<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <!--

       PKG2 - ProzessKettenGenerator second implementation 
       Copyright (C) 1999-2006 by Alexander Tenbusch
       
       This program is free software; you can redistribute it and/or modify
       it under the terms of the GNU General Public License as published by
       the Free Software Foundation; either version 2 of the License, or
       (at your option) any later version.

       This program is distributed in the hope that it will be useful,
       but WITHOUT ANY WARRANTY; without even the implied warranty of
       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
       GNU General Public License for more details.

       You should have received a copy of the GNU General Public License 
       along with this program; if not, write to the Free Software
       Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
       
       -->

  <xsl:output method="text"/>

  <xsl:variable name="newline">
    <xsl:text>
</xsl:text>
  </xsl:variable>

  <xsl:template match="/">
    <xsl:apply-templates/>
  </xsl:template>
      
  <xsl:template match="pie">
    <xsl:value-of select="concat('digraph AAA {',$newline)"/>
<xsl:text>node [shape=plaintext, fontsize=16];</xsl:text>
       <xsl:value-of select="$newline"/>
        <xsl:apply-templates select="dir"/>
    <xsl:value-of select="concat($newline,'}',$newline)"/>
  </xsl:template>

  <xsl:template match="dir">
    <xsl:variable name="id" select="generate-id(.)"/>
    <xsl:variable name="size" select="format-number(sum(descendant::file/attribute::size) div (1024 * 1024),'###,###0.00')"/>

<xsl:if test="$size &gt; 0.1">
    <xsl:value-of select="concat($id,' [label = &quot;',$size,'MB\n',@name,'&quot;, style=solid];')"/>
    <xsl:value-of select="$newline"/>

<xsl:if test="parent::dir">
       <xsl:value-of select="concat($id,' -&gt; ',generate-id(parent::dir),';')"/>
       <xsl:value-of select="$newline"/>
</xsl:if>
       <xsl:apply-templates select="dir"/>
</xsl:if>

  </xsl:template>

  <xsl:template match="*"/>

</xsl:stylesheet>
