<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:cxp="http://www.tenbusch.info/cxproc"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="../xsl/html/PieHtml.xsl"/>
  <xsl:variable name="file_css" select="'CgiDir.css'"/>
  <!-- file:///H:/opt/cxproc/contrib/pie/html/ -->
  <!--  -->
  <xsl:variable name="flag_header" select="true()"/>
  <!--  -->
  <xsl:variable name="str_prefix" select="''"/>
  <!--  -->
  <xsl:variable name="length_link" select="-1"/>
  <xsl:output method="html" encoding="UTF-8" omit-xml-declaration="no" doctype-public="-//W3C//DTD HTML 4.01//EN" doctype-system="file:///tmp/dummy.dtd"/>
  <xsl:template match="/pie">
    <xsl:choose>
      <xsl:when test="$flag_header">
        <xsl:element name="html">
          <xsl:call-template name="HEADER"/>
          <xsl:element name="body">
            <xsl:element name="table">
              <xsl:element name="tbody">
                <!--  -->
                <xsl:call-template name="DIRNAVI">
                  <xsl:with-param name="dir_name">
                    <xsl:value-of select="dir[1]/@name"/>
                  </xsl:with-param>
                </xsl:call-template>
                <!--  -->
                <xsl:element name="tr">
                </xsl:element>
                <!--  -->
                <xsl:call-template name="DIRPATH">
                  <xsl:with-param name="dir_name">
                    <xsl:value-of select="dir[1]/@name"/>
                  </xsl:with-param>
                </xsl:call-template>
              </xsl:element>
            </xsl:element>
            <!--  -->
            <xsl:element name="hr"/>
            <!--  -->
            <xsl:apply-templates select="dir/*[name()='dir' or name()='file']">
              <xsl:sort order="ascending" data-type="text" case-order="lower-first" select="name()"/>
              <xsl:sort order="ascending" data-type="text" case-order="lower-first" select="@name"/>
            </xsl:apply-templates>
            <xsl:if test="not(contains(dir[1]/@name,'/'))">
              <xsl:element name="hr"/>
              <!--
              <xsl:element name="center">
                <xsl:element name="img">
                  <xsl:attribute name="src">/cxproc/icons/Libxml2-Logo-90x34.gif</xsl:attribute>
                </xsl:element>
                <xsl:element name="img">
                  <xsl:attribute name="src">/cxproc/icons/Libxslt-Logo-90x34.gif</xsl:attribute>
                </xsl:element>
              </xsl:element>
            -->
              <xsl:element name="p">
                <xsl:attribute name="align">right</xsl:attribute>
                <xsl:element name="a">
                  <xsl:attribute name="target">mainframe</xsl:attribute>
                  <xsl:attribute name="href">
                    <xsl:value-of select="concat('?','cxp=Powered')"/>
                  </xsl:attribute>
                  <xsl:text>Powered by ...</xsl:text>
                </xsl:element>
              </xsl:element>
            </xsl:if>
          </xsl:element>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <xsl:element name="body">
          <xsl:apply-templates/>
        </xsl:element>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="dir">
    <!--  -->
    <xsl:choose>
      <xsl:when test="@name = 'tmp'"/>
      <xsl:when test="starts-with(@name,'_')"/>
      <xsl:when test="starts-with(@name,'.') and not(@name = '.svn')"/>
      <xsl:when test="not(@name = '') and not(@err)">
        <xsl:variable name="dir_name">
          <xsl:for-each select="ancestor::dir">
            <xsl:value-of select="@name"/>
            <xsl:text>/</xsl:text>
          </xsl:for-each>
          <xsl:value-of select="@name"/>
        </xsl:variable>
        <xsl:element name="p">
          <xsl:element name="a">
            <!-- the sub directories are links -->
            <xsl:attribute name="class">subdir</xsl:attribute>
            <xsl:attribute name="href">
              <xsl:value-of select="concat('?dir=',$dir_name,'&amp;','cxp=Dir')"/>
            </xsl:attribute>
            <xsl:value-of select="@name"/>
            <xsl:text>/</xsl:text>
          </xsl:element>
        </xsl:element>
        <xsl:apply-templates select="dir|file">
          <xsl:sort order="ascending" data-type="text" case-order="lower-first" select="name()"/>
          <xsl:sort order="ascending" data-type="text" case-order="lower-first" select="id3/track"/>
          <xsl:sort order="ascending" data-type="text" case-order="lower-first" select="@name"/>
        </xsl:apply-templates>
      </xsl:when>
      <xsl:otherwise>
          </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="file">
    <!--  -->
    <xsl:choose>
      <xsl:when test="@read = 'no'"/>
      <xsl:when test="@name = ''"/>
      <xsl:when test="@name = 'albumfiles.txt'"/>
      <xsl:when test="@name = 'tmp'"/>
      <xsl:when test="contains(@type,'error')"/>
      <xsl:when test="substring-before(@name,'~')"/>
      <xsl:when test="@ext='css' or @ext='sh' or @ext='pl' or @ext='xsl' or @ext='el' or @ext='bat' or @ext='lnk' or @ext='zip'"/>
      <xsl:when test="starts-with(@name,'IMG_')"/>
      <xsl:when test="starts-with(@name,'_')"/>
      <xsl:when test="contains(@name,'.pie_')"/>
      <xsl:when test="starts-with(@name,'.') and not(@name = '.svn')"/>
      <xsl:when test="contains(@type,'audio')">
        <!-- use id3 tags -->
        <xsl:variable name="file_path">
          <xsl:for-each select="ancestor::dir">
          <xsl:if test="position() &gt; 1">
            <xsl:text>/</xsl:text>
          </xsl:if>
            <xsl:value-of select="@name"/>
          </xsl:for-each>
        </xsl:variable>
        <xsl:element name="p">
          <xsl:element name="a">
            <xsl:attribute name="class">cxp</xsl:attribute>
            <xsl:attribute name="target">
              <xsl:text>mainframe</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="title">
              <xsl:value-of select="concat(id3/artist,' :: ',id3/album,' :: ',id3/track,' :: ',@name)"/>
            </xsl:attribute>
            <xsl:attribute name="href">

    <xsl:choose>
      <xsl:when test="id3/track and number(id3/track) &gt; 1">
              <xsl:value-of select="concat('?dir=',$file_path,'&amp;','cxp=PlayTrack','&amp;','t=',id3/track)"/>
      </xsl:when>
      <xsl:otherwise>
              <xsl:value-of select="concat('?dir=',$file_path,'&amp;','cxp=PlayTrack','&amp;','t=',position())"/>
      </xsl:otherwise>
    </xsl:choose>
            </xsl:attribute>

    <xsl:choose>
      <xsl:when test="id3/title">
            <xsl:value-of select="id3/title"/>
      </xsl:when>
      <xsl:otherwise>
            <xsl:value-of select="substring-before(@name,concat('.',@ext))"/>
      </xsl:otherwise>
    </xsl:choose>

          </xsl:element>
        </xsl:element>
      </xsl:when>
      <xsl:when test="@ext='txt' or @ext='mm' or @ext='pie' or @ext='cxp' or @ext='csv' or (contains(@type,'image') and image) or contains(@ext,'cal')">
        <!-- dynamic content using cxproc -->
        <xsl:variable name="file_path">
          <xsl:for-each select="ancestor::dir">
            <xsl:value-of select="@name"/>
            <xsl:text>/</xsl:text>
          </xsl:for-each>
          <xsl:value-of select="@name"/>
        </xsl:variable>
        <xsl:choose>
          <xsl:when test="@ext='cxp' and not(cxp:make/cxp:description)">
            <!-- ignore cxp files without description -->
          </xsl:when>
          <xsl:when test="@ext='pie' and pie[@class='shortcuts']">
            <!-- list of links in shortcut file -->
            <xsl:for-each select="pie//link">
              <xsl:element name="p">
                <xsl:if test="preceding-sibling::img[@src]">
                  <xsl:element name="img">
                    <xsl:attribute name="src">
                      <xsl:value-of select="concat('/cxproc/icons/',preceding-sibling::img[1]/@src)"/>
                    </xsl:attribute>
                  </xsl:element>
                  <xsl:text> </xsl:text>
                </xsl:if>
                <xsl:element name="a">
                  <xsl:attribute name="target">
                    <xsl:choose>
                      <xsl:when test="@target">
                        <xsl:value-of select="@target"/>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:text>mainframe</xsl:text>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:attribute>
                  <xsl:copy-of select="@href"/>
                  <xsl:value-of select="."/>
                </xsl:element>
              </xsl:element>
            </xsl:for-each>
          </xsl:when>
          <xsl:otherwise>
            <!-- single link to named file -->
            <xsl:element name="p">
              <xsl:element name="a">
                <xsl:attribute name="class">cxp</xsl:attribute>
                <xsl:attribute name="target">
                  <xsl:text>mainframe</xsl:text>
                </xsl:attribute>
                <xsl:attribute name="title">
                  <xsl:choose>
                    <xsl:when test="contains(@type,'image')">
                      <!-- all images -->
                      <xsl:value-of select="concat(@name,' (',image/size/@col,'x',image/size/@row,'): ',image/comment/@value)"/>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:value-of select="@name"/>
                    </xsl:otherwise>
                  </xsl:choose>
                </xsl:attribute>
                <xsl:attribute name="href">
                  <xsl:choose>
                    <xsl:when test="contains(@type,'image') and image">
                      <!-- all images -->
                      <xsl:value-of select="concat('?file=',$file_path,'&amp;','cxp=image')"/>
                    </xsl:when>
                    <xsl:when test="contains(@ext,'cal')">
                      <!-- edit form for this type of files -->
                      <xsl:value-of select="concat('?file=',$file_path,'&amp;','cxp=article')"/>
                    </xsl:when>
                    <xsl:when test="@ext='csv'">
                      <!--  -->
                      <xsl:value-of select="concat('?file=',$file_path,'&amp;','cxp=article')"/>
                      <!-- <xsl:value-of select="concat('?file=',$file_path,'&amp;','cxp=csv')"/> -->
                    </xsl:when>
                    <xsl:when test="@ext='txt' or @ext='mm' or @ext='pie'">
                      <!--  -->
                      <xsl:value-of select="concat('?file=',$file_path,'&amp;','cxp=article')"/>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:value-of select="concat('?file=',$file_path,'&amp;','cxp=',@ext)"/>
                      <xsl:if test="@ext='cxp' and cxp:make/cxp:description/@anchor">
                        <xsl:value-of select="concat('#',cxp:make/cxp:description/@anchor)"/>
                      </xsl:if>
                    </xsl:otherwise>
                  </xsl:choose>
                  <xsl:if test="@write='no'">
                    <xsl:value-of select="concat('&amp;','write=no')"/>
                  </xsl:if>
                </xsl:attribute>
                <xsl:choose>
                  <xsl:when test="contains(@type,'image')">
                    <!-- all images -->
                    <xsl:value-of select="substring-before(@name,'.')"/>
                  </xsl:when>
                  <xsl:when test="@ext='mm'">
                    <!--  or @ext='html' -->
                    <xsl:choose>
                      <xsl:when test="map/node[1]/@TEXT">
                        <xsl:value-of select="map/node[1]/@TEXT"/>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:value-of select="substring-before(@name,concat('.',@ext))"/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:when test="@ext='cxp'">
                    <!--  -->
                    <xsl:choose>
                      <xsl:when test="cxp:make/cxp:description">
                        <xsl:choose>
                          <xsl:when test="cxp:make/cxp:description/@icon">
                            <xsl:element name="img">
                              <xsl:attribute name="src">
                                <xsl:value-of select="concat('/cxproc/icons/',cxp:make/cxp:description/@icon)"/>
                              </xsl:attribute>
                              <xsl:attribute name="title">
                                <xsl:value-of select="cxp:make/cxp:description"/>
                              </xsl:attribute>
                            </xsl:element>
                            <xsl:text> </xsl:text>
                            <xsl:value-of select="cxp:make/cxp:description"/>
                          </xsl:when>
                          <xsl:otherwise>
                            <xsl:value-of select="cxp:make/cxp:description"/>
                          </xsl:otherwise>
                        </xsl:choose>
                      </xsl:when>
                      <xsl:when test="make/description">
                        <xsl:value-of select="make/description"/>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:value-of select="substring-before(@name,concat('.',@ext))"/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:when test="@ext='pie' or @ext='txt'">
                    <!--  or @ext='html' -->
                    <xsl:choose>
                      <xsl:when test="pie/section[1]/h">
                        <xsl:value-of select="pie/section[1]/h"/>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:value-of select="substring-before(@name,concat('.',@ext))"/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="substring-before(@name,concat('.',@ext))"/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:element>
            </xsl:element>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="true()">
        <!--  default: direct link  -->
        <xsl:variable name="file_path">
          <xsl:text>/</xsl:text>
          <xsl:for-each select="ancestor::dir">
            <xsl:value-of select="@name"/>
            <xsl:text>/</xsl:text>
          </xsl:for-each>
          <xsl:value-of select="@name"/>
        </xsl:variable>
        <xsl:element name="p">
          <xsl:element name="a">
            <xsl:attribute name="class">file</xsl:attribute>
            <xsl:attribute name="target">
              <xsl:text>mainframe</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="href">
              <xsl:value-of select="$file_path"/>
            </xsl:attribute>
            <xsl:copy-of select="@type"/>
            <xsl:value-of select="@name"/>
          </xsl:element>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <!-- ignore anything else -->
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="DIRUP">
    <xsl:param name="dir_name"/>
    <xsl:param name="dir_up"/>
    <xsl:choose>
      <xsl:when test="contains($dir_name,'/')">
        <xsl:call-template name="DIRUP">
          <xsl:with-param name="dir_name">
            <xsl:value-of select="substring-after($dir_name,'/')"/>
          </xsl:with-param>
          <xsl:with-param name="dir_up">
            <xsl:choose>
              <xsl:when test="string-length($dir_up)">
                <xsl:value-of select="concat($dir_up,'/',substring-before($dir_name,'/'))"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="substring-before($dir_name,'/')"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:with-param>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="$dir_up=''">
        <!-- dir_name is the toplevel dir -->
        <xsl:value-of select="$dir_name"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$dir_up"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="DIRTOP">
    <xsl:param name="dir_name"/>
    <xsl:choose>
      <xsl:when test="contains($dir_name,'/')">
        <xsl:call-template name="DIRTOP">
          <xsl:with-param name="dir_name">
            <xsl:value-of select="substring-before($dir_name,'/')"/>
          </xsl:with-param>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$dir_name"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template name="DIRNAVI">
    <xsl:param name="dir_name"/>
    <xsl:variable name="str_top">
      <xsl:call-template name="DIRTOP">
        <xsl:with-param name="dir_name">
          <xsl:value-of select="$dir_name"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="str_up">
      <xsl:call-template name="DIRUP">
        <xsl:with-param name="dir_name">
          <xsl:value-of select="$dir_name"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:variable>
    <xsl:element name="tr">
      <xsl:element name="td">
        <xsl:element name="form">
          <!-- hidden form input -->
          <xsl:element name="input">
            <xsl:attribute name="type">hidden</xsl:attribute>
            <xsl:attribute name="name">cxp</xsl:attribute>
            <xsl:attribute name="value">Dir</xsl:attribute>
          </xsl:element>
          <xsl:element name="input">
            <xsl:attribute name="type">hidden</xsl:attribute>
            <xsl:attribute name="name">dir</xsl:attribute>
            <xsl:attribute name="value">
              <xsl:value-of select="$str_top"/>
            </xsl:attribute>
          </xsl:element>
          <!-- form buttons -->
          <xsl:element name="input">
            <xsl:attribute name="type">image</xsl:attribute>
            <xsl:attribute name="src">/cxproc/icons/go-top.png</xsl:attribute>
            <xsl:attribute name="alt">Show Home Directory</xsl:attribute>
            <xsl:attribute name="title">Show Top Directory</xsl:attribute>
          </xsl:element>
        </xsl:element>
      </xsl:element>
      <xsl:element name="td">
        <xsl:if test="not($str_up=$dir_name)">
          <xsl:element name="form">
            <!-- hidden form input -->
            <xsl:element name="input">
              <xsl:attribute name="type">hidden</xsl:attribute>
              <xsl:attribute name="name">cxp</xsl:attribute>
              <xsl:attribute name="value">Dir</xsl:attribute>
            </xsl:element>
            <xsl:element name="input">
              <xsl:attribute name="type">hidden</xsl:attribute>
              <xsl:attribute name="name">dir</xsl:attribute>
              <xsl:attribute name="value">
                <xsl:value-of select="$str_up"/>
              </xsl:attribute>
            </xsl:element>
            <!-- form buttons -->
            <xsl:element name="input">
              <xsl:attribute name="type">image</xsl:attribute>
              <xsl:attribute name="src">/cxproc/icons/go-up.png</xsl:attribute>
              <xsl:attribute name="alt">Show Parent Directory</xsl:attribute>
              <xsl:attribute name="title">Show Parent Directory</xsl:attribute>
            </xsl:element>
          </xsl:element>
        </xsl:if>
      </xsl:element>
    </xsl:element>
  </xsl:template>
  <xsl:template name="DIRPATH">
    <xsl:param name="dir_name"/>
    <xsl:element name="tr">
      <xsl:element name="td">
        <xsl:attribute name="colspan">4</xsl:attribute>
        <xsl:attribute name="align">left</xsl:attribute>
        <xsl:attribute name="valign">bottom</xsl:attribute>
        <xsl:element name="a">
          <!-- the upper directories are not links -->
          <xsl:attribute name="class">path</xsl:attribute>
          <xsl:value-of select="$dir_name"/>
        </xsl:element>
      </xsl:element>
    </xsl:element>
    <xsl:element name="tr">
      <xsl:element name="td">
        <!--  -->
        <xsl:element name="a">
          <xsl:attribute name="target">_blank</xsl:attribute>
          <xsl:attribute name="href">
            <xsl:value-of select="concat('file://',$str_prefix,$dir_name)"/>
          </xsl:attribute>
          <xsl:attribute name="title">Open Local Directory</xsl:attribute>
          <xsl:element name="img">
            <xsl:attribute name="alt">Open Local Directory</xsl:attribute>
            <xsl:attribute name="src">/cxproc/icons/folder-open.png</xsl:attribute>
          </xsl:element>
        </xsl:element>
      </xsl:element>
      <xsl:element name="td">
        <xsl:choose>
          <xsl:when test="count(descendant::file[starts-with(@type,'image/')]) &gt; 1">
            <!-- there are more than one Image, show the gallery button -->
            <xsl:element name="form">
              <xsl:attribute name="target">
                <xsl:text>_blank</xsl:text>
              </xsl:attribute>
              <!-- hidden form input -->
              <xsl:element name="input">
                <xsl:attribute name="type">hidden</xsl:attribute>
                <xsl:attribute name="name">cxp</xsl:attribute>
                <xsl:attribute name="value">gallery</xsl:attribute>
              </xsl:element>
              <xsl:element name="input">
                <xsl:attribute name="type">hidden</xsl:attribute>
                <xsl:attribute name="name">dir</xsl:attribute>
                <xsl:attribute name="value">
                  <xsl:value-of select="$dir_name"/>
                </xsl:attribute>
              </xsl:element>
              <!-- form buttons -->
              <xsl:element name="input">
                <xsl:attribute name="type">image</xsl:attribute>
                <xsl:attribute name="src">/cxproc/icons/image-x-generic.png</xsl:attribute>
                <xsl:attribute name="alt">Show Gallery Directory</xsl:attribute>
                <xsl:attribute name="title">Show Gallery Directory</xsl:attribute>
              </xsl:element>
            </xsl:element>
          </xsl:when>
          <xsl:otherwise>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:element>
      <xsl:element name="td">
        <xsl:choose>
          <xsl:when test="count(descendant::file[starts-with(@type,'audio/')]) &gt; 1">
            <!-- there are more than one Audio file, show the playlist button -->
            <xsl:element name="form">
              <xsl:attribute name="target">
                <xsl:text>_blank</xsl:text>
              </xsl:attribute>
              <!-- hidden form input -->
              <xsl:element name="input">
                <xsl:attribute name="type">hidden</xsl:attribute>
                <xsl:attribute name="name">cxp</xsl:attribute>
                <xsl:attribute name="value">playlist</xsl:attribute>
              </xsl:element>
              <xsl:element name="input">
                <xsl:attribute name="type">hidden</xsl:attribute>
                <xsl:attribute name="name">dir</xsl:attribute>
                <xsl:attribute name="value">
                  <xsl:value-of select="$dir_name"/>
                </xsl:attribute>
              </xsl:element>
              <!-- form buttons -->
              <xsl:element name="input">
                <xsl:attribute name="type">image</xsl:attribute>
                <xsl:attribute name="src">/cxproc/icons/audio-x-generic.png</xsl:attribute>
                <xsl:attribute name="alt">Play Audio Directory</xsl:attribute>
                <xsl:attribute name="title">Play Audio Directory</xsl:attribute>
              </xsl:element>
            </xsl:element>
          </xsl:when>
          <xsl:otherwise>
              </xsl:otherwise>
        </xsl:choose>
      </xsl:element>
      <xsl:element name="td">
        <xsl:choose>
          <xsl:when test="count(descendant::file[starts-with(@type,'text/')]) &gt; 1">
            <!-- there are more than one Audio file, show the playlist button -->
            <xsl:element name="form">
              <xsl:attribute name="target">
                <xsl:text>mainframe</xsl:text>
              </xsl:attribute>
              <!-- hidden form input -->
              <xsl:element name="input">
                <xsl:attribute name="type">hidden</xsl:attribute>
                <xsl:attribute name="name">cxp</xsl:attribute>
                <xsl:attribute name="value">MergePie</xsl:attribute>
              </xsl:element>
              <xsl:element name="input">
                <xsl:attribute name="type">hidden</xsl:attribute>
                <xsl:attribute name="name">dir</xsl:attribute>
                <xsl:attribute name="value">
                  <xsl:value-of select="$dir_name"/>
                </xsl:attribute>
              </xsl:element>
              <!-- form buttons -->
              <xsl:element name="input">
                <xsl:attribute name="type">image</xsl:attribute>
                <xsl:attribute name="src">/cxproc/icons/x-office-document.png</xsl:attribute>
                <xsl:attribute name="alt">Show all Text in Directory</xsl:attribute>
                <xsl:attribute name="title">Show all Text in Directory</xsl:attribute>
              </xsl:element>
            </xsl:element>
          </xsl:when>
          <xsl:otherwise>
              </xsl:otherwise>
        </xsl:choose>
      </xsl:element>
      <xsl:element name="td">
        <xsl:if test="dir/dir">
          <xsl:element name="form">
            <xsl:attribute name="target">mainframe</xsl:attribute>
            <!-- hidden form input -->
            <xsl:element name="input">
              <xsl:attribute name="type">hidden</xsl:attribute>
              <xsl:attribute name="name">cxp</xsl:attribute>
              <xsl:attribute name="value">DirSitemap</xsl:attribute>
            </xsl:element>
            <xsl:element name="input">
              <xsl:attribute name="type">hidden</xsl:attribute>
              <xsl:attribute name="name">dir</xsl:attribute>
              <xsl:attribute name="value">
                <xsl:value-of select="$dir_name"/>
              </xsl:attribute>
            </xsl:element>
            <!-- form buttons -->
            <xsl:element name="input">
              <xsl:attribute name="type">image</xsl:attribute>
              <xsl:attribute name="src">/cxproc/icons/applications-internet.png</xsl:attribute>
              <xsl:attribute name="alt">Sitemap for Content</xsl:attribute>
              <xsl:attribute name="title">Sitemap for Content</xsl:attribute>
            </xsl:element>
          </xsl:element>
        </xsl:if>
      </xsl:element>
      <xsl:element name="td">
        <xsl:element name="form">
          <xsl:attribute name="target">mainframe</xsl:attribute>
          <!-- hidden form input -->
          <xsl:element name="input">
            <xsl:attribute name="type">hidden</xsl:attribute>
            <xsl:attribute name="name">cxp</xsl:attribute>
            <xsl:attribute name="value">DirSearch</xsl:attribute>
          </xsl:element>
          <xsl:element name="input">
            <xsl:attribute name="type">hidden</xsl:attribute>
            <xsl:attribute name="name">dir</xsl:attribute>
            <xsl:attribute name="value">
              <xsl:value-of select="$dir_name"/>
            </xsl:attribute>
          </xsl:element>
          <!-- form buttons -->
          <xsl:element name="input">
            <xsl:attribute name="type">image</xsl:attribute>
            <xsl:attribute name="src">/cxproc/icons/edit-find.png</xsl:attribute>
            <xsl:attribute name="alt">Search for Content</xsl:attribute>
            <xsl:attribute name="title">Search for Content</xsl:attribute>
          </xsl:element>
        </xsl:element>
      </xsl:element>
    </xsl:element>
  </xsl:template>
  <xsl:template match="*[@error]">
    <!-- ignore all error entries -->
  </xsl:template>
</xsl:stylesheet>
