<?xml version="1.0"?>
<xsl:stylesheet xmlns:cxp="http://www.tenbusch.info/cxproc" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:import href="../xsl/html/PieHtml.xsl"/>
  <xsl:variable name="file_css" select="'CgiDir.css'"/>
  <!-- file:///H:/opt/cxproc/contrib/pie/html/ -->
  <!--  -->
  <xsl:variable name="flag_header" select="true()"/>
  <xsl:variable name="str_tab">
     <xsl:text>   </xsl:text>
  </xsl:variable>
  <!--  -->
  <xsl:variable name="length_link" select="-1"/>
  <xsl:output method="html" omit-xml-declaration="no" doctype-public="-//W3C//DTD HTML 4.01//EN" doctype-system="file:///tmp/dummy.dtd"/>
  <xsl:template match="/pie">
    <xsl:choose>
      <xsl:when test="$flag_header">
        <xsl:element name="html">
          <xsl:call-template name="HEADER"/>
          <xsl:element name="body">
            <!--  -->
          <xsl:element name="pre">
            <xsl:apply-templates select="dir/*[name()='dir' or name()='file']">
              <xsl:sort order="ascending" data-type="text" case-order="lower-first" select="name()"/>
              <xsl:sort order="ascending" data-type="text" case-order="lower-first" select="@name"/>
            </xsl:apply-templates>
          </xsl:element>
          </xsl:element>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <xsl:element name="body">
          <xsl:apply-templates/>
        </xsl:element>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="dir">
    <!--  -->
    <xsl:choose>
      <xsl:when test="@name = 'tmp'"/>
      <xsl:when test="starts-with(@name,'_')"/>
      <xsl:when test="starts-with(@name,'.') and not(@name = '.svn')"/>
      <xsl:when test="not(@name = '') and not(@err)">
        <xsl:variable name="dir_name">
          <xsl:for-each select="ancestor::dir">
            <xsl:value-of select="@name"/>
            <xsl:text>/</xsl:text>
          </xsl:for-each>
          <xsl:value-of select="@name"/>
        </xsl:variable>
        <xsl:element name="p">
          <xsl:for-each select="ancestor::dir">
            <xsl:value-of select="$str_tab"/>
          </xsl:for-each>
          <xsl:element name="a">
            <!-- the sub directories are links -->
            <xsl:attribute name="class">subdir</xsl:attribute>
            <xsl:attribute name="href">
              <xsl:value-of select="concat('?dir=',$dir_name,'&amp;','cxp=Dir')"/>
            </xsl:attribute>
            <xsl:value-of select="@name"/>
            <xsl:text>/</xsl:text>
          </xsl:element>
        </xsl:element>
        <xsl:apply-templates select="dir|file">
          <xsl:sort order="ascending" data-type="text" case-order="lower-first" select="name()"/>
          <xsl:sort order="ascending" data-type="text" case-order="lower-first" select="@name"/>
        </xsl:apply-templates>
      </xsl:when>
      <xsl:otherwise>
          </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="file">
    <!--  -->
    <xsl:choose>
      <xsl:when test="@name = ''"/>
      <xsl:when test="false() and @name = 'tmp'"/>
      <xsl:when test="substring-before(@name,'~')"/>
      <xsl:when test="@ext='css' or @ext='sh' or @ext='pl' or @ext='xsl'"/>
      <xsl:when test="starts-with(@name,'IMG_')"/>
      <xsl:when test="starts-with(@name,'_')"/>
      <xsl:when test="starts-with(@name,'.') and not(@name = '.svn')"/>
      <xsl:when test="@ext='txt' or @ext='mm' or @ext='pie' or @ext='cxp' or contains(@type,'image') or contains(@ext,'cal')">
        <!-- dynamic content using cxproc -->
        <xsl:variable name="file_path">
          <xsl:for-each select="ancestor::dir">
            <xsl:value-of select="@name"/>
            <xsl:text>/</xsl:text>
          </xsl:for-each>
          <xsl:value-of select="@name"/>
        </xsl:variable>
        <xsl:element name="p">
          <xsl:for-each select="ancestor::dir">
            <xsl:value-of select="$str_tab"/>
          </xsl:for-each>
          <xsl:element name="a">
            <xsl:attribute name="class">cxp</xsl:attribute>
            <xsl:attribute name="target">
              <xsl:text>mainframe</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="title">
              <xsl:value-of select="@name"/>
            </xsl:attribute>
            <xsl:attribute name="href">
              <xsl:choose>
                <xsl:when test="contains(@ext,'cal')">
                  <!-- edit form for this type of files -->
                  <xsl:value-of select="concat('?file=',$file_path,'&amp;','cxp=EditTxt')"/>
                </xsl:when>
                <xsl:when test="@ext='txt' or @ext='mm' or @ext='pie'">
                  <!--  -->
                  <xsl:value-of select="concat('?file=',$file_path,'&amp;','cxp=article')"/>
                    </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="concat('?file=',$file_path,'&amp;','cxp=',@ext)"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:attribute>
            <xsl:choose>
              <xsl:when test="@ext='mm'">
                <!--  or @ext='html' -->
                <xsl:choose>
                  <xsl:when test="map/node[1]/@TEXT">
                    <xsl:value-of select="map/node[1]/@TEXT"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="substring-before(@name,concat('.',@ext))"/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:when test="@ext='cxp'">
                <!--  -->
                <xsl:choose>
                  <xsl:when test="cxp:make/cxp:description">
                    <xsl:value-of select="cxp:make/cxp:description"/>
                  </xsl:when>
                  <xsl:when test="make/description">
                    <xsl:value-of select="make/description"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="substring-before(@name,concat('.',@ext))"/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:when test="@ext='pie' or @ext='txt'">
                <!--  or @ext='html' -->
                <xsl:choose>
                  <xsl:when test="pie/section[1]/h">
                    <xsl:value-of select="pie/section[1]/h"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="substring-before(@name,concat('.',@ext))"/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="substring-before(@name,concat('.',@ext))"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:element>
        </xsl:element>
      </xsl:when>
      <xsl:when test="true()">
        <!--  default: direct link  -->
        <xsl:variable name="file_path">
          <xsl:text>/</xsl:text>
          <xsl:for-each select="ancestor::dir">
            <xsl:value-of select="@name"/>
            <xsl:text>/</xsl:text>
          </xsl:for-each>
          <xsl:value-of select="@name"/>
        </xsl:variable>
        <xsl:element name="p">
          <xsl:for-each select="ancestor::dir">
            <xsl:value-of select="$str_tab"/>
          </xsl:for-each>
          <xsl:element name="a">
            <xsl:attribute name="class">file</xsl:attribute>
            <xsl:attribute name="target">
              <xsl:text>mainframe</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="href">
              <xsl:value-of select="$file_path"/>
            </xsl:attribute>
            <xsl:copy-of select="@type"/>
            <xsl:value-of select="@name"/>
          </xsl:element>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <!-- ignore anything else -->
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="*[@error]">
    <!-- ignore all error entries -->
  </xsl:template>
</xsl:stylesheet>
