<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:cxp="http://www.tenbusch.info/cxproc" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:import href="../xsl/html/PieHtml.xsl"/>
  <!-- -->
  <xsl:variable name="file_css" select="'../../html/pie.css'"/>
  <!-- name of plain input file -->
  <xsl:variable name="file_plain" select="''"/>
  <xsl:variable name="file_ref" select="'../../tmp/TodoContactTable.html'"/>
  <!-- cancel tree -->
  <xsl:variable name="flag_tree" select="true()"/>
  <!--  -->
  <xsl:variable name="flag_header" select="true()"/>
  <!--  -->
  <xsl:variable name="flag_fig" select="true()"/>
  <!--  -->
  <xsl:variable name="str_write"  select="''"/>
  <!--  -->
  <xsl:variable name="length_link" select="-1"/>
  <!--  -->
  <xsl:variable name="flag_form" select="false()"/>
  <!--  -->
  <xsl:variable name="level_hidden" select="0"/>
  <!-- flag for captions of slides -->
  <xsl:variable name="flag_slidecap" select="true()"/>


  <xsl:variable name="str_element" select="''"/>
  <xsl:variable name="str_relation" select="''"/>
  <xsl:variable name="str_date" select="''"/>

  <xsl:output method="html" encoding="UTF-8" doctype-public="-//W3C//DTD HTML 4.01//EN" doctype-system="file:///tmp/dummy.dtd"/>
  <xsl:template match="/map">
    <xsl:element name="html">
      <xsl:if test="not($file_css='')">
        <xsl:element name="link">
          <xsl:attribute name="rel">
            <xsl:text>stylesheet</xsl:text>
          </xsl:attribute>
          <xsl:attribute name="media">
            <xsl:text>screen, print</xsl:text>
          </xsl:attribute>
          <xsl:attribute name="type">
            <xsl:text>text/css</xsl:text>
          </xsl:attribute>
          <xsl:attribute name="href">
            <xsl:value-of select="$file_css"/>
          </xsl:attribute>
        </xsl:element>
      </xsl:if>
      <!-- calendar stylesheet -->
      <link rel="stylesheet" type="text/css" media="all" href="/jscalendar/calendar-system.css"/>
      <xsl:element name="meta">
        <xsl:attribute name="name">
          <xsl:text>generator</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="content">
          <xsl:text>cxproc PIE/XML</xsl:text>
        </xsl:attribute>
      </xsl:element>
      <xsl:element name="meta">
        <xsl:attribute name="http-equiv">
          <xsl:text>cache-control</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="content">
          <xsl:text>no-cache</xsl:text>
        </xsl:attribute>
      </xsl:element>
      <xsl:element name="meta">
        <xsl:attribute name="http-equiv">
          <xsl:text>pragma</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="content">
          <xsl:text>no-cache</xsl:text>
        </xsl:attribute>
      </xsl:element>
      <xsl:element name="script">
        <xsl:attribute name="src">
          <xsl:text>/cxproc/js/CgiEditPie.js</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="type">
          <xsl:text>text/javascript</xsl:text>
        </xsl:attribute>
      </xsl:element>
  <!-- main calendar program -->
  <script type="text/javascript" src="/jscalendar/calendar.js"></script>

  <!-- language for the calendar -->
  <script type="text/javascript" src="/jscalendar/lang/calendar-en.js"></script>

  <!-- the following script defines the Calendar.setup helper function, which makes
       adding a calendar a matter of 1 or 2 lines of code. -->
  <script type="text/javascript" src="/jscalendar/calendar-setup.js"></script>

  <xsl:if test="/map/node/@TEXT">
    <xsl:element name="title">
      <xsl:value-of select="concat('Editor ',/map/node/@TEXT)"/>
    </xsl:element>
  </xsl:if>
  <xsl:element name="body">
    <xsl:if test="$flag_form">
      <xsl:call-template name="PIEFORM"/>
    </xsl:if>
    <form id="input" method="post" accept-charset="UTF-8">
      <xsl:element name="input">
        <xsl:attribute name="type">hidden</xsl:attribute>
        <xsl:attribute name="name">cxp</xsl:attribute>
        <xsl:attribute name="value">MmInsertNode</xsl:attribute>
      </xsl:element>
      <xsl:element name="input">
        <xsl:attribute name="type">hidden</xsl:attribute>
        <xsl:attribute name="name">file</xsl:attribute>
        <xsl:attribute name="value">
          <xsl:value-of select="$file_plain"/>
        </xsl:attribute>
      </xsl:element>
      <!-- selections --> 
      <table class="unlined" cellpadding="2">
        <tr>
          <td colspan="2">Insert a new 
          <select class="additor" id="element" name="element" onchange="FormSwitch(this.form)">
            <xsl:element name="option">
              <xsl:text>node</xsl:text>
            </xsl:element>
            <!-- 
            <xsl:element name="option">
              <xsl:text>section</xsl:text>
            </xsl:element>
            <xsl:element name="option">
              <xsl:if test="$str_element='task'">
                <xsl:attribute name="selected"></xsl:attribute>
              </xsl:if>
              <xsl:text>task</xsl:text>
            </xsl:element>
            <xsl:element name="option">
              <xsl:if test="$str_element='p'">
                <xsl:attribute name="selected"></xsl:attribute>
              </xsl:if>
              <xsl:text>p</xsl:text>
            </xsl:element>
            <xsl:element name="option">
              <xsl:if test="$str_element='pre'">
                <xsl:attribute name="selected"></xsl:attribute>
              </xsl:if>
              <xsl:text>pre</xsl:text>
            </xsl:element>
            <xsl:element name="option">
              <xsl:if test="$str_element='target'">
                <xsl:attribute name="selected"></xsl:attribute>
              </xsl:if>
              <xsl:text>target</xsl:text>
            </xsl:element>
            --> 
          </select>
          as 
          <select class="additor" name="relation">
            <xsl:element name="option">
              <xsl:text>child</xsl:text>
            </xsl:element>
            <xsl:element name="option">
              <xsl:if test="$str_relation='sibling'">
                <xsl:attribute name="selected"></xsl:attribute>
              </xsl:if>
              <xsl:text>sibling</xsl:text>
            </xsl:element>
          </select>
          with
          </td>
        </tr>
        <!-- inputs --> 
        <xsl:choose>
          <xsl:when test="$str_element='task'">
            <tr>
              <td>Header</td>
              <td><input class="additor" id="h" name="h" type="text" size="50" maxlength="60"/></td>
            </tr>
              <tr>
                <td>Text</td>
                <td><input class="additor" id="p" name="p" type="text" size="50" maxlength="60"/></td>
              </tr>
              <tr>
                <td>Date</td>
                <td>
                  <input class="additor" id="f_date_b" name="date" type="text" size="12" maxlength="12" value="{$str_date}"/>
                  <button type="reset" id="f_trigger_b">...</button>
                </td>
              </tr>
              <tr>
                <td>Effort</td>
                <td><input class="additor" name="effort" type="text"/></td>
              </tr>
              <tr>
                <td>Contact</td>
                <td><input class="additor" name="contact" type="text" size="20" maxlength="20"/></td>
              </tr>

<script type="text/javascript">
    Calendar.setup({
        inputField     :    "f_date_b",      // id of the input field
        ifFormat       :    "%Y%m%d",       // format of the input field
        showsTime      :    false,            // will display a time selector
        button         :    "f_trigger_b",   // trigger for the calendar (button ID)
        singleClick    :    true,           // double-click mode
        firstDayOfWeek :    2,
        step           :    1                // show all years in drop-down boxes (instead of every other year as default)
    });
</script>

            </xsl:when>
            <xsl:when test="$str_element='p'">
              <tr>
                <td>Text</td>
                <td><input class="additor" id="p" name="p" type="text" size="50" maxlength="60"/></td>
              </tr>
            </xsl:when>
            <xsl:when test="$str_element='pre'">
              <tr>
                <td>Text</td>
                <td><textarea class="additor" id="pre" name="pre" cols="50" rows="10"/></td>
              </tr>
            </xsl:when>
            <xsl:when test="$str_element='target'">
              <tr>
                <td>Header</td>
                <td><input class="additor" id="h" name="h" type="text" size="50" maxlength="60"/></td>
              </tr>
            </xsl:when>
            <xsl:otherwise> <!-- section is default -->
              <tr>
                <td>Header</td>
                <td><input class="additor" id="h" name="h" type="text" size="50" maxlength="60"/></td>
              </tr>
            </xsl:otherwise>
          </xsl:choose>
        </table>
        <!-- selction tree --> 
        <xsl:element name="pre">
          <xsl:for-each select="//node[@TEXT and not(ancestor-or-self::node[contains(icon/@BUILTIN,'cancel')])]">
            <xsl:for-each select="ancestor::node[@TEXT and not(ancestor-or-self::node[contains(icon/@BUILTIN,'cancel')])]">
              <xsl:text>   </xsl:text>
            </xsl:for-each>
            <xsl:element name="a">
              <xsl:attribute name="id">
                <xsl:value-of select="count(preceding::node) + count(ancestor::node) + 1"/>
            </xsl:attribute>
            <xsl:attribute name="onclick">CheckAndSubmit(this)</xsl:attribute>
            <xsl:attribute name="onmouseover">this.className='datum'</xsl:attribute>
            <xsl:attribute name="onmouseout">this.className='link'</xsl:attribute>
            <xsl:value-of select="normalize-space(@TEXT)"/>
          </xsl:element>
          <xsl:value-of select="$newline"/>
        </xsl:for-each>
      </xsl:element>
        </form>
            <xsl:if test="$flag_form">
              <xsl:call-template name="PIEFORM"/>
            </xsl:if>
      </xsl:element>
    </xsl:element>
  </xsl:template>
</xsl:stylesheet>
