<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!--
    -->
  <xsl:output method="xml" encoding="UTF-8"/>
  <xsl:variable name="pos_element" select="2"/>
  <xsl:variable name="str_relation" select="'child'"/>
  <xsl:variable name="str_element" select="'section'"/>
  <xsl:variable name="str_h" select="'NEW'"/>
  <xsl:variable name="str_p" select="''"/>
  <xsl:variable name="str_pre" select="''"/>
  <xsl:variable name="str_date" select="''"/>
  <xsl:variable name="str_effort" select="''"/>
  <xsl:variable name="str_contact" select="''"/>
  <xsl:variable name="newline">
    <!-- a newline xsl:text element -->
    <xsl:text>
</xsl:text>
  </xsl:variable>

  <xsl:template match="@*|node()">
    <xsl:choose>
      <xsl:when test="self::node[(count(preceding::node) + count(ancestor::node) + 1) = $pos_element]">
        <!-- parent node with proper position found -->
        <xsl:choose>
          <xsl:when test="$str_relation='sibling'">
            <!-- add as sibling -->
            <xsl:copy-of select="."/>
            <!-- now insert new sibling node -->
            <xsl:call-template name="INSNODE"/>
          </xsl:when>
          <xsl:otherwise>
            <!-- add by default as child -->
            <xsl:element name="{name()}">
              <xsl:copy-of select="@*"/>
              <xsl:copy-of select="child::*"/>
              <!-- now insert new child node -->
              <xsl:call-template name="INSNODE"/>
            </xsl:element>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:copy>
          <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="INSNODE">
    <!-- insert the global specified node --> 
    <xsl:value-of select="$newline"/>
    <xsl:element name="{$str_element}">
      <xsl:choose>
        <xsl:when test="$str_element='task'">
          <xsl:if test="string-length($str_date) &gt; 0">
            <xsl:attribute name="date">
              <xsl:value-of select="$str_date"/>
            </xsl:attribute>
          </xsl:if>
          <xsl:if test="string-length($str_effort) &gt; 0">
            <xsl:attribute name="effort">
              <xsl:value-of select="$str_effort"/>
            </xsl:attribute>
          </xsl:if>
          <xsl:element name="h">
            <xsl:value-of select="normalize-space($str_h)"/>
          </xsl:element>
          <xsl:value-of select="$newline"/>
          <xsl:if test="string-length($str_p) &gt; 0">
            <xsl:element name="p">
              <xsl:value-of select="normalize-space($str_p)"/>
            </xsl:element>
            <xsl:value-of select="$newline"/>
          </xsl:if>
          <xsl:if test="string-length($str_contact) &gt; 0">
            <xsl:element name="contact">
              <xsl:attribute name="idref">
                <xsl:value-of select="$str_contact"/>
              </xsl:attribute>
            </xsl:element>
          </xsl:if>
        </xsl:when>
        <xsl:when test="$str_element='p'">
          <xsl:value-of select="normalize-space($str_p)"/>
        </xsl:when>
        <xsl:when test="$str_element='pre'">
          <xsl:value-of select="$str_pre"/>
        </xsl:when>
        <xsl:when test="$str_element='target'">
          <xsl:element name="h">
            <xsl:value-of select="normalize-space($str_h)"/>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <!-- default is node -->
          <xsl:attribute name="TEXT">
            <xsl:value-of select="normalize-space($str_h)"/>
          </xsl:attribute>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>
    <xsl:value-of select="$newline"/>
  </xsl:template>

</xsl:stylesheet>
