<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:import href="../xsl/html/PieHtml.xsl"/>
  <xsl:variable name="file_css" select="'pie.css'"/>
  <!--  -->
  <xsl:variable name="file" select="''"/>
  <!--  -->
  <xsl:variable name="str_write"  select="''"/>
  <!--  -->
  <xsl:variable name="str_input" select="''"/>
  <!-- true() : there is image support in cxproc (these files have image child element) -->
  <xsl:variable name="flag_cxp" select="/pie//file[contains(@type,'image/') and image]"/>
  <!--  -->
  <xsl:output method="html" omit-xml-declaration="no" doctype-public="-//W3C//DTD HTML 4.01//EN" doctype-system="file:///tmp/dummy.dtd" encoding="UTF-8"/>
  <xsl:template match="/">
    <xsl:element name="html">
      <xsl:call-template name="HEADER">
        <xsl:with-param name="str_title">
          <xsl:value-of select="$file"/>
        </xsl:with-param>
      </xsl:call-template>
      <!--
           <xsl:element name="META">
             <xsl:attribute name="HTTP-EQUIV">Refresh</xsl:attribute>
             <xsl:attribute name="CONTENT">
               <xsl:text>5; </xsl:text>
               <xsl:value-of select="concat('URL=','?dir=',/pie/dir/@name,'&amp;','cxp=gallery','&amp;','index=',$index_next)"/>
             </xsl:attribute>
           </xsl:element>
           -->
      <xsl:element name="body">
        <xsl:attribute name="background">#000000</xsl:attribute>
        <xsl:choose>
          <xsl:when test="string-length($file) &gt; 0">
            <xsl:apply-templates select="pie/dir/file[@name=$file]"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:apply-templates select="pie/dir/file[contains(@type,'image/')]"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:element>
    </xsl:element>
  </xsl:template>
  <xsl:template match="file">
    <!--  -->
    <xsl:variable name="dir_name">
      <xsl:for-each select="ancestor::dir">
        <xsl:value-of select="@name"/>
        <xsl:if test="position() != last()">
          <xsl:text>/</xsl:text>
        </xsl:if>
      </xsl:for-each>
    </xsl:variable>

    <xsl:element name="form">
      <xsl:attribute name="method">
        <xsl:text>post</xsl:text>
      </xsl:attribute>
      <xsl:element name="p">
        <xsl:attribute name="align">right</xsl:attribute>
        <!-- hidden form input -->
        <xsl:element name="input">
          <xsl:attribute name="type">hidden</xsl:attribute>
          <xsl:attribute name="name">cxp</xsl:attribute>
          <xsl:attribute name="value">gallery</xsl:attribute>
        </xsl:element>
        <xsl:element name="input">
          <xsl:attribute name="type">hidden</xsl:attribute>
          <xsl:attribute name="name">dir</xsl:attribute>
          <xsl:attribute name="value">
            <xsl:value-of select="$dir_name"/>
          </xsl:attribute>
        </xsl:element>
        <xsl:element name="input">
          <xsl:attribute name="type">hidden</xsl:attribute>
          <xsl:attribute name="name">file</xsl:attribute>
          <xsl:attribute name="value">
            <xsl:value-of select="following::file[contains(@type,'image')]/@name"/>
          </xsl:attribute>
        </xsl:element>
        <!-- form buttons -->
	  <xsl:element name="input">
	    <xsl:attribute name="type">image</xsl:attribute>
	    <xsl:attribute name="src">/cxproc/icons/go-next.png</xsl:attribute>
	    <xsl:attribute name="alt">Next Image</xsl:attribute>
	    <xsl:attribute name="title">Next Image</xsl:attribute>
	  </xsl:element>
      </xsl:element>
    </xsl:element>

    <xsl:element name="form">
      <xsl:attribute name="method">
        <xsl:text>post</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="accept-charset">
        <xsl:value-of select="'UTF-8'"/>
      </xsl:attribute>
      <xsl:element name="table">
        <xsl:element name="tbody">
          <xsl:element name="tr">
          </xsl:element>
          <xsl:element name="tr">
            <xsl:element name="td">
              <xsl:attribute name="width">800</xsl:attribute>
              <xsl:attribute name="height">800</xsl:attribute>
              <xsl:attribute name="valign">center</xsl:attribute>
              <xsl:attribute name="align">center</xsl:attribute>

              <xsl:choose>
                <xsl:when test="$flag_cxp">
                  <xsl:element name="a">
                    <xsl:attribute name="href">
                      <xsl:value-of select="concat('/',$dir_name,'/',@name)"/>
                    </xsl:attribute>
                    <xsl:element name="img">
                      <xsl:attribute name="alt">
                        <xsl:value-of select="@name"/>
                      </xsl:attribute>
                      <xsl:attribute name="title">
                        <xsl:value-of select="@name"/>
                      </xsl:attribute>
                      <xsl:attribute name="src">
                        <xsl:value-of select="concat('?file=',$dir_name,'/',@name,'&amp;','cxp=image')"/>
                      </xsl:attribute>
                    </xsl:element>
                  </xsl:element>
                </xsl:when>
                <xsl:otherwise>
                  <!-- direct link if there is no image support in cxproc --> 
                  <xsl:element name="img">
                    <xsl:attribute name="alt">
                      <xsl:value-of select="@name"/>
                    </xsl:attribute>
                    <xsl:attribute name="title">
                      <xsl:value-of select="@name"/>
                    </xsl:attribute>
                    <xsl:attribute name="src">
                      <xsl:value-of select="concat('/',$dir_name,'/',@name)"/>
                    </xsl:attribute>
                  </xsl:element>
                </xsl:otherwise>
              </xsl:choose>
              <br/>
              <!--
            </xsl:element>
          </xsl:element>
          <xsl:element name="tr">
            <xsl:element name="td">
-->
              <xsl:text>Kommentar zu </xsl:text>
              <xsl:value-of select="@name"/>
              <xsl:text> </xsl:text>
              <xsl:value-of select="concat('(',count(preceding-sibling::file[contains(@type,'image')])+1,'/',count(/pie/dir/file[contains(@type,'image')]),')')"/>
              <xsl:text> </xsl:text>
              <!-- hidden form input -->
              <xsl:element name="input">
                <xsl:attribute name="type">hidden</xsl:attribute>
                <xsl:attribute name="name">cxp</xsl:attribute>
                <xsl:attribute name="value">comment</xsl:attribute>
              </xsl:element>
              <xsl:element name="input">
                <xsl:attribute name="type">hidden</xsl:attribute>
                <xsl:attribute name="name">dir</xsl:attribute>
                <xsl:attribute name="value">
                  <xsl:value-of select="$dir_name"/>
                </xsl:attribute>
              </xsl:element>
              <xsl:element name="input">
                <xsl:attribute name="type">hidden</xsl:attribute>
                <xsl:attribute name="name">file</xsl:attribute>
                <xsl:attribute name="value">
                  <xsl:value-of select="@name"/>
                </xsl:attribute>
              </xsl:element>
              <!-- form buttons -->
              <xsl:element name="input">
                <xsl:attribute name="type">submit</xsl:attribute>
                <xsl:attribute name="value">Absenden</xsl:attribute>
              </xsl:element>
              <xsl:element name="input">
                <xsl:attribute name="type">reset</xsl:attribute>
                <xsl:attribute name="value">Zurücksetzen</xsl:attribute>
              </xsl:element>
              <!-- form input -->
              <xsl:element name="textarea">
                <xsl:attribute name="name">comment</xsl:attribute>
                <xsl:attribute name="cols">90</xsl:attribute>
                <xsl:attribute name="rows">5</xsl:attribute>
                <xsl:choose>
                  <xsl:when test="string-length($str_input) &gt; 0">
                    <xsl:value-of select="$str_input"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:comment> Not usable yet </xsl:comment>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:element>
            </xsl:element>
          </xsl:element>
        </xsl:element>
      </xsl:element>
    </xsl:element>
  </xsl:template>
</xsl:stylesheet>
