<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:cxp="http://www.tenbusch.info" version="1.0">
  <xsl:variable name="file" select="'t.txt'"/>
  <xsl:variable name="class" select="'article'"/>
  <xsl:output method="xml"/>
  <xsl:template match="/">
     <xsl:element name="cxp:xml">
      <xsl:choose>
        <xsl:when test="contains($file,'.txt')">
          <xsl:element name="cxp:pie">
            <xsl:attribute name="url">yes</xsl:attribute>
            <xsl:attribute name="figure">yes</xsl:attribute>
            <xsl:attribute name="date">no</xsl:attribute>
            <xsl:element name="cxp:plain">
              <xsl:attribute name="name">
                <xsl:value-of select="$file"/>
              </xsl:attribute>
            </xsl:element>
          </xsl:element>
          <xsl:element name="cxp:xsl">
            <xsl:attribute name="name">Validate.xsl</xsl:attribute>
          </xsl:element>
          <xsl:element name="cxp:xsl">
            <xsl:attribute name="name">ExtractDuration.xsl</xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:when test="contains($file,'.csv')">
          <xsl:element name="cxp:pie">
            <xsl:attribute name="url">no</xsl:attribute>
            <xsl:attribute name="figure">no</xsl:attribute>
            <xsl:attribute name="date">no</xsl:attribute>
            <xsl:element name="cxp:plain">
              <xsl:attribute name="type">csv</xsl:attribute>
              <xsl:attribute name="name">
                <xsl:value-of select="$file"/>
              </xsl:attribute>
            </xsl:element>
          </xsl:element>
        </xsl:when>
        <xsl:when test="contains($file,'.cal') or contains($file,'.acal') or contains($file,'.gcal')">
          <xsl:element name="cxp:pie">
            <xsl:attribute name="url">yes</xsl:attribute>
            <xsl:attribute name="figure">no</xsl:attribute>
            <xsl:attribute name="date">no</xsl:attribute>
            <xsl:element name="cxp:plain">
              <xsl:attribute name="type">line</xsl:attribute>
              <xsl:attribute name="format">log</xsl:attribute>
              <xsl:attribute name="name">
                <xsl:value-of select="$file"/>
              </xsl:attribute>
            </xsl:element>
          </xsl:element>
          <xsl:element name="cxp:xsl">
            <xsl:attribute name="name">RemoveHiddenLevel.xsl</xsl:attribute>
            <xsl:element name="cxp:variable">
              <xsl:attribute name="name">level_hidden_max</xsl:attribute>
              <xsl:attribute name="select">0</xsl:attribute>
            </xsl:element>
          </xsl:element>
        </xsl:when>
        <xsl:when test="contains($file,'.mm')">
          <xsl:element name="cxp:xml">
            <xsl:attribute name="name">
              <xsl:value-of select="$file"/>
            </xsl:attribute>
          </xsl:element>
	  <xsl:choose>
            <xsl:when test="$class = 'project'">
              <xsl:element name="cxp:xsl">
		<xsl:attribute name="name">
		  <xsl:value-of select="'mm2task.xsl'"/>
		</xsl:attribute>
              </xsl:element>
            </xsl:when>
            <xsl:otherwise>
              <xsl:element name="cxp:xsl">
		<xsl:attribute name="name">
		  <xsl:value-of select="'mm_strip_folded.xsl'"/>
		</xsl:attribute>
              </xsl:element>
              <xsl:element name="cxp:xsl">
		<xsl:attribute name="name">
		  <xsl:value-of select="'mm_cleanup.xsl'"/>
		</xsl:attribute>
              </xsl:element>
              <xsl:element name="cxp:xsl">
		<xsl:attribute name="name">
		  <xsl:value-of select="'mm2pie.xsl'"/>
		</xsl:attribute>
              </xsl:element>
            </xsl:otherwise>
	  </xsl:choose>
          <xsl:element name="cxp:xsl">
            <xsl:attribute name="name">
              <xsl:value-of select="'ExtractDuration.xsl'"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <xsl:element name="cxp:pie">
            <xsl:attribute name="url">yes</xsl:attribute>
            <xsl:attribute name="figure">no</xsl:attribute>
            <xsl:attribute name="date">no</xsl:attribute>
            <xsl:element name="cxp:xml">
              <xsl:attribute name="name">
                <xsl:value-of select="$file"/>
              </xsl:attribute>
            </xsl:element>
          </xsl:element>
          <xsl:element name="cxp:xsl">
            <xsl:attribute name="name">
              <xsl:value-of select="'Validate.xsl'"/>
            </xsl:attribute>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>
  </xsl:template>
</xsl:stylesheet>
