#! /usr/bin/perl
#
#

use strict;
use Tk;
use Tk::Tree;
#use UTF8;

#use Proc::Background;
use Sys::Hostname;

#use Encode;

# global hash table
my %entry = ();
my %form = ();

my $tree;
my $imageDefault;
my $imagePie;
my $imageMm; 
my $imageDir; 

my $hostname = lc &hostname();

my $strCommandCxproc = '/home/alex/develop/cxproc/cxproc';
$ENV{PATHXSL} = '/home/alex/develop/cxproc';
#my $strCommandCxproc = '/home/tester/Desktop/cxproc/cxproc';
if ($^O eq 'MSWin32') {
    #$strCommandCxproc = 'C:/home/alex/develop/cxproc/build/vc/cxproc.exe';
    $strCommandCxproc = 'h:/opt/cxproc/bin/cxproc';
    #$strCommandCxproc = 'C:\opt\cxproc\build\vc\cxproc.exe';
    $ENV{PATHXSL} = 'h:/opt/cxproc';
}



sub edit {
    ($form{path}) = $tree->selectionGet();

    my $strNameFile = $entry{$form{path}}->{path_dir} . $entry{$form{path}}->{name_file};
    if ($^O eq 'MSWin32') {
	$strNameFile =~ s/\/+/\\/g;
	if ($strNameFile =~ /\.txt$/i) {
	    #TODO: system "emacsclientw.exe $strNameFile ";
	    system "notepad.exe $strNameFile ";
	}
	elsif ($strNameFile =~ /\.mm$/i) {
	    # TODO: merge with menu.pl
	    #if ($hostname =~ /^frdc/i) {
	#	chdir $ENV{HOME} . '\opt\freemind';
	    #}
	    Proc::Background->new('h:/opt/freemind/freemind.bat', $strNameFile);
	}
	else {
	    system "explorer.exe $strNameFile";
	}
    }
}


sub cleanup_structure {

    # cleanup all file structure entries first
    $tree->selectionClear;
    foreach my $strPath (sort keys %entry) {
	if ($entry{$strPath}->{type} =~ /(section|node|cxp)/i) {
	    #print "$strPath\n";
	    if ($tree->infoExists($strPath)) {
		$tree->delete('offsprings',$strPath);
		$tree->delete('entry',$strPath);
	    }
	    delete $entry{$strPath};
	}
    }
}


=item scan()

=cut

sub scan {

    my $strName = shift;
    my $strKey;
    my $strEval = '';

    $tree->update; # forces scrollbar to update

    # TODO: eval Tree add code directly, use -data => () and ->infoData()
    $strName =~ s/\\+/\//g;
    if (exists $entry{$strName}) {
	my $strNameFile = $entry{$strName}->{path_dir} . $entry{$strName}->{name_file};
	if ($entry{$strName}->{type} eq 'file' and -f $strNameFile) {
	    # scan file entry
	    print "FILE '$strName'\n";
	    open(CXPPIPE,"$strCommandCxproc list.cxp $entry{$strName}->{path_dir} $entry{$strName}->{name_file} |");
	    while (<CXPPIPE>) {
		chomp();
		$strEval .= $_; 
	    }
	    close CXPPIPE;
	    cleanup_structure();
	    eval $strEval;
	}
    }
    elsif (-d $strName) {
	#
	my $strPrefix = 'pie';
	#
	$strName =~ s/\\+/\//g;
	open(CXPPIPE,"$strCommandCxproc browse.cxp $strName |");
	while (<CXPPIPE>) {
	    chomp();
	    $strEval .= $_; 
	}
	close CXPPIPE;
	cleanup_structure();
	eval $strEval;

	# add the keys for $strName
	$entry{$strPrefix} = {'type' => 'root', 'text' => 'PIE'};
	foreach my $strDir (split(/[\/\\]+/, $strName)) {
	    if ($strDir =~ /./) {
		if ($strDir =~ /^[a-z]\:$/i) {
		    $strDir =~ s/\:/_/;
		    $strPrefix .= $strDir;
		}
		else {
		    $strPrefix .= '.' . $strDir;
		}
		$entry{$strPrefix} = {type => 'dir', 
				      #path_dir => '', 
				      name_file => $strDir, 
				      text => $strDir};
	    }
	}
    }
    elsif (-f $strName) {
    }
    else {
    }

    return;
}
# end of scan()



=item show()

=cut

sub show {

    my $widTree = shift;

    $widTree->delete('all');
    foreach my $strPath (sort keys %entry) {
	#print "PP  '$strPath' '$entry{$strPath}->{text}'\n"; #
	# TODO: use $widTree->addchild() instead?
	#$widTree->setmode("$strPrefix.$strPath", 'close');
	#$widTree->infoExists($strPath)

	if ($entry{$strPath}->{type} =~ /(section|node|cxp)/i) {
	    $widTree->add($strPath,
			  -text => ((exists $entry{$strPath}->{text}) ? $entry{$strPath}->{text} : 'HH'));
	}
	else {
	    my $image = $imageDefault;
	    if ($entry{$strPath}->{type} eq 'dir') {
		$image = $imageDir;
	    }
	    elsif ($entry{$strPath}->{type} eq 'file') {
		if ($entry{$strPath}->{text} =~ /\.(pie|txt)$/i) {
		    $image = $imagePie;
		}
		elsif ($entry{$strPath}->{text} =~ /\.mm$/i) {
		    $image = $imageMm;
		}
	    }
	    $widTree->add($strPath,
			  -text => ((exists $entry{$strPath}->{text}) ? $entry{$strPath}->{text} : 'HH'),
			  -image => $image);
	}
    }
    # 
    return;
}
# end of show()


=item clickEntry()

=cut

sub clickEntry {

    my $path = shift;

    scan($path);
    show($tree);
    $tree->autosetmode();
}
# end of clickEntry()


sub viewArticle {

    ($form{path}) = $tree->selectionGet();
    # TODO: multiple selection

    chdir 'H:/opt/cxproc/desktop' or return;

    if ($entry{$form{path}}->{name_file} =~ /\.txt$/i) {
	system "$strCommandCxproc txt2html.cxp \"$entry{$form{path}}->{path_dir}$entry{$form{path}}->{name_file}\"";
    } 
    elsif ($entry{$form{path}}->{name_file} =~ /\.pie$/i) {
    }
    else {
    }
}


sub viewPresentation {

    ($form{path}) = $tree->selectionGet();
    # TODO: multiple selection

    chdir 'H:/opt/cxproc/desktop' or return;

    if ($entry{$form{path}}->{name_file} =~ /\.pie$/i) {
	system "$strCommandCxproc desktop-presentation2.cxp \"h:/tmp/apt\" \"$entry{$form{path}}->{path_dir}$entry{$form{path}}->{name_file}\"";    
    } 
    else {
    }
}


sub viewProject {

    ($form{path}) = $tree->selectionGet();
    # TODO: multiple selection

    chdir 'H:/opt/cxproc/desktop' or return;

    if ($entry{$form{path}}->{name_file} =~ /\.pie$/i) {
	system "$strCommandCxproc desktop-project.cxp \"$entry{$form{path}}->{path_dir}$entry{$form{path}}->{name_file}\"";
    } 
    else {
    }
}


sub executeConfig {

    ($form{path}) = $tree->selectionGet();
    # TODO: multiple selection

    if ($entry{$form{path}}->{name_file} =~ /\.cxp$/i) {
	chdir $entry{$form{path}}->{path_dir} or return;
	system "$strCommandCxproc \"$entry{$form{path}}->{name_file}\"";
    }
    else {
    }
}


=item insertEntry()

=cut

sub insertEntry {

    ($form{path}) = $tree->selectionGet();

    my $iw = MainWindow->new;
    $iw->title("PIE Input '$form{path}'");

    my $frame_input = $iw->Frame(-bg => 'yellow')->pack(-padx => 2, -pady => 5);

    my $l = $frame_input->Label(-text => "$form{relative}::$form{element}")->pack(-expand => 1, -fill => 'x', -side => 'top');
    my $e = $frame_input->Entry(-width => 40, -textvariable => \$form{input})->pack(-expand => 1, -fill => 'x', -side => 'top');

    if ($form{element} eq 'task') {
	$frame_input->Label(-text => "\@date")->pack(-expand => 1, -fill => 'x', -side => 'top');
	$frame_input->Entry(-width => 40, -textvariable => \$form{input_date})->pack(-expand => 1, -fill => 'x', -side => 'top');
	$frame_input->Label(-text => "\@contact")->pack(-expand => 1, -fill => 'x', -side => 'top');
	$frame_input->Entry(-width => 40, -textvariable => \$form{input_contact})->pack(-expand => 1, -fill => 'x', -side => 'top');
    }
    elsif ($form{element} eq 'section') {
    }
    else {
    }
    $frame_input->Button(-text => 'Apply', -command => sub {$iw->destroy; insertEntryApply()})->pack(-expand => 1, -fill => 'x', -side => 'top');
    $e->focusForce;
}


=item insertEntryApply()

=cut

sub insertEntryApply {

    my $strEval = '';

    # TODO: problem if dirname matches
    my $strXpath = '';
    foreach my $strPos (split(/\./, "001$entry{$form{path}}->{path_doc}")) {
	$strXpath .= sprintf "/*\[%i\]", $strPos;
    }

# TODO: quote handling
#    print encode("utf-8", $form{input});
#    $form{input} =~ s/\"/\&quot;/g;
#    $form{input} =~ s/\"/\\\"/g;
#    $form{input} =~ s/\'/\&quot;/g;
    print "Input '$form{input}'\n";

    # apply stylesheet patch and parse new pie file
    open(CXPPIPE,"$strCommandCxproc insert.cxp \"$entry{$form{path}}->{path_dir}\" \"$entry{$form{path}}->{name_file}\" \"$form{relative}\" \"$form{element}\" \"$strXpath\" \"$form{input}\" \"$form{input_date}\" \"$form{input_contact}\" |");
    while (<CXPPIPE>) {
	chomp();
	$strEval .= $_; 
    }
    close CXPPIPE;
    eval $strEval;
    %form = ();

    clickEntry($form{path});
}


my $mw = MainWindow->new;

$mw->title("PIE Browser");

$tree = $mw->Scrolled('Tree', -scrollbars => 'oe')->pack(-fill => 'both', -expand => 0);
$tree->configure(-bg => 'white',
		 -drawbranch => 0,
#		 -ignoreinvoke => 0,
#		 -expand => 0,
		 -height => 60, -width => 70,
		 -font => ['helvetica','8'],
		 -command => \&clickEntry);
#$imageDefault = $tree->Pixmap(-file => 'icons/empty.xpm'); 
$imageDefault = $tree->Pixmap(-file => 'icons/help.xpm'); 
$imagePie = $tree->Pixmap(-file => 'icons/edit12.xpm'); 
$imageMm  = $tree->Pixmap(-file => 'icons/idea.xpm'); 
$imageDir = $tree->Pixmap(-file => 'icons/fileopen.xpm'); 

#scan('c:/home/alex/develop/cxproc/contrib/pie');
#scan('c:/usr/local');
#scan('C:\home\alex\develop\Album\arbeit\themen');
scan('h:/arbeit/themen');
#scan('/home/alex/develop/cxproc');
#scan('/home/tester/Desktop/cxproc/contrib');
#exit;

#scan('\home\alex\develop\trash\cxproc');
#scan('/home/alex/tmp');

show($tree);
$tree->update; # forces scrollbar to update

# # set fold tree
# foreach my $strPath (sort keys %entry) {
#    if ((split /\./, $strPath) > 5) {
# 	    $tree->setmode($strPath,'close');
# 	    $tree->close($strPath);
# 	}
#    }
# $tree->selectionClear;
# $tree->update; # forces scrollbar to update

#exit;

my $menubar = $mw->Menu();
$mw->configure(-menu => $menubar);
my $menu_file = $menubar->cascade(-label => '~File', -tearoff => 0);
$menu_file->command(-label => '~Read');
$menu_file->separator;
#$menu_file->command(-label => '~Exit', -command => sub {exit});
$menu_file->command(-label => '~Exit', -command => sub {$mw->destroy()});

my $menu_edit = $menubar->cascade(-label => '~Edit', -tearoff => 0);
$menu_edit->command(-label => '~Find');
$menu_edit->separator;
$menu_edit->command(-label => '~Cut');
$menu_edit->command(-label => '~Paste');

my $menu_appl = $menubar->cascade(-label => '~Applikation', -tearoff => 0);
$menu_appl->command(-label => 'Editor');
$menu_appl->command(-label => 'E-Mail');
$menu_appl->command(-label => "Taskmanager", -command => \&taskmanager );
$menu_appl->command(-label => "Dateimanager", -command => \&dateimanager );
$menu_appl->command(-label => "WWW-Browser", -command => \&browser );
$menu_appl->command(-label => "E-Mail", -command => \&mail );
#$menu_appl->command(-label => "Terminal lokal", -command => \&terminal );
$menu_appl->command(-label => "ZAPS",
		  -state => (($hostname =~ /^f[ru]/i) ? 'normal' : 'disabled'),
		  -command => \&zaps );
$menu_appl->command(-label => "3D_Evolution", -command => \&evolution );
$menu_appl->command(-label => "Woerterbuch", -command => \&dict );
$menu_appl->command(-label => "Bildbearbeitung", -command => \&bildbearbeitung );
$menu_appl->command(-label => "Textverarbeitung", -command => \&textverarbeitung );
$menu_appl->command(-label => "Tabellenkalkulation", -command => \&tabellenkalkulation );
$menu_appl->command(-label => "Mindmapper", -command => \&mindmapper );
$menu_appl->command(-label => 'Backup', -command => \&backup );
$menu_appl->separator;
$menu_appl->command(-label => "Lock", -command => \&lock );
$menu_appl->command(-label => 'Logout', -command => \&logout );

my $menu_help = $menubar->cascade(-label => '~Help', -tearoff => 0);
$menu_help->command(-label => '~About');

my $menu = $tree->Menu(-tearoff => 0);

my $menu_insert = $menu->Menubutton(-text => 'Insert', -tearoff => 0);
$menu_insert->command(-label => 'sibling/section', -command => sub {%form = (relative => 'sibling', element => 'section'); insertEntry();});
$menu_insert->separator;
$menu_insert->command(-label => 'child/section', -command => sub {%form = (relative => 'child', element => 'section'); insertEntry();});
$menu_insert->command(-label => 'child/task', -command => sub {%form = (relative => 'child', element => 'task'); insertEntry();});
$menu_insert->command(-label => 'child/p');

my $menu_view = $menu->Menubutton(-text => 'View', -tearoff => 0);
$menu_view->command(-label => 'Presentation', -command => sub {viewPresentation();});
$menu_view->command(-label => 'Article', -command => sub {viewArticle();});
$menu_view->command(-label => 'Project', -command => sub {viewProject();});
$menu_view->command(-label => 'Calendar');

$menu->command(-label => 'Edit', -command => \&edit);
$menu->command(-label => 'Execute', -command => sub {executeConfig();});
$menu->command(-label => 'Delete');
$menu->command(-label => 'Collapse');

$tree->bind('<Button-3>' => sub {$menu->Popup(-popover => 'cursor', -popanchor => 'nw')});
$mw->bind('<Control-w>' => sub {$mw->destroy()});

$tree->autosetmode();
MainLoop;

