<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

  <!--

      PKG2 - ProzessKettenGenerator second implementation 
      Copyright (C) 1999-2006 by Alexander Tenbusch

      This program is free software; you can redistribute it and/or modify
      it under the terms of the GNU General Public License as published by
      the Free Software Foundation; either version 2 of the License, or
      (at your option) any later version.

      This program is distributed in the hope that it will be useful,
      but WITHOUT ANY WARRANTY; without even the implied warranty of
      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      GNU General Public License for more details.

      You should have received a copy of the GNU General Public License 
      along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

    -->

  <xsl:output
     method="xml"
     doctype-system="file:///H:/opt/cxproc/xml/pie.dtd"
     encoding="ISO-8859-1"/>  

  <xsl:variable name="str_relative" select="'child'"/>
  <xsl:variable name="pos_element" select="/*[1]/*[1]/*[4]/*[9]"/>
  <xsl:variable name="str_element" select="'section'"/>
  <xsl:variable name="str_h" select="'NEW'"/>
  <xsl:variable name="str_date" select="'20000101'"/>
  <xsl:variable name="str_contact" select="'CONTACT'"/>

  <xsl:variable name="newline">
    <!-- a newline xsl:text element -->
    <xsl:text>
</xsl:text>
  </xsl:variable>

  <xsl:template match="@*|node()">
    <xsl:choose>
      <!-- in valids -->
      <xsl:when test="self::node()=$pos_element">
        <!-- node with proper position found -->
        <xsl:choose>
          <xsl:when test="$str_relative='sibling'">
            <xsl:copy-of select="."/>
            <xsl:value-of select="$newline"/>
            <xsl:element name="{$str_element}">
              <xsl:if test="string-length($str_date) &gt; 0">
                <xsl:attribute name="date">
                  <xsl:value-of select="$str_date"/>
                </xsl:attribute>
              </xsl:if>
	      <xsl:value-of select="$newline"/>
	      <xsl:element name="h">
                <xsl:value-of select="$str_h"/>
              </xsl:element>
	      <xsl:value-of select="$newline"/>
	      <xsl:if test="string-length($str_contact) &gt; 0">
                <xsl:element name="contact">
                  <xsl:attribute name="idref">
                    <xsl:value-of select="$str_contact"/>
                  </xsl:attribute>
                </xsl:element>
		<xsl:value-of select="$newline"/>
	      </xsl:if>
            </xsl:element>
          </xsl:when>
          <xsl:otherwise>
            <!-- default child -->
            <xsl:element name="{name()}">
              <xsl:copy-of select="@*"/>
              <xsl:copy-of select="*"/>
              <xsl:value-of select="$newline"/>
              <xsl:element name="{$str_element}">
		<xsl:if test="string-length($str_date) &gt; 0">
                  <xsl:attribute name="date">
                    <xsl:value-of select="$str_date"/>
                  </xsl:attribute>
		</xsl:if>
		<xsl:value-of select="$newline"/>
		<xsl:element name="h">
                  <xsl:value-of select="$str_h"/>
                </xsl:element>
		<xsl:value-of select="$newline"/>
		<xsl:if test="string-length($str_contact) &gt; 0">
                  <xsl:element name="contact">
                    <xsl:attribute name="idref">
                      <xsl:value-of select="$str_contact"/>
                    </xsl:attribute>
                  </xsl:element>
		  <xsl:value-of select="$newline"/>
		</xsl:if>
              </xsl:element>
            <xsl:value-of select="$newline"/>
            </xsl:element>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:otherwise>
        <xsl:copy>
          <xsl:apply-templates select="@*|node()"/> 
        </xsl:copy>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
