<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:cxp="http://www.tenbusch.info/cxproc" version="1.0">
  <xsl:output method="text" encoding="iso-8859-1"/>
  <!-- ignore all elements with an id and valid="no" -->

  <xsl:variable name="dir_name" select="'.'"/>

  <xsl:variable name="file_name" select="'test.pie'"/>

  <xsl:template match="/">
    <xsl:apply-templates select="pie|map|cxp:make/*"/>
  </xsl:template>

  <xsl:template match="pie|map">
      <xsl:text>%entry = (%entry, (</xsl:text>
      <xsl:apply-templates select="*">
        <xsl:with-param name="path_pos">
          <xsl:value-of select="''"/>
        </xsl:with-param>
      </xsl:apply-templates>
      <xsl:text>));</xsl:text>
      <xsl:text>
</xsl:text>
  </xsl:template>
      

  <xsl:template match="*[name()='section' or name()='node' or contains(name(),'cxp:')]">
    <xsl:param name="path_pos"/>
    <xsl:variable name="str_path">
      <xsl:value-of select="concat($path_pos,'.',format-number(position(),'000'))"/>
    </xsl:variable>
    <!--  -->
    <xsl:if test="(contains(name(),'cxp:') and @name and child::*) or true()">
      <xsl:text>"</xsl:text>
      <xsl:value-of select="translate(concat('pie',translate(concat($dir_name,$file_name),' .:','___'),$str_path),'/','.')"/>
      <!-- first col: path -->
      <xsl:text>" => </xsl:text>
      <xsl:text>{type => "</xsl:text>
      <xsl:value-of select="name()"/>
      <xsl:text>", path_doc => "</xsl:text>
      <xsl:value-of select="$str_path"/>
      <xsl:text>", path_dir => "</xsl:text>
      <xsl:value-of select="$dir_name"/>
      <xsl:text>", name_file => "</xsl:text>
      <xsl:value-of select="$file_name"/>
      <xsl:text>", text => "</xsl:text>
      <xsl:value-of select="h"/>
      <xsl:value-of select="@TEXT"/>
      <xsl:value-of select="@name"/>
      <xsl:text>"}</xsl:text>
      <xsl:text>,</xsl:text>
      <xsl:text>
</xsl:text>
      </xsl:if>
      <xsl:apply-templates select="child::*">
        <xsl:with-param name="path_pos">
          <xsl:value-of select="$str_path"/>
        </xsl:with-param>
      </xsl:apply-templates>
  </xsl:template>
    
  <xsl:template match="*"/>
</xsl:stylesheet>
