;;
;;
;;

(require 'ecb)
(ecb-activate)

(defvar ecb-pie-root-node nil
  "Path to currently selected source.")

(defvar pie-ecb-struct nil
  "Header list of parsed file.")

(setq speedbar-use-imenu-flag nil
      ecb-process-non-semantic-files t
      ecb-non-semantic-parsing-function (list (cons 'xml-mode 'pie-ecb-tree-initialize)))

;; (defcustom ecb-pie-buffer-name ecb-methods-buffer-name
;;   ;;"*PIE Tree*"
;;   "Buffer name for pie tree"
;;   :group 'ecb-methods
;;   :type 'string)


(defvar ecb-pie-shell-buffer-name "*PIE out*"
  "Buffer name for pie tree")


(defun pie-ecb-build-tree (node-parent list-of-headers)
  ""
  (let ((node-list (tree-node-new (car list-of-headers) 1 nil)))
    (tree-node-add-children node-parent node-list)
    (dolist (e (nth 2 list-of-headers))
      (if (and (listp e) (> (length e) 2))
	  (pie-ecb-build-tree node-list e)
	(tree-node-add-children node-list (tree-node-new (car e) 1 "DDD"))
	)
      )
    )
  )
;;


(defun pie-ecb-tree-initialize (&optional no-caches)
  "Initialize the pie-browser of ECB. If optional arg NO-CACHES is not nil
then the caches used by the pie-browser will not be initialized."

  (save-excursion
    (set-buffer ecb-methods-buffer-name)
    (setq ecb-pie-root-node (tree-node-new-root))
    (setq ecb-selected-tag nil)
    ;;(setq ecb-pie-root-node nil)
    (setq ecb-pie-root-node (tree-node-new-root))
					;(setq ecb-pie-user-filter-alist nil)
    (setq ecb-current-post-processed-tag-table nil)
					;(unless no-caches
					;  (ecb-pie-browser-initialize-caches))
    )
  )
;; (pie-ecb-tree-initialize)


(defun pie-ecb-tree-update (&optional current-file-name)
  ""
  (interactive)

;  (save-excursion
    (setq pie-buffer (if current-file-name
			 (get-file-buffer current-file-name)
		       (current-buffer)))
    (shell-command
     (concat "xsltproc"
	     " /home/alex/develop/cxproc/contrib/pie/xsl/plain/LispStructEcb.xsl"
	     " " (buffer-file-name pie-buffer)
	     ) ecb-pie-shell-buffer-name)
    (eval-buffer ecb-pie-shell-buffer-name)
    (if pie-ecb-struct
	(progn
	  ;(switch-to-buffer (get-buffer ecb-pie-buffer-name))
	  ;(set-buffer ecb-pie-buffer-name)
	  (set-buffer ecb-methods-buffer-name)
	  ;; structure
	  ;;(setq ecb-pie-root-node (tree-node-new-root))
	  (pie-ecb-build-tree ecb-pie-root-node pie-ecb-struct)
	  (tree-buffer-set-root ecb-pie-root-node)
	  (tree-buffer-update)
	  )
      )
    (kill-buffer ecb-pie-shell-buffer-name)
    ;;(switch-to-buffer pie-buffer)
;    )
  t
)
;; (pie-ecb-tree-update)
;; (pie-ecb-tree "~/develop/cxproc/contrib/pie/tmp/article.pie")

;(add-hook 'pie-xml-mode-hook 'pie-ecb-tree)
;(add-hook 'ecb-current-buffer-sync-hook 'pie-ecb-tree)
(add-hook 'ecb-rebuild-non-semantic-methods-before-hook 'pie-ecb-tree t t)
(add-hook 'after-save-hook 'ecb-rebuild-methods-buffer-for-non-semantic)
;(add-hook 'after-save-hook 'ecb-rebuild-methods-buffer)
(add-hook 'ecb-redraw-layout-after-hook 'pie-ecb-tree t t)

;; s. example from info pages

;; (defecb-tree-buffer-creator ecb-create-pie-tree-buffer
;;     ecb-pie-buffer-name
;;   "Create the tree-buffer for analyse-display."
;;   (tree-buffer-create
;;    ecb-pie-buffer-name
;;    :frame ecb-frame
;;    :mouse-action-trigger ecb-tree-mouse-action-trigger
;;    :is-click-valid-fn 'ecb-interpret-mouse-click
;;    :node-selected-fn 'ecb-tree-buffer-node-select-callback
;;    :node-expanded-fn 'ecb-tree-buffer-node-expand-callback
;;    :node-collapsed-fn 'ecb-tree-buffer-node-collapsed-callback
;;    :node-mouse-over-fn 'ecb-mouse-over-analyse-node
;;    :mouse-highlight-fn 'ecb-analyse-node-mouse-highlighted-p
;;    :node-data-equal-fn 'ecb-analyse-compare-node-data
;;    :maybe-empty-node-types nil
;;    :leaf-node-types nil
;;    :menu-creator 'ecb-analyse-menu-creator
;;    :menu-titles (ecb-analyse-gen-menu-title-creator)
;;    :modeline-menu-creator 'ecb-common-tree-buffer-modeline-menu-creator
;;    :trunc-lines (ecb-member-of-symbol/value-list
;; 		 ecb-pie-buffer-name
;; 		 ecb-tree-truncate-lines)
;;    :read-only t
;;    :tree-indent ecb-tree-indent
;;    :incr-search-p t
;;    :incr-search-additional-pattern nil
;;    :arrow-navigation ecb-tree-navigation-by-arrow
;;    :hor-scroll-step ecb-tree-easy-hor-scroll
;;    :default-images-dir (car ecb-tree-image-icons-directories)
;;    :additional-images-dir (ecb-member-of-symbol/value-list
;; 			   ecb-pie-buffer-name
;; 			   (cdr ecb-tree-image-icons-directories)
;; 			   'car 'cdr)
;;    :image-file-prefix "ecb-"
;;    :tree-style ecb-tree-buffer-style
;;    ;;:tree-style 'ascii-guides
;;    :ascii-guide-face ecb-tree-guide-line-face
;;    :type-facer nil
;;    :expand-symbol-before-p ecb-tree-expand-symbol-before
;;    :highlight-node-face ecb-analyse-face
;;    :general-face ecb-analyse-general-face
;;    :after-create-hook (append
;; 		       (list (lambda ()
;; 			       (ecb-common-after-tree-buffer-create-actions)))
;; 		       ecb-common-tree-buffer-after-create-hook
;; 		       ecb-analyse-buffer-after-create-hook
;; 		       (list (lambda ()
;; 			       (pie-ecb-tree)))
;; 		       )
;;    :after-update-hook nil))


;
;; (ecb-layout-define "my-own-layout" left nil
;; 		   ;; The frame is already splitted side-by-side and point stays in the
;; 		   ;; left window (= the ECB-tree-window-column)
   
;;      ;; Here is the creation code for the new layout
   
;;      ;; 1. Defining the current window/buffer as ECB-methods buffer
;;      (ecb-set-methods-buffer)
;;      ;; 2. Splitting the ECB-tree-windows-column in two windows
;;      (ecb-split-ver 0.75 t)
;;      ;; 3. Go to the second window
;;      (other-window 1)
;;      ;; 4. Defining the current window/buffer as ECB-history buffer
;;      (ecb-set-history-buffer)
;;      ;; 5. Make the ECB-edit-window current (see Postcondition above)
;;      (select-window (next-window)))

;(ecb-create-pie-tree-buffer)

(provide 'ecb-pie-browser)
