<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="xml" encoding="iso-8859-1"/>  

  <!-- ignore all elements with an id and valid="no" -->

  <xsl:template match="/">
    <xsl:element name="map">
      <xsl:element name="node">
        <xsl:attribute name="TEXT">
          <xsl:text>Mindmaps</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="link">
          <xsl:value-of select="pie/dir/@name"/>
        </xsl:attribute>
        <xsl:apply-templates select="pie/*"/>
      </xsl:element>
    </xsl:element>
  </xsl:template>
      
<xsl:template match="dir|file">
  <xsl:variable name="dir_name">
    <xsl:for-each select="ancestor::dir">
      <xsl:value-of select="@name"/>
      <xsl:text>/</xsl:text>
    </xsl:for-each>
    <xsl:value-of select="@name"/>
  </xsl:variable>
  <!--  -->
  <xsl:choose>
    <xsl:when test="@name = 'tmp'"/>  <!-- false() and  -->
    <xsl:when test="starts-with(@name,'_')"/>
    <xsl:when test="starts-with(@name,'.') and not(@name = '.svn')"/>
    <xsl:when test="name()='dir'">
      <xsl:element name="node">
        <xsl:attribute name="TEXT">
          <xsl:value-of select="@name"/>
        </xsl:attribute>
        <xsl:attribute name="link">
          <xsl:value-of select="$dir_name"/>
        </xsl:attribute>
        <xsl:if test="count(ancestor::dir) &gt; 0 and count(file[@ext]) &gt; 6"> <!--  or @ext='html' -->
          <xsl:attribute name="FOLDED">
            <xsl:text>true</xsl:text>
          </xsl:attribute>
        </xsl:if>
        <xsl:apply-templates select="dir[descendant::file]|file"/> <!--  or @ext='html' -->
      </xsl:element>
    </xsl:when>
    <xsl:when test="@ext='mm' or @ext='pie' or @ext='txt' or @ext='htm' or @ext='html'">	<!--  or @ext='html' -->
    <xsl:variable name="url_file">
      <xsl:value-of select="concat('file:///',translate($dir_name,'\','/'))"/>
    </xsl:variable>
    <xsl:variable name="text_node">
      <xsl:choose>
        <xsl:when test="@ext='pie'">
          <xsl:value-of select="document($url_file)/pie/section[1]/h"/>
        </xsl:when>
        <xsl:when test="@ext='txt'"/>
        <xsl:when test="@ext='htm'"/>
        <xsl:when test="@ext='html'"/>
        <xsl:otherwise>
          <xsl:value-of select="document($url_file)/map//node[1]/attribute::*[name()='TEXT' or name()='text']"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:element name="node">
      <xsl:attribute name="TEXT">
        <xsl:choose>
          <xsl:when test="$text_node=''">
            <xsl:value-of select="concat('(',@name,')')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$text_node"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:attribute>
      <xsl:attribute name="link">
        <xsl:value-of select="$url_file"/>
      </xsl:attribute>
    </xsl:element>
  </xsl:when>
    <xsl:otherwise>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

</xsl:stylesheet>

