<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <!--

       PKG2 - ProzessKettenGenerator second implementation 
       Copyright (C) 1999-2006 by Alexander Tenbusch
       
       This program is free software; you can redistribute it and/or modify
       it under the terms of the GNU General Public License as published by
       the Free Software Foundation; either version 2 of the License, or
       (at your option) any later version.

       This program is distributed in the hope that it will be useful,
       but WITHOUT ANY WARRANTY; without even the implied warranty of
       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
       GNU General Public License for more details.

       You should have received a copy of the GNU General Public License 
       along with this program; if not, write to the Free Software
       Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
       
       -->

  <xsl:output method="text"/>  

  <xsl:variable name="prefix">/tmp</xsl:variable>

  <!-- ignore all elements with an id and valid="no" -->

  <xsl:template match="/">
    <xsl:apply-templates select="pie/dir"/>
  </xsl:template>
      
  <xsl:template match="dir">
    <xsl:if test="@name and string-length(@name) &gt; 0">
      <xsl:text>(cd &quot;</xsl:text>
      <xsl:value-of select="$prefix"/>
      <xsl:choose>
        <xsl:when test="count(ancestor::dir) &lt; 1">
        </xsl:when>
        <xsl:otherwise>
          <xsl:for-each select="ancestor::dir">
            <xsl:value-of select="@name"/>
            <xsl:text>/</xsl:text>
          </xsl:for-each>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:text>&quot; &amp;&amp; mkdir &quot;</xsl:text>
        <xsl:value-of select="substring-after(@name,'/')"/>
      <xsl:value-of select="@name"/>
      <xsl:text>&quot;)
</xsl:text>
    </xsl:if>
    <xsl:apply-templates select="dir"/>
  </xsl:template>
      
  <xsl:template match="*">
  </xsl:template>
      
</xsl:stylesheet>

