<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method='xml' version='1.0'/>

  <xsl:variable name="flag_file" select="true()"/>

  <xsl:variable name="flag_link" select="true()"/>

  <xsl:template match="/">
     <xsl:apply-templates/>
  </xsl:template>


  <xsl:template match="pie">
    <xsl:element name="map">
      <xsl:choose>
        <xsl:when test="count(child::*) &gt; 1">
          <!-- create root node -->
          <xsl:element name="node">
            <xsl:attribute name="TEXT">
              <xsl:value-of select="@name"/>
            </xsl:attribute>
            <xsl:apply-templates/>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <!-- there is a root node already -->
          <xsl:apply-templates/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>
  </xsl:template>


  <xsl:template match="dir">
    <xsl:element name="node">
      <xsl:if test="child::dir and count(parent::dir) &gt; 0 and count(parent::dir) &lt; 2">
        <xsl:attribute name="FOLDED">
          <xsl:text>true</xsl:text>
        </xsl:attribute>
      </xsl:if>
      <xsl:if test="$flag_link">
        <xsl:attribute name="LINK">
          <xsl:for-each select="ancestor::dir">
            <xsl:if test="@name">
              <xsl:value-of select="@name"/>
              <xsl:text>/</xsl:text>
            </xsl:if>
          </xsl:for-each>
        <xsl:value-of select="@name"/>
        </xsl:attribute>
      </xsl:if>
      <xsl:attribute name="TEXT">
        <xsl:value-of select="@name"/>
      </xsl:attribute>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>


  <xsl:template match="file"> <!--  and not(@name='index.html') -->
    <xsl:if test="$flag_file">
      <xsl:element name="node">
        <xsl:attribute name="TEXT">
          <xsl:value-of select="@name"/>
        </xsl:attribute>
      </xsl:element>
    </xsl:if>
  </xsl:template>


  <xsl:template match="*"/>

</xsl:stylesheet>
