<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method='xml' version='1.0'/> <!--  doctype-system="pie.dtd" -->

<xsl:variable name="h_max" select="3"/>


<xsl:template match="/map">
  <!--
  <xsl:processing-instruction name="xml-stylesheet">
    <xsl:text>href="pie2html.xsl" type="text/xsl"</xsl:text>
  </xsl:processing-instruction>
  -->
  <xsl:element name="pie">
    <xsl:apply-templates/>
  </xsl:element>
</xsl:template>


<xsl:template match="node">
  <xsl:variable name="depth" select="count(ancestor::node)"/>
  <xsl:choose>
    <xsl:when test="$depth &lt; $h_max">
      <!-- header -->
      <xsl:element name="section">
        <xsl:if test="child::icon[contains(@BUILTIN, 'cancel')]">
          <xsl:attribute name="valid">
            <xsl:text>no</xsl:text>
          </xsl:attribute>
        </xsl:if>
        <xsl:element name="h">
        <xsl:choose>
          <xsl:when test="@LINK">
            <!-- node with a link -->
            <xsl:element name="link">
              <xsl:attribute name="href">
                <xsl:value-of select="@LINK"/>
              </xsl:attribute>
              <xsl:value-of select="@TEXT"/>
            </xsl:element>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="@TEXT"/>
          </xsl:otherwise>
        </xsl:choose>
        </xsl:element>
        <xsl:choose>
          <xsl:when test="($h_max - $depth &lt; 2) and child::node">
            <xsl:element name="list">
              <xsl:apply-templates/>
            </xsl:element>
          </xsl:when>
          <xsl:otherwise>
            <xsl:apply-templates/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:element>
    </xsl:when>
    <xsl:otherwise>
      <!-- itemized par -->
      <xsl:element name="p">
        <xsl:if test="child::icon[contains(@BUILTIN, 'cancel')]">
          <xsl:attribute name="valid">
            <xsl:text>no</xsl:text>
          </xsl:attribute>
        </xsl:if>
        <xsl:choose>
          <xsl:when test="@LINK">
            <!-- node with a link -->
            <xsl:element name="link">
              <xsl:attribute name="href">
                <xsl:value-of select="@LINK"/>
              </xsl:attribute>
              <xsl:value-of select="@TEXT"/>
            </xsl:element>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="@TEXT"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:element>
      <xsl:if test="child::node">
        <xsl:element name="list">
          <xsl:apply-templates/>
        </xsl:element>
      </xsl:if>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template match="nodeooo">
    <xsl:choose>
      <xsl:when test="count(ancestor::node) &lt; $h_max">
        <!-- header -->
        <xsl:element name="section">
          <xsl:if test="child::icon[contains(@BUILTIN, 'cancel')]">
            <xsl:attribute name="valid">
              <xsl:text>no</xsl:text>
            </xsl:attribute>
          </xsl:if>
          <xsl:element name="h">
            <xsl:value-of select="@TEXT"/>
          </xsl:element>
          <xsl:apply-templates/>
        </xsl:element>
      </xsl:when>
      <xsl:when test="count(ancestor::node) = $h_max">
        <!-- par -->
        <xsl:element name="p">
          <xsl:if test="child::icon[contains(@BUILTIN, 'cancel')]">
            <xsl:attribute name="valid">
              <xsl:text>no</xsl:text>
            </xsl:attribute>
          </xsl:if>
          <xsl:value-of select="@TEXT"/>
        </xsl:element>
          <xsl:apply-templates/>
      </xsl:when>
      <xsl:otherwise>
        <!-- itemize -->
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
</xsl:template>


<xsl:template match="hook">
  <xsl:if test="@NAME = 'accessories/plugins/NodeNote.properties' and child::text">
    <xsl:apply-templates/>
  </xsl:if>
</xsl:template>


<xsl:template match="text">
  <!--
  <xsl:for-each select="ancestor::node">
    <xsl:call-template name="itemize"/>
  </xsl:for-each>
       -->
  <xsl:text> </xsl:text><xsl:value-of select="."/>
</xsl:template>


<xsl:template match="icon">
  <!--
       <xsl:text> </xsl:text><xsl:value-of select="@BUILTIN"/>
       -->
</xsl:template>


</xsl:stylesheet>
