<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="xml" version="1.0" encoding="ISO-8859-1"/>
  <xsl:variable name="flag_p" select="true()"/>
  <xsl:variable name="str_title" select="''"/>
  <xsl:template match="/">
    <xsl:element name="map">
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>
  <xsl:template match="pie">
    <xsl:choose>
      <xsl:when test="count(child::*[not(name()='meta' or name()='date' or name()='author')]) &gt; 1">
        <!-- create root node -->
        <xsl:element name="node">
          <xsl:attribute name="TEXT">
            <xsl:value-of select="concat($str_title,'&#xa;',date,'&#xa;',author)"/>
          </xsl:attribute>
          <xsl:apply-templates/>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <!-- there is a root node already -->
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="section">
    <xsl:element name="node">
      <xsl:if test="child::*[not(name() = 'h')] and count(ancestor::section) &gt; 0">
        <xsl:attribute name="FOLDED">
          <xsl:text>true</xsl:text>
        </xsl:attribute>
      </xsl:if>
      <xsl:attribute name="TEXT">
        <xsl:value-of select="normalize-space(h)"/>
      </xsl:attribute>
      <xsl:if test="h/@ref">
        <xsl:attribute name="LINK">
          <xsl:value-of select="h/@ref"/>
        </xsl:attribute>
      </xsl:if>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>
  <xsl:template match="task|target">
    <xsl:if test="$flag_p">
      <xsl:element name="node">
        <xsl:attribute name="TEXT">
          <!--
          <xsl:if test="@date">
            <xsl:value-of select="@date"/>
            <xsl:text>: </xsl:text>
          </xsl:if>
          --> 
          <xsl:value-of select="normalize-space(h)"/>
          <xsl:for-each select="child::contact">
            <xsl:text> / </xsl:text>
            <xsl:value-of select="@idref"/>
          </xsl:for-each>
        </xsl:attribute>
        <xsl:if test="h/@ref">
          <xsl:attribute name="LINK">
            <xsl:value-of select="h/@ref"/>
          </xsl:attribute>
        </xsl:if>
        <xsl:if test="@done">
          <xsl:element name="icon">
            <xsl:attribute name="BUILTIN">
              <xsl:text>button_ok</xsl:text>
            </xsl:attribute>
          </xsl:element>
        </xsl:if>
        <xsl:if test="@prio &lt; 3">
          <xsl:element name="icon">
            <xsl:attribute name="BUILTIN">
              <xsl:text>messagebox_warning</xsl:text>
            </xsl:attribute>
          </xsl:element>
        </xsl:if>
        <xsl:if test="@valid = 'no' or @hidden">
          <xsl:element name="icon">
            <xsl:attribute name="BUILTIN">
              <xsl:text>button_cancel</xsl:text>
            </xsl:attribute>
          </xsl:element>
        </xsl:if>
        <xsl:apply-templates select="*"/>
      </xsl:element>
    </xsl:if>
  </xsl:template>
  <xsl:template match="list">
    <!-- TODO: check if list is child of a section element after h element --> 
    <xsl:if test="$flag_p and preceding-sibling::*[position()=1 and not(name()='p')]">
      <xsl:element name="node">
        <xsl:apply-templates/>
      </xsl:element>
    </xsl:if>
  </xsl:template>
  <xsl:template match="fig">
    <xsl:element name="node">
      <xsl:if test="h">
        <!-- write header as TEXT in this node -->
        <xsl:attribute name="TEXT">
          <xsl:value-of select="normalize-space(h)"/>
        </xsl:attribute>
      </xsl:if>
      <xsl:if test="img/@src">
        <!-- add link to image -->
        <xsl:attribute name="LINK">
          <xsl:value-of select="img/@src"/>
        </xsl:attribute>
      </xsl:if>
    </xsl:element>
  </xsl:template>
  <xsl:template match="p">
    <xsl:if test="$flag_p">
      <xsl:element name="node">
        <xsl:attribute name="TEXT">
          <xsl:value-of select="normalize-space(.)"/>
        </xsl:attribute>
        <xsl:if test="link/@href">
          <xsl:attribute name="LINK">
            <xsl:value-of select="link/@href"/>
          </xsl:attribute>
        </xsl:if>
        <xsl:if test="following-sibling::*[position()=1 and name()='list']">
          <xsl:apply-templates select="following-sibling::*[1]/*"/>
        </xsl:if>
      </xsl:element>
    </xsl:if>
  </xsl:template>
  <xsl:template match="*"/>
</xsl:stylesheet>
