<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:import href="../PieHtml.xsl"/>
  <xsl:variable name="dir_icons" select="'../html/icons'"/>
  <!--  -->
  <xsl:variable name="file_css" select="'pie.css'"/>
  <xsl:variable name="file_ref" select="'TodoContactTable.html'"/>
  <xsl:variable name="file_cxp" select="''"/>
  <!--  -->
  <xsl:variable name="node_cols" select="/calendar/meta/*/*[@id]"/>
  <xsl:variable name="id_cols" select="$node_cols/@id"/>
  <xsl:variable name="context" select="'Day'"/>
  <!--  -->
  <xsl:variable name="nowYear" select="''"/>
  <xsl:variable name="nowMonth" select="''"/>
  <xsl:variable name="nowWeek" select="''"/>
  <xsl:variable name="nowDay" select="''"/>
  <!--  -->
  <xsl:variable name="flag_form" select="false()"/>
  <!--  -->
  <xsl:output encoding="ISO-8859-1" method="html" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN" media-type="text/html"/>
  <xsl:template match="/">
    <xsl:element name="html">
      <xsl:call-template name="HEADER"/>
      <xsl:element name="body">
        <xsl:if test="$flag_form">
          <xsl:call-template name="NAVI"/>
        </xsl:if>
        <xsl:apply-templates select="calendar"/>
        <xsl:if test="$flag_form">
          <xsl:call-template name="NAVI"/>
        </xsl:if>
      </xsl:element>
    </xsl:element>
  </xsl:template>
  <xsl:template match="calendar">
    <!--  -->
    <xsl:element name="table">
      <xsl:attribute name="class">
        <xsl:value-of select="name(.)"/>
      </xsl:attribute>
      <xsl:attribute name="border">
        <xsl:text>0</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="cellspacing">
        <xsl:text>1</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="width">
        <xsl:text>100%</xsl:text>
      </xsl:attribute>
      <xsl:element name="tbody">
        <xsl:element name="tr">
          <xsl:for-each select="$node_cols">
            <xsl:element name="th">
              <xsl:value-of select="@name"/>
            </xsl:element>
          </xsl:for-each>
        </xsl:element>
        <!--  -->
        <xsl:choose>
          <xsl:when test="$nowYear=''">
            <!-- no current date informations -->
            <xsl:apply-templates/>
          </xsl:when>
          <xsl:when test="$context='Year'">
            <xsl:apply-templates select="/calendar/year[@ad=$nowYear]"/>
          </xsl:when>
          <xsl:when test="$context='Day'">
            <xsl:apply-templates select="/calendar/year[@ad=$nowYear]//day[@oy=$nowDay]"/>
          </xsl:when>
          <xsl:otherwise>
            <!-- default context is 'Month' -->
            <xsl:apply-templates select="/calendar/year[@ad=$nowYear]/month[@nr=$nowMonth]"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:element>
    </xsl:element>
  </xsl:template>
  <xsl:template match="year">
    <xsl:element name="tr">
      <xsl:element name="th">
        <xsl:attribute name="colspan">
          <xsl:value-of select="count($id_cols)"/>
        </xsl:attribute>
        <xsl:element name="center">
          <xsl:value-of select="@ad"/>
        </xsl:element>
      </xsl:element>
    </xsl:element>
    <xsl:apply-templates select="month"/>
    <!-- -->
    <xsl:if test="child::col">
      <xsl:element name="tr">
        <!--
      <xsl:element name="td">
        <xsl:value-of select="@ad"/>        
      </xsl:element>
      -->
        <xsl:call-template name="LINE">
          <xsl:with-param name="pwd" select="self::node()"/>
        </xsl:call-template>
      </xsl:element>
    </xsl:if>
  </xsl:template>
  <xsl:template match="month">
    <xsl:element name="tr">
      <xsl:element name="th">
        <xsl:attribute name="colspan">
          <xsl:value-of select="count($id_cols)"/>
        </xsl:attribute>
        <!-- label -->
        <xsl:element name="a">
          <xsl:attribute name="id">
            <xsl:text>m</xsl:text>
            <xsl:value-of select="../@ad"/>
            <xsl:value-of select="@nr"/>
          </xsl:attribute>
        </xsl:element>
        <xsl:element name="center">
          <xsl:value-of select="@name"/>
          <xsl:text> / </xsl:text>
          <xsl:value-of select="../@ad"/>
        </xsl:element>
        <!-- next -->
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:text>#</xsl:text>
            <xsl:text>m</xsl:text>
            <xsl:value-of select="parent::year/attribute::ad"/>
            <xsl:value-of select="following-sibling::month/attribute::nr"/>
          </xsl:attribute>
          <xsl:text>next</xsl:text>
        </xsl:element>
      </xsl:element>
    </xsl:element>
    <!-- -->
    <xsl:apply-templates select="day"/>
    <!-- -->
    <xsl:if test="col">
      <xsl:element name="tr">
        <!--
      <xsl:element name="td">
        <xsl:value-of select="@name"/>        
      </xsl:element>
      -->
        <xsl:call-template name="LINE">
          <xsl:with-param name="pwd" select="self::node()"/>
        </xsl:call-template>
      </xsl:element>
    </xsl:if>
  </xsl:template>
  <xsl:template match="day">
    <xsl:if test="col[contains($id_cols,@name) and (p or task or target)] or @today">
      <xsl:variable name="own" select="@own"/>
      <xsl:element name="tr">
        <!-- -->
        <xsl:call-template name="LINE">
          <xsl:with-param name="pwd" select="self::node()"/>
          <xsl:with-param name="class">
            <xsl:choose>
              <xsl:when test="descendant::*[@holiday = 'yes']">
                <xsl:text>sat</xsl:text>
              </xsl:when>
              <xsl:when test="@today">
                <xsl:text>today</xsl:text>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="$own"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:with-param>
        </xsl:call-template>
      </xsl:element>
    </xsl:if>
    <!-- week related entries -->
    <xsl:variable name="cw" select="@cw"/>
    <xsl:variable name="pwd_week" select="../../week[@nr = $cw]"/>
    <xsl:if test="number(@ow) = 5 and string($pwd_week)">
      <xsl:element name="tr">
        <!-- 
      <xsl:element name="td">
        <xsl:text>KW</xsl:text>
        <xsl:value-of select="$cw"/>
      </xsl:element>
      -->
        <xsl:call-template name="LINE">
          <xsl:with-param name="pwd" select="$pwd_week"/>
        </xsl:call-template>
      </xsl:element>
    </xsl:if>
  </xsl:template>
  <xsl:template match="p">
    <xsl:choose>
      <xsl:when test="name(parent::node()) = 'list'">
        <!-- list item -->
        <xsl:element name="li">
          <xsl:apply-templates/>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <!-- para -->
        <xsl:element name="p">
          <xsl:apply-templates/>
        </xsl:element>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="task|target|deadline">
    <xsl:element name="p">
      <xsl:choose>
        <xsl:when test="@done">
          <xsl:attribute name="class">done</xsl:attribute>
        </xsl:when>
        <xsl:when test="@prio">
          <xsl:attribute name="class">p<xsl:value-of select="@prio"/></xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
        </xsl:otherwise>
      </xsl:choose>
      <!-- all deadline related -->
      <xsl:if test="name() = 'deadline'">
        <xsl:element name="img">
          <xsl:attribute name="src">
            <xsl:value-of select="concat($dir_icons,'pencil.png')"/>
          </xsl:attribute>
          <xsl:attribute name="alt">
            <xsl:value-of select="name()"/>
          </xsl:attribute>
          <xsl:attribute name="title">
            <xsl:value-of select="name()"/>
          </xsl:attribute>
        </xsl:element>
      </xsl:if>
      <xsl:element name="i">
        <xsl:value-of select="@hstr"/>
      </xsl:element>
      <xsl:if test="name() != 'deadline'">
        <xsl:apply-templates select="h"/>
        <xsl:if test="@effort">
          <xsl:text> / </xsl:text>
          <xsl:value-of select="@effort"/>
        </xsl:if>
        <!--  -->
        <xsl:for-each select="contact">
          <xsl:text> ; </xsl:text>
          <xsl:element name="a">
            <xsl:attribute name="href">
              <xsl:value-of select="$file_ref"/>
              <xsl:text>#</xsl:text>
              <xsl:value-of select="@idref"/>
            </xsl:attribute>
            <xsl:value-of select="@idref"/>
          </xsl:element>
        </xsl:for-each>
        <!--  -->
      </xsl:if>
    </xsl:element>
  </xsl:template>
  <xsl:template name="LINE">
    <xsl:param name="pwd"/>
    <xsl:param name="class">summary</xsl:param>
    <xsl:for-each select="$id_cols">
      <xsl:variable name="id_col" select="."/>
      <xsl:element name="td">
        <xsl:attribute name="class">
          <!-- set class of cells -->
          <xsl:choose>
            <xsl:when test="$pwd/col[@name=$id_col]/*[@free = 'yes']">
              <xsl:text>sat</xsl:text>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$class"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:attribute>
        <!-- today anchor -->
        <xsl:if test="$pwd/@today and position() = 1">
          <xsl:element name="a">
            <xsl:attribute name="id">
              <xsl:text>today</xsl:text>
            </xsl:attribute>
          </xsl:element>
        </xsl:if>
        <xsl:apply-templates select="$pwd/col[@name=$id_col]/*">
          <xsl:sort select="@hstr"/>
          <xsl:sort select="."/>
        </xsl:apply-templates>
      </xsl:element>
    </xsl:for-each>
  </xsl:template>
  <xsl:template name="NAVI">
    <xsl:variable name="nextDay">
      <!-- day value for next button -->
      <xsl:choose>
        <xsl:when test="$context='Day' and $nowDay &gt; 364">
          <xsl:value-of select="1"/>
        </xsl:when>
        <xsl:when test="$context='Day'">
          <xsl:value-of select="$nowDay+1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$nowDay"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="nextWeek">
      <!-- week value for next button -->
      <xsl:choose>
        <xsl:when test="$context='Week' and $nowWeek &gt; 50">
          <xsl:value-of select="1"/>
        </xsl:when>
        <xsl:when test="$context='Week'">
          <xsl:value-of select="$nowWeek+1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$nowWeek"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="nextMonth">
      <!-- month value for next button -->
      <xsl:choose>
        <xsl:when test="$context='Month' and $nowMonth &gt; 11">
          <xsl:value-of select="1"/>
        </xsl:when>
        <xsl:when test="$context='Month'">
          <xsl:value-of select="$nowMonth+1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$nowMonth"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="nextYear">
      <!-- year value for next button -->
      <xsl:choose>
        <xsl:when test="$context='Year' or ($context='Month' and $nowMonth &gt; 11)">
          <xsl:value-of select="$nowYear+1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$nowYear"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="prevDay">
      <!-- day value for prev button -->
      <xsl:choose>
        <xsl:when test="$context='Day' and $nowDay &lt; 2">
          <xsl:value-of select="1"/>
        </xsl:when>
        <xsl:when test="$context='Day'">
          <xsl:value-of select="$nowDay - 1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$nowDay"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="prevWeek">
      <!-- week value for prev button -->
      <xsl:choose>
        <xsl:when test="$context='Week' and $nowWeek &lt; 2">
          <xsl:value-of select="1"/>
        </xsl:when>
        <xsl:when test="$context='Week'">
          <xsl:value-of select="$nowWeek - 1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$nowWeek"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="prevMonth">
      <!-- month value for prev button -->
      <xsl:choose>
        <xsl:when test="$context='Month' and $nowMonth &lt; 2">
          <xsl:value-of select="12"/>
        </xsl:when>
        <xsl:when test="$context='Month'">
          <xsl:value-of select="$nowMonth - 1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$nowMonth"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="prevYear">
      <!-- year value for prev button -->
      <xsl:choose>
        <xsl:when test="$context='Year' or ($context='Month' and $nowMonth &lt; 2)">
          <xsl:value-of select="$nowYear - 1"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$nowYear"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:element name="table">
      <xsl:attribute name="class">formicons</xsl:attribute>
      <xsl:element name="tr">
        <xsl:call-template name="FORMICON">
          <xsl:with-param name="icon">
            <xsl:text>go-previous.png</xsl:text>
          </xsl:with-param>
          <xsl:with-param name="text">
            <xsl:value-of select="concat('Previous ',$context)"/>
          </xsl:with-param>
          <xsl:with-param name="file">
            <xsl:value-of select="$file_cxp"/>
          </xsl:with-param>
          <xsl:with-param name="context">
            <xsl:value-of select="$context"/>
          </xsl:with-param>
          <xsl:with-param name="year">
            <xsl:value-of select="$prevYear"/>
          </xsl:with-param>
          <xsl:with-param name="m">
            <xsl:value-of select="$prevMonth"/>
          </xsl:with-param>
          <xsl:with-param name="d">
            <xsl:value-of select="$prevDay"/>
          </xsl:with-param>
          <xsl:with-param name="w">
            <xsl:value-of select="$prevWeek"/>
          </xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="SEPICONS"/>
        <xsl:call-template name="FORMICON">
          <xsl:with-param name="text">
            <xsl:text>Day</xsl:text>
          </xsl:with-param>
          <xsl:with-param name="file">
            <xsl:value-of select="$file_cxp"/>
          </xsl:with-param>
          <xsl:with-param name="context">
            <xsl:text>Day</xsl:text>
          </xsl:with-param>
          <xsl:with-param name="year">
            <xsl:value-of select="$nowYear"/>
          </xsl:with-param>
          <xsl:with-param name="m">
            <xsl:value-of select="$nowMonth"/>
          </xsl:with-param>
          <xsl:with-param name="d">
            <xsl:value-of select="$nowDay"/>
          </xsl:with-param>
          <xsl:with-param name="w">
            <xsl:value-of select="$nowWeek"/>
          </xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="FORMICON">
          <xsl:with-param name="text">
            <xsl:text>Month</xsl:text>
          </xsl:with-param>
          <xsl:with-param name="file">
            <xsl:value-of select="$file_cxp"/>
          </xsl:with-param>
          <xsl:with-param name="context">
            <xsl:text>Month</xsl:text>
          </xsl:with-param>
          <xsl:with-param name="year">
            <xsl:value-of select="$nowYear"/>
          </xsl:with-param>
          <xsl:with-param name="m">
            <xsl:value-of select="$nowMonth"/>
          </xsl:with-param>
          <xsl:with-param name="d">
            <xsl:value-of select="$nowDay"/>
          </xsl:with-param>
          <xsl:with-param name="w">
            <xsl:value-of select="$nowWeek"/>
          </xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="FORMICON">
          <xsl:with-param name="text">
            <xsl:text>Year</xsl:text>
          </xsl:with-param>
          <xsl:with-param name="file">
            <xsl:value-of select="$file_cxp"/>
          </xsl:with-param>
          <xsl:with-param name="context">
            <xsl:text>Year</xsl:text>
          </xsl:with-param>
          <xsl:with-param name="year">
            <xsl:value-of select="$nowYear"/>
          </xsl:with-param>
          <xsl:with-param name="m">
            <xsl:value-of select="$nowMonth"/>
          </xsl:with-param>
          <xsl:with-param name="d">
            <xsl:value-of select="$nowDay"/>
          </xsl:with-param>
          <xsl:with-param name="w">
            <xsl:value-of select="$nowWeek"/>
          </xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="SEPICONS"/>
        <xsl:call-template name="FORMICON">
          <xsl:with-param name="icon">
            <xsl:text>go-next.png</xsl:text>
          </xsl:with-param>
          <xsl:with-param name="text">
            <xsl:value-of select="concat('Next ',$context)"/>
          </xsl:with-param>
          <xsl:with-param name="file">
            <xsl:value-of select="$file_cxp"/>
          </xsl:with-param>
          <xsl:with-param name="context">
            <xsl:value-of select="$context"/>
          </xsl:with-param>
          <xsl:with-param name="year">
            <xsl:value-of select="$nextYear"/>
          </xsl:with-param>
          <xsl:with-param name="m">
            <xsl:value-of select="$nextMonth"/>
          </xsl:with-param>
          <xsl:with-param name="d">
            <xsl:value-of select="$nextDay"/>
          </xsl:with-param>
          <xsl:with-param name="w">
            <xsl:value-of select="$nextWeek"/>
          </xsl:with-param>
        </xsl:call-template>
      </xsl:element>
    </xsl:element>
  </xsl:template>
  <xsl:template name="FORMICON">
    <xsl:param name="anchor"/>
    <xsl:param name="icon"/>
    <xsl:param name="text"/>
    <xsl:param name="file"/>
    <xsl:param name="context"/>
    <xsl:param name="year"/>
    <xsl:param name="m"/>
    <xsl:param name="d"/>
    <xsl:param name="w"/>
    <xsl:element name="td">
      <!-- form button -->
      <xsl:attribute name="class">formicon</xsl:attribute>
      <xsl:element name="form">
        <xsl:attribute name="action">
          <xsl:choose>
            <xsl:when test="$anchor=''">
              <xsl:value-of select="concat('#','today')"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="concat('#',$anchor)"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:attribute>
        <xsl:element name="input">
          <xsl:choose>
            <xsl:when test="$icon=''">
              <xsl:attribute name="type">submit</xsl:attribute>
              <xsl:attribute name="value">
                <xsl:value-of select="$text"/>
              </xsl:attribute>
            </xsl:when>
            <xsl:otherwise>
              <xsl:attribute name="type">image</xsl:attribute>
              <xsl:attribute name="src">
                <xsl:value-of select="concat('/cxproc/icons/',$icon)"/>
              </xsl:attribute>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:attribute name="alt">
            <xsl:value-of select="$text"/>
          </xsl:attribute>
          <xsl:attribute name="title">
            <xsl:value-of select="$text"/>
          </xsl:attribute>
        </xsl:element>
        <!-- hidden form input -->
        <xsl:element name="input">
          <xsl:attribute name="type">hidden</xsl:attribute>
          <xsl:attribute name="name">cxp</xsl:attribute>
          <xsl:attribute name="value">cxp</xsl:attribute>
        </xsl:element>
        <xsl:element name="input">
          <xsl:attribute name="type">hidden</xsl:attribute>
          <xsl:attribute name="name">file</xsl:attribute>
          <xsl:attribute name="value">
            <xsl:value-of select="$file"/>
          </xsl:attribute>
        </xsl:element>
        <xsl:element name="input">
          <xsl:attribute name="type">hidden</xsl:attribute>
          <xsl:attribute name="name">context</xsl:attribute>
          <xsl:attribute name="value">
            <xsl:value-of select="$context"/>
          </xsl:attribute>
        </xsl:element>
        <xsl:element name="input">
          <xsl:attribute name="type">hidden</xsl:attribute>
          <xsl:attribute name="name">year</xsl:attribute>
          <xsl:attribute name="value">
            <xsl:value-of select="$year"/>
          </xsl:attribute>
        </xsl:element>
        <xsl:element name="input">
          <xsl:attribute name="type">hidden</xsl:attribute>
          <xsl:attribute name="name">m</xsl:attribute>
          <xsl:attribute name="value">
            <xsl:value-of select="$m"/>
          </xsl:attribute>
        </xsl:element>
        <xsl:element name="input">
          <xsl:attribute name="type">hidden</xsl:attribute>
          <xsl:attribute name="name">d</xsl:attribute>
          <xsl:attribute name="value">
            <xsl:value-of select="$d"/>
          </xsl:attribute>
        </xsl:element>
        <xsl:element name="input">
          <xsl:attribute name="type">hidden</xsl:attribute>
          <xsl:attribute name="name">w</xsl:attribute>
          <xsl:attribute name="value">
            <xsl:value-of select="$w"/>
          </xsl:attribute>
        </xsl:element>
      </xsl:element>
    </xsl:element>
  </xsl:template>
  <xsl:template name="SEPICONS">
    <xsl:element name="td">
      <xsl:attribute name="class">
        <xsl:text>separator</xsl:text>
      </xsl:attribute>
    </xsl:element>
  </xsl:template>
  <xsl:template match="meta|col"/>
</xsl:stylesheet>
