<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output
    omit-xml-declaration='yes'
    encoding="ISO-8859-1"
    method="html" 
    doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"
    media-type="text/html"/>

  <xsl:variable name="year" select="2007"/>

  <xsl:template match="/">
    <xsl:element name="html">
      <xsl:element name="body">
        <xsl:apply-templates/>
      </xsl:element>
    </xsl:element>
  </xsl:template>


  <xsl:template match="/calendar">
    <xsl:apply-templates select="year[@ad = $year]"/>
  </xsl:template>


  <xsl:template match="year">
    <xsl:element name="table">
      <xsl:element name="tbody">
        <xsl:apply-templates select="week"/>
      </xsl:element>
    </xsl:element>
    <p>.</p>
  </xsl:template>


  <xsl:template match="week">
    <xsl:variable name="year_nr" select="ancestor::year/@ad"/>
    <xsl:variable name="week_nr" select="@nr"/>
        <xsl:element name="tr">
          <xsl:element name="th">
            <xsl:element name="p">
              <xsl:text> </xsl:text>
            </xsl:element>
          </xsl:element>
          <xsl:element name="th">
            <xsl:element name="p">
              <xsl:value-of select="$week_nr"/>
              <xsl:text>/</xsl:text>
              <xsl:value-of select="$year_nr"/>
            </xsl:element>
          </xsl:element>
        </xsl:element>
        <xsl:apply-templates select="//day[@cw=$week_nr and ancestor::year/@ad=$year_nr]"/>
  </xsl:template>


  <xsl:template match="day">
    <xsl:element name="tr">
      <xsl:element name="td">
        <xsl:element name="p">
          <xsl:apply-templates select="col//p">
            <xsl:sort select="."/>                               
          </xsl:apply-templates>
        </xsl:element>
      </xsl:element>
      <xsl:element name="td">
        <!-- <xsl:attribute name="valign">top</xsl:attribute> -->
        <xsl:element name="p">
          <xsl:value-of select="@own"/>
          <xsl:text> </xsl:text>
          <xsl:value-of select="@om"/>
          <xsl:text>.</xsl:text>
          <xsl:value-of select="../@nr"/>
          <xsl:text>.</xsl:text>
        </xsl:element>
      </xsl:element>
    </xsl:element>
  </xsl:template>


  <xsl:template match="p">
    <xsl:copy-of select="."/>
  </xsl:template>

</xsl:stylesheet>
