<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

<xsl:output method='xml' doctype-system="../xml/pie.dtd" version='1.0' encoding='ISO-8859-1'/>

  <!--  -->

  <xsl:template match="/">
  <!-- 
    <xsl:processing-instruction name="xml-stylesheet">
      <xsl:text>href="../xml/xsl/pie2html.xsl" type="text/xsl"</xsl:text>
    </xsl:processing-instruction>
 -->
    <xsl:element name="pie">
      <xsl:apply-templates/> 
    </xsl:element>
  </xsl:template>
      
  <xsl:template match="title|h1|h2|h3|h4">
    <xsl:element name="section">
      <xsl:element name="h">
        <xsl:value-of select="."/>
      </xsl:element>
      <!-- 
      <xsl:apply-templates select="following-sibling::*"/> 
      -->
    </xsl:element>
  </xsl:template>

  <xsl:template match="a[@href]">
    <xsl:element name="link">
      <xsl:attribute name="ref">
        <xsl:value-of select="@href"/>
      </xsl:attribute>
      <xsl:value-of select="."/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="p|li|div|th|td|center">
    <xsl:choose>
      <xsl:when test="child::p">
        <xsl:apply-templates/> 
      </xsl:when>
      <xsl:otherwise>
        <xsl:element name="p">
          <xsl:apply-templates/> 
        </xsl:element>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
      
  <xsl:template match="em|it|tt|strong|u|b">
    <xsl:apply-templates/> 
  </xsl:template>
      
  <xsl:template match="img">
    <xsl:element name="fig">
      <xsl:element name="img">
        <xsl:attribute name="src">
          <xsl:value-of select="@src"/>
        </xsl:attribute>
      </xsl:element>
      <xsl:if test="not(@alt='')">
        <xsl:element name="h">
          <xsl:value-of select="@alt"/>
        </xsl:element>
      </xsl:if>
    </xsl:element>
  </xsl:template>
      
  <xsl:template match="script">
    <!-- ignore -->
  </xsl:template>
      
  <xsl:template match="ul|ol">
    <xsl:element name="list">
      <xsl:apply-templates/> 
    </xsl:element>
  </xsl:template>
      
  <xsl:template match="*">
    <!-- ignore -->
    <xsl:apply-templates/> 
  </xsl:template>
      
</xsl:stylesheet>
