<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:import href="PieHtml.xsl"/>

  <!-- -->
  <xsl:variable name="file_css" select="'pie.css'"/>
  <!-- name of plain input file -->
  <xsl:variable name="file_plain" select="''"/>

  <xsl:variable name="file_ref" select="'../../tmp/TodoContactTable.html'"/>
  <!-- cancel tree -->
  <xsl:variable name="flag_tree" select="true()"/>
  <!--  -->
  <xsl:variable name="flag_header" select="true()"/>
  <!--  -->
  <xsl:variable name="flag_fig" select="true()"/>
  <!--  -->
  <xsl:variable name="str_write"  select="''"/>
  <!--  -->
  <xsl:variable name="length_link" select="-1"/>
  <!--  -->
  <xsl:variable name="flag_form" select="false()"/>
  <!--  -->
  <xsl:variable name="level_hidden" select="0"/>
  <!-- flag for captions of slides -->
  <xsl:variable name="flag_slidecap" select="true()"/>

  <xsl:variable name="flag_tags"  select="false()"/>
  <xsl:variable name="str_tag"  select="''"/>

  <xsl:output 
    method="html"
    omit-xml-declaration="no"
    doctype-public="-//W3C//DTD HTML 4.01//EN"
    doctype-system="file:///tmp/dummy.dtd" />

  <xsl:template match="/">
    <xsl:choose>
      <xsl:when test="$flag_tags">
        <xsl:element name="html">
          <xsl:call-template name="HEADER"/>
          <xsl:element name="body">
            <xsl:if test="$flag_form">
              <xsl:call-template name="PIEFORM"/>
            </xsl:if>
            <xsl:call-template name="PIETAGCLOUD"/>
            <xsl:if test="$flag_form">
              <xsl:call-template name="PIEFORM"/>
            </xsl:if>
          </xsl:element>
        </xsl:element>
      </xsl:when>
      <xsl:when test="$flag_header">
        <xsl:element name="html">
          <xsl:call-template name="HEADER"/>
          <xsl:element name="body">
            <xsl:if test="$flag_form">
              <xsl:call-template name="PIEFORM"/>
            </xsl:if>
            <xsl:apply-templates/>
            <xsl:if test="$flag_form">
              <xsl:call-template name="PIEFORM"/>
            </xsl:if>
          </xsl:element>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <xsl:element name="body">
          <xsl:apply-templates/>
        </xsl:element>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="*[@valid='no']">
    <!-- ignore this elements -->
  </xsl:template>

  <xsl:template match="meta">
    <!-- ignore this elements -->
  </xsl:template>

  <xsl:template name="PIETAGCLOUD">
    <!--  -->
    <xsl:variable name="int_space" select="5"/>
    <xsl:element name="p">
      <xsl:for-each select="pie/meta/tags/word[@count]">
        <xsl:sort order="ascending" data-type="text" select="translate(.,'ABCDEFGHIJKLMNOPQRSTUVWXYZ','abcdefghijklmnopqrstuvwxyz')"/>
        <xsl:sort order="descending" data-type="number" select="@count"/>
        <xsl:element name="a">
          <xsl:attribute name="style">
            <xsl:value-of select="concat('font-size:',(80+@count*10),'%;')"/>
            <xsl:value-of select="concat('margin:',(@count*$int_space),'px ',(@count*$int_space),'px ',(@count*$int_space),'px ',(@count*$int_space),'px ',';')"/>
          </xsl:attribute>
          <xsl:if test="@count">
            <xsl:attribute name="title">
              <xsl:value-of select="concat(@count,' x ',.)"/>
            </xsl:attribute>
          </xsl:if>
          <xsl:attribute name="href">
            <xsl:text>?</xsl:text>
            <xsl:value-of select="concat('file=',$file_plain)"/>
            <xsl:value-of select="concat('&amp;','cxp=','articleTags')"/>
            <xsl:value-of select="concat('&amp;','str_tag=',.)"/>
            <xsl:text>#result</xsl:text>
          </xsl:attribute>
          <xsl:value-of select="concat(.,' ')"/>
        </xsl:element>
      </xsl:for-each>
    </xsl:element>
    <xsl:if test="string-length($str_tag) &gt; 0">
      <hr/>
      <xsl:element name="dl">
        <xsl:element name="dt">
          <xsl:element name="a">
            <xsl:attribute name="name">result</xsl:attribute>
            <xsl:for-each select="pie/meta/tags//word[contains(.,$str_tag)]">
              <xsl:value-of select="concat(.,' ')"/>
            </xsl:for-each>
          </xsl:element>
        </xsl:element>
        <xsl:for-each select="descendant::text()[not(name(parent::node())='word') and contains(.,$str_tag)]">
          <xsl:element name="dt">
            <xsl:for-each select="ancestor::node()">
              <xsl:choose>
                <xsl:when test="name(.)='pie'"/>
                <xsl:when test="name(.)='section'">
                  <xsl:value-of select="concat(' / ',h)"/>
                </xsl:when>
                <xsl:otherwise>
                  <xsl:value-of select="concat(' / ',name(.))"/>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:for-each>
          </xsl:element>
          <xsl:element name="dd">
            <xsl:call-template name="TAGMARKUP">
              <xsl:with-param name="str_mark">
                <xsl:value-of select="."/>
              </xsl:with-param>
            </xsl:call-template>
          </xsl:element>
        </xsl:for-each>
      </xsl:element>
    </xsl:if>
  </xsl:template>

  <xsl:template name="TAGMARKUP">
    <xsl:param name="str_mark"/>

    <xsl:variable name="str_tail" select="substring-after($str_mark,$str_tag)"/>

    <xsl:choose>
      <xsl:when test="contains($str_mark,$str_tag)">
        <xsl:value-of select="substring-before($str_mark,$str_tag)"/>
        <xsl:element name="a">
          <xsl:attribute name="class">datum</xsl:attribute>
          <xsl:value-of select="$str_tag"/>
        </xsl:element>
        <xsl:if test="string-length($str_tail) &gt; 0">
          <xsl:call-template name="TAGMARKUP">
            <!-- recursive call -->
            <xsl:with-param name="str_mark">
              <xsl:value-of select="$str_tail"/>
            </xsl:with-param>
          </xsl:call-template>
        </xsl:if>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$str_mark"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>
