<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:import href="Link.xsl"/>

  <xsl:output method='html' doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"/>

  <xsl:template match="/">
    <xsl:element name="html">
      <!--
      <xsl:element name="head">
        <xsl:element name="title">
          <xsl:value-of select="node/@text"/>
        </xsl:element>
      </xsl:element>
      -->
      <xsl:element name="body">
        <xsl:apply-templates/>
      </xsl:element>
    </xsl:element>
  </xsl:template>

  <xsl:template match="pie">
    <xsl:element name="ul">
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="section">
    <xsl:element name="li">
      <xsl:apply-templates select="h"/>
      <xsl:element name="ul">
        <xsl:apply-templates select="*[not(name(.) = 'h')]"/>
      </xsl:element>
    </xsl:element>
  </xsl:template>

  <xsl:template match="h">
    <xsl:choose>
      <xsl:when test="@ref">
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:value-of select="@ref"/>
          </xsl:attribute>
          <xsl:value-of select="."/>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template match="list">
    <xsl:if test="child::node()">
      <xsl:choose>
        <xsl:when test="@enum = 'yes'">
          <!-- numerated list -->
          <xsl:element name="ol">
            <xsl:apply-templates/>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <!-- para -->
          <xsl:element name="ul">
            <xsl:apply-templates/>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
  </xsl:template>
 
  <xsl:template match="p">
    <!-- para -->
    <xsl:element name="li">
      <xsl:element name="p">
        <xsl:apply-templates/>
      </xsl:element>
    </xsl:element>
  </xsl:template>

  <xsl:template match="*">
    <xsl:apply-templates/>
  </xsl:template>

</xsl:stylesheet>
