<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:import href="PieHtml.xsl"/>

  <!-- -->
  <xsl:variable name="file_css" select="'/share/News/news.css'"/>
  <!-- name of plain input file -->
  <xsl:variable name="file_plain" select="''"/>

  <xsl:variable name="file_ref" select="'../../tmp/TodoContactTable.html'"/>
  <!-- cancel tree -->
  <xsl:variable name="flag_tree" select="false()"/>
  <!--  -->
  <xsl:variable name="flag_header" select="true()"/>
  <!--  -->
  <xsl:variable name="flag_fig" select="true()"/>
  <!--  -->
  <xsl:variable name="length_link" select="-1"/>
  <!--  -->
  <xsl:variable name="flag_form" select="false()"/>
  <!--  -->
  <xsl:variable name="level_hidden" select="0"/>
  <!-- flag for captions of slides -->
  <xsl:variable name="flag_slidecap" select="true()"/>

  <xsl:output 
    method="html"
    omit-xml-declaration="no"
    doctype-public="-//W3C//DTD HTML 4.01//EN"
    doctype-system="file:///tmp/dummy.dtd" />

  <xsl:template match="/">
        <xsl:element name="html">
          <xsl:call-template name="HEADER"/>
          <xsl:element name="body">
        <xsl:element name="table">
<xsl:attribute name="class">unlined</xsl:attribute>
<xsl:attribute name="width">80%</xsl:attribute>
            <xsl:apply-templates/>
        </xsl:element>
          </xsl:element>
        </xsl:element>
  </xsl:template>

  <xsl:template match="section">
    <!--  -->
        <xsl:element name="tr">
        <xsl:element name="th">
            <xsl:apply-templates select="h"/>
        </xsl:element>
        </xsl:element>

    <xsl:choose>
      <xsl:when test="list">
<xsl:for-each select="list/p">
        <xsl:element name="tr">
        <xsl:element name="td">
        <xsl:element name="a">
<xsl:attribute name="title">
<xsl:value-of select="text()"/>
</xsl:attribute>
<xsl:attribute name="href">
<xsl:value-of select="link/@href"/>
</xsl:attribute>
<xsl:value-of select="link"/>
<!--
            <xsl:apply-templates select="link"/>
        <xsl:element name="br"/>
<xsl:value-of select="substring(text(),0,120)"/>
-->
        </xsl:element>
        </xsl:element>
        </xsl:element>
</xsl:for-each>
      </xsl:when>
      <xsl:otherwise>
        <xsl:element name="tr">
        <xsl:element name="td">
            <xsl:apply-templates/>
        </xsl:element>
        </xsl:element>
      </xsl:otherwise>
    </xsl:choose>


  </xsl:template>

  <xsl:template match="*[@valid='no']">
    <!-- ignore this elements -->
  </xsl:template>

  <xsl:template match="meta|fig">
    <!-- ignore this elements -->
  </xsl:template>

</xsl:stylesheet>
