<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

<xsl:output method="xml"/>  

<!--  -->

<xsl:template match="@*|node()">
  <xsl:choose>
    <!--  -->
    <xsl:when test="(self::task or self::target)">
      <xsl:element name="{name()}">
        <!--  -->
        <xsl:variable name="nodeset_section_date" select="ancestor::section[@date]"/>
        <xsl:if test="not(@date) and count($nodeset_section_date) &gt; 0"> 
          <xsl:copy-of select="$nodeset_section_date[position()=last()]/@date"/>
        </xsl:if>
        <!--  -->
        <xsl:variable name="nodeset_section_done" select="ancestor::section[@done]"/>
        <xsl:if test="not(@done) and count($nodeset_section_done) &gt; 0"> 
          <xsl:copy-of select="$nodeset_section_done[position()=last()]/@done"/>
        </xsl:if>
        <!--  -->
        <xsl:copy-of select="@*|child::node()"/>
      </xsl:element>
    </xsl:when>
    <!--  -->
    <xsl:otherwise>
      <xsl:copy>
        <xsl:apply-templates select="@*|node()"/>
      </xsl:copy>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>
      
</xsl:stylesheet>
