<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

  <xsl:import href="../PieHtml.xsl"/>

  <xsl:variable name="file_css" select="'pie.css'"/>

  <xsl:variable name="file_ref" select="'TodoContactTable.html'"/>
  <!--  -->
  <xsl:variable name="level_hidden" select="0"/>

  <xsl:output method='html' encoding='ISO-8859-1'/>

  <xsl:include href="../../Utils.xsl"/>

<!-- index with all contact in valid structures where parent task is not @done -->
<xsl:key name="listcontact" match="contact[not(@idref='') and parent::task[not(@done)]]" use="@idref"/>

<xsl:template match="/">
  <xsl:element name="html">
    <xsl:call-template name="HEADER"/>
    <xsl:element name="body">
      <xsl:call-template name="PIECONTACT">
      </xsl:call-template>
    </xsl:element>
  </xsl:element>
</xsl:template>


<!-- ignore all elements with an id and valid="no" -->
<xsl:template name="PIECONTACT">
<!--  <xsl:variable name="set_contact"
    select="document(document(pie/@CONFIG)//INCLUDE/@file)/pie//contact[generate-id(.) = generate-id(key('listcontact',@idref))]"/>
       -->
<xsl:variable name="set_contact"
    select="/pie//contact[generate-id(.) = generate-id(key('listcontact',@idref))]"/>
  <!-- Contact links -->
  <xsl:for-each select="$set_contact">
    <xsl:sort select="@idref"/>
    <xsl:element name="a">
      <xsl:attribute name="href">
        <xsl:text>#</xsl:text>
        <xsl:value-of select="@idref"/>
      </xsl:attribute>
      <xsl:value-of select="@idref"/>
    </xsl:element>
    <xsl:text> / </xsl:text>
  </xsl:for-each>
  <!-- count contact -->
  <xsl:element name="a">
    <xsl:value-of select="count($set_contact)"/>
    <xsl:text> Kontakte</xsl:text>
  </xsl:element>
  <xsl:element name="hr"/>
  <!-- Contact/Todo lists -->
  <xsl:for-each select="$set_contact">
    <xsl:sort select="@idref"/>
    <!-- Contact/Vcard -->
    <!--
    <xsl:call-template name="VCSHORT">
      <xsl:with-param name="id_vc" select="@idref"/>
    </xsl:call-template>
    --> 
    <xsl:element name="p">
      <xsl:element name="b">
        <xsl:element name="a">
          <xsl:attribute name="name">
            <xsl:value-of select="@idref"/>
          </xsl:attribute>
          <xsl:value-of select="@idref"/>
        </xsl:element>
      </xsl:element>
    </xsl:element>
    <xsl:element name="ol">
      <xsl:for-each select="key('listcontact',@idref)">
        <xsl:if test="not(../@done)">
          <xsl:element name="li">
            <xsl:if test="../@prio">
              <xsl:attribute name="class">
                <xsl:text>p</xsl:text>
                <xsl:value-of select="../@prio"/>
              </xsl:attribute>
            </xsl:if>
            <xsl:element name="i">
              <xsl:for-each select="ancestor::section">
                <xsl:value-of select="h"/>
                <xsl:text> :: </xsl:text>
              </xsl:for-each>
            </xsl:element>
            <xsl:text> </xsl:text>
            <xsl:value-of select="../h"/>
            <xsl:if test="../@effort">
              <xsl:text> / </xsl:text>
              <xsl:value-of select="../@effort"/>
            </xsl:if>
            <xsl:if test="../@date">
              <xsl:text> / </xsl:text>
              <xsl:value-of select="../@date"/>
            </xsl:if>
          </xsl:element>
        </xsl:if>
      </xsl:for-each>
    </xsl:element>
  </xsl:for-each>
</xsl:template>

<xsl:template name="VCSHORT">
  <xsl:param name="id_vc"/>
  <xsl:if test="string-length($id_vc) &gt; 0">
    <xsl:variable name="node_vcard" select="document('../../kontakte/funktion.pie')//vcard[@id=$id_vc]"/>
    <xsl:element name="p">
      <xsl:element name="b">
        <xsl:element name="a">
          <xsl:attribute name="name">
            <xsl:value-of select="$id_vc"/>
          </xsl:attribute>
          <!--
          <xsl:attribute name="href">http://wwwv1.htm</xsl:attribute>
          --> 
          <xsl:value-of select="$id_vc"/>
        </xsl:element>
      </xsl:element>
      <xsl:text> </xsl:text>
      <xsl:value-of select="$node_vcard/phone/work"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="$node_vcard/name"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="$node_vcard/firstname"/>
    </xsl:element>
  </xsl:if>
</xsl:template>

</xsl:stylesheet>




