<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:import href="../PieHtml.xsl"/>

  <xsl:variable name="file_css" select="'pie.css'"/>
  <!-- name of plain input file -->
  <xsl:variable name="file_plain" select="''"/>

  <xsl:variable name="file_ref" select="'TodoContactTable.html'"/>
  <!--  -->
  <xsl:variable name="level_hidden" select="0"/>

  <!-- cancel tree -->
  <xsl:variable name="flag_tree" select="false()"/>
  <!--  -->
  <xsl:variable name="flag_form" select="false()"/>
  <!--  -->
  <xsl:variable name="str_write"  select="''"/>

  <xsl:output method='html'/>

  <xsl:include href="../../Utils.xsl"/>

<xsl:template match="/">
  <xsl:element name="html">
    <xsl:call-template name="HEADER"/>
    <xsl:element name="body">
      <xsl:if test="$flag_form">
        <xsl:call-template name="PIEFORM"/>
      </xsl:if>
      <xsl:if test="$flag_tree">
        <xsl:call-template name="TREE"/>
        <hr/>
      </xsl:if>
      <xsl:element name="table">
        <xsl:attribute name="class">
          <xsl:value-of select="name(.)"/>
        </xsl:attribute>
        <xsl:attribute name="border">
          <xsl:text>0</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="cellspacing">
          <xsl:text>1</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="width">
          <xsl:text>90%</xsl:text>
        </xsl:attribute>
        <xsl:element name="tbody">
          <xsl:element name="tr">
            <xsl:element name="th">
              <xsl:attribute name="colspan">
                <xsl:text>3</xsl:text>
              </xsl:attribute>
              <xsl:element name="b">
                <xsl:text>TODO</xsl:text>
              </xsl:element>
            </xsl:element>
          </xsl:element>
          <xsl:apply-templates select="pie"/>
        </xsl:element>
      </xsl:element>
      <xsl:if test="$flag_form">
        <xsl:call-template name="PIEFORM"/>
      </xsl:if>
    </xsl:element>
  </xsl:element>
</xsl:template>


<xsl:template name="XTREE">
  <xsl:element name="pre">
    <xsl:for-each select="//section">
      <xsl:for-each select="ancestor-or-self::section">
        <xsl:text>    </xsl:text>
      </xsl:for-each>
      <xsl:value-of select="h"/>
      <xsl:text>
</xsl:text>
    </xsl:for-each>
  </xsl:element>
</xsl:template>


<xsl:template match="section">
  <xsl:if test="not(@valid = 'no')">
    <xsl:if test="count(ancestor-or-self::section) &lt; 2 or child::task[not(@done) and not(@valid = 'no')]">
      <xsl:element name="tr">
        <xsl:element name="th">
          <xsl:if test="count(ancestor-or-self::section) &lt; 2">
            <xsl:attribute name="class">transition</xsl:attribute>
          </xsl:if>
          <xsl:attribute name="colspan">
            <xsl:text>3</xsl:text>
          </xsl:attribute>
          <xsl:for-each select="ancestor-or-self::section">
            <xsl:if test="child::h">
              <xsl:value-of select="h"/>
              <xsl:text> :: </xsl:text>
            </xsl:if>
          </xsl:for-each>
        </xsl:element>
      </xsl:element>
      <xsl:element name="tr">
        <xsl:element name="td">
          <xsl:apply-templates select="task"/>
        </xsl:element>
      </xsl:element>
    </xsl:if>
    <xsl:if test="child::section">
      <xsl:apply-templates select="section"/>
    </xsl:if>
  </xsl:if>
</xsl:template>


<xsl:template match="task">
  <xsl:if test="not(@done) and not(@valid = 'no')">
    <xsl:element name="p">
      <xsl:choose>
        <xsl:when test="@done">
          <xsl:attribute name="class">done</xsl:attribute>
        </xsl:when>
        <xsl:when test="@prio">
          <xsl:attribute name="class">p<xsl:value-of select="@prio"/></xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
        </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="h"/>
      <xsl:if test="@effort">
        <xsl:text> / </xsl:text>
        <xsl:value-of select="@effort"/>
      </xsl:if>
      <xsl:if test="@date">
        <xsl:text> / </xsl:text>
        <xsl:value-of select="@date"/>
      </xsl:if>
      <xsl:for-each select="contact">
        <xsl:text> / </xsl:text>
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:value-of select="$file_ref"/>
            <xsl:text>#</xsl:text>
            <xsl:value-of select="@idref"/>
          </xsl:attribute>
          <xsl:value-of select="@idref"/>
        </xsl:element>
      </xsl:for-each>
    </xsl:element>
  </xsl:if>
</xsl:template>


<xsl:template match="contact">
  <!-- list item -->
  <xsl:value-of select="@idref"/>
  <xsl:text> / </xsl:text>
</xsl:template>


</xsl:stylesheet>
