<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:import href="../PieHtml.xsl"/>

  <xsl:variable name="file_css" select="'pie.css'"/>

  <xsl:variable name="file_ref" select="'TodoContactTable.html'"/>
  <!--  -->
  <xsl:variable name="level_hidden" select="0"/>

  <xsl:output method='html' encoding='ISO-8859-1'/>

  <xsl:include href="../../Utils.xsl"/>

<!-- cancel tree -->
<xsl:variable name="flag_tree" select="false()"/>

<xsl:template match="/">
  <xsl:element name="html">
    <xsl:call-template name="HEADER"/>
    <xsl:element name="body">
      <xsl:element name="table">
        <xsl:attribute name="class">
          <xsl:value-of select="name(.)"/>
        </xsl:attribute>
        <xsl:attribute name="border">
          <xsl:text>0</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="cellspacing">
          <xsl:text>1</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="width">
          <xsl:text>90%</xsl:text>
        </xsl:attribute>
        <xsl:element name="tbody">
          <!--  -->
          <xsl:call-template name="BLOCK">
            <xsl:with-param name="nodes" select="//task[@state='mail' and not(@done)]"/>
            <xsl:with-param name="header">TODO E-Mail</xsl:with-param>
          </xsl:call-template>
          <!--  -->
          <xsl:call-template name="BLOCK">
            <xsl:with-param name="nodes" select="//task[@state='phone' and not(@done)]"/>
            <xsl:with-param name="header">TODO Phone</xsl:with-param>
          </xsl:call-template>
          <!--  -->
          <xsl:call-template name="BLOCK">
            <xsl:with-param name="nodes" select="//task[@state='transfer' and not(@done)]"/>
            <xsl:with-param name="header">TODO Transfer</xsl:with-param>
          </xsl:call-template>
          <!--  -->
          <xsl:call-template name="BLOCK">
            <xsl:with-param name="nodes" select="//task[@state='progress' and not(@done)]"/>
            <xsl:with-param name="header">TODO Progress</xsl:with-param>
          </xsl:call-template>
          <!--  -->
          <xsl:call-template name="BLOCK">
            <xsl:with-param name="nodes" select="//task[@state='meeting' and not(@done)]"/>
            <xsl:with-param name="header">TODO Meeting</xsl:with-param>
          </xsl:call-template>
          <!--  -->
          <xsl:call-template name="BLOCK">
            <xsl:with-param name="nodes" select="//task[@state='program' and not(@done)]"/>
            <xsl:with-param name="header">TODO Programming</xsl:with-param>
          </xsl:call-template>
        </xsl:element>
      </xsl:element>
    </xsl:element>
  </xsl:element>
</xsl:template>

<xsl:template name="BLOCK">
  <xsl:param name="header">TODO</xsl:param>
  <xsl:param name="nodes"/>
  <!--  -->
  <xsl:element name="tr">
    <xsl:element name="th">
      <xsl:element name="b">
      <xsl:value-of select="$header"/>
      </xsl:element>
    </xsl:element>
  </xsl:element>
  <xsl:element name="tr">
    <xsl:element name="td">
      <xsl:apply-templates select="$nodes"/>
    </xsl:element>
  </xsl:element>
</xsl:template>

<xsl:template match="task">
  <xsl:element name="p">
    <xsl:choose>
      <xsl:when test="../../@today='yes'">
        <!-- today message ?? -->
        <xsl:attribute name="class">today</xsl:attribute>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="class">p<xsl:value-of select="@prio"/></xsl:attribute>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:element name="i">
      <xsl:value-of select="@hstr"/>
    </xsl:element>
    <xsl:choose>
      <xsl:when test="h/@ref">
        <!-- a -->
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:value-of select="h/@ref"/>
          </xsl:attribute>
          <xsl:value-of select="h"/>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <!--  -->
        <xsl:value-of select="h"/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:if test="@effort">
      <xsl:text> / </xsl:text>
      <xsl:value-of select="@effort"/>
    </xsl:if>
    <xsl:if test="@date">
      <xsl:text> / </xsl:text>
      <xsl:value-of select="@date"/>
    </xsl:if>
    <xsl:for-each select="contact">
      <xsl:text> / </xsl:text>
      <xsl:element name="a">
        <xsl:attribute name="href">
          <xsl:value-of select="$file_ref"/>
          <xsl:text>#</xsl:text>
          <xsl:value-of select="@idref"/>
        </xsl:attribute>
        <xsl:value-of select="@idref"/>
      </xsl:element>
    </xsl:for-each>
  </xsl:element>
</xsl:template>


<xsl:template match="contact">
  <!-- list item -->
  <xsl:value-of select="@idref"/>
  <xsl:text> / </xsl:text>
</xsl:template>

<xsl:template match="*"/>

</xsl:stylesheet>
