<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="text" encoding="UTF-8"/>
  <xsl:variable name="newline">
    <xsl:text>
</xsl:text>
  </xsl:variable>
  <xsl:variable name="newpar">
    <xsl:text>
</xsl:text>
  </xsl:variable>
  <xsl:template match="/">
    <xsl:apply-templates/>
  </xsl:template>
  <xsl:template match="pie">
    <xsl:apply-templates/>
  </xsl:template>
  <xsl:template match="section">
    <xsl:value-of select="$newpar"/>
    <xsl:for-each select="ancestor-or-self::section">
      <xsl:text>=</xsl:text>
    </xsl:for-each>
    <xsl:text> </xsl:text>
    <xsl:value-of select="normalize-space(h)"/>
    <xsl:text> </xsl:text>
    <xsl:for-each select="ancestor-or-self::section">
      <xsl:text>=</xsl:text>
    </xsl:for-each>
    <xsl:value-of select="$newpar"/>
    <xsl:apply-templates select="*[not(name(.) = 'h')]"/>
  </xsl:template>
  <xsl:template match="list">
    <xsl:if test="child::node()">
      <xsl:apply-templates select="p"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="target|task">
    <xsl:value-of select="$newpar"/>
    <xsl:value-of select="normalize-space(h)"/>
    <xsl:apply-templates select="*[not(name(.) = 'h')]"/>
  </xsl:template>
  <xsl:template match="list">
    <xsl:if test="child::node()">
      <xsl:apply-templates select="p"/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="p">
    <xsl:choose>
      <xsl:when test="name(parent::node()) = 'list'">
        <!-- list item -->
        <xsl:choose>
          <xsl:when test="@enum = 'yes'">
            <!-- numerated list -->
            <xsl:for-each select="ancestor::list">
              <xsl:text>#</xsl:text>
            </xsl:for-each>
          </xsl:when>
          <xsl:otherwise>
            <!-- para -->
            <xsl:for-each select="ancestor::list">
              <xsl:text>*</xsl:text>
            </xsl:for-each>
          </xsl:otherwise>
        </xsl:choose>
        <xsl:text> </xsl:text>
        <xsl:apply-templates/>
      </xsl:when>
      <xsl:otherwise>
        <!-- para -->
        <xsl:value-of select="normalize-space(.)"/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:value-of select="$newline"/>
  </xsl:template>
  <xsl:template match="img">
    <xsl:value-of select="@src"/>
  </xsl:template>
  <xsl:template match="fig">
    <xsl:text>Abb. </xsl:text>
    <xsl:value-of select="img/@src"/>
    <xsl:if test="h">
      <xsl:text>: </xsl:text>
      <xsl:value-of select="h"/>
    </xsl:if>
    <xsl:value-of select="$newpar"/>
  </xsl:template>
  <xsl:template match="pre">
    <xsl:value-of select="concat($newline,'&lt;','code','&gt;')"/>
    <xsl:copy-of select="text()"/>
    <xsl:value-of select="concat('&lt;','/code','&gt;',$newpar)"/>
  </xsl:template>
  <xsl:template match="*"/>
</xsl:stylesheet>
