<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="text"/>

<xsl:variable name="newpar">
<xsl:text>

</xsl:text>
</xsl:variable>

  <xsl:template match="/">
    <xsl:apply-templates/>
  </xsl:template>


  <xsl:template match="pie">
    <xsl:apply-templates/>
  </xsl:template>


  <xsl:template match="h">
    <xsl:for-each select="ancestor::section">
      <xsl:text>*</xsl:text>
    </xsl:for-each>
    <xsl:text> </xsl:text>
    <xsl:apply-templates select="h"/>
    <xsl:choose>
      <xsl:when test="@ref">
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:value-of select="@ref"/>
          </xsl:attribute>
          <xsl:value-of select="."/>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:value-of select="$newpar"/>
  </xsl:template>
  

  <xsl:template match="section">
    <xsl:apply-templates select="h"/>
    <xsl:apply-templates select="*[not(name(.) = 'h')]"/>
  </xsl:template>


  <xsl:template match="task">
    <!-- valid task element -->
      <xsl:element name="p">
        <xsl:choose>
          <xsl:when test="@done">
            <xsl:attribute name="class">done</xsl:attribute>
          </xsl:when>
          <xsl:when test="@prio">
            <xsl:attribute name="class">p<xsl:value-of select="@prio"/></xsl:attribute>
          </xsl:when>
          <xsl:otherwise>
          </xsl:otherwise>
        </xsl:choose>
        <!-- calendar marker -->
        <xsl:element name="u">
        <xsl:choose>
          <xsl:when test="@done">
            <xsl:value-of select="@done"/>
          </xsl:when>
          <xsl:when test="@date">
            <xsl:value-of select="@date"/>
          </xsl:when>
          <xsl:otherwise>
          </xsl:otherwise>
        </xsl:choose>
        </xsl:element>
        <xsl:text>: </xsl:text>
        <xsl:apply-templates select="h"/>
        <!--  -->
        <xsl:if test="@effort">
          <xsl:text> / </xsl:text>
          <xsl:value-of select="@effort"/>
        </xsl:if>
        <!--  -->
        <xsl:if test="contact">
          <xsl:element name="ul">
            <xsl:for-each select="contact">
              <xsl:element name="li">
                <xsl:element name="a">
                  <xsl:attribute name="href">
                    <xsl:value-of select="cc"/>
                    <xsl:text>#</xsl:text>
                    <xsl:value-of select="@idref"/>
                  </xsl:attribute>
                  <xsl:value-of select="@idref"/>
                </xsl:element>
                <xsl:apply-templates select="p|list"/>
              </xsl:element>
            </xsl:for-each>
          </xsl:element>
        </xsl:if>
        <!--  -->
        <xsl:apply-templates select="p|list"/>
      </xsl:element>
    <xsl:value-of select="$newpar"/>
  </xsl:template>


  <xsl:template match="contact">
    <!-- list item -->
    <xsl:value-of select="$newpar"/>
  </xsl:template>


  <xsl:template match="list">
    <xsl:if test="child::node()">
      <xsl:choose>
        <xsl:when test="@enum = 'yes'">
          <!-- numerated list -->
          <xsl:element name="ol">
            <xsl:apply-templates/>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <!-- para -->
          <xsl:element name="ul">
            <xsl:apply-templates/>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
    <xsl:value-of select="$newpar"/>
  </xsl:template>


  <xsl:template match="p">
    <xsl:choose>
      <xsl:when test="name(parent::node()) = 'list'">
        <!-- list item -->
        <xsl:value-of select="."/>
      </xsl:when>
      <xsl:otherwise>
        <!-- para -->
        <xsl:value-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
    <xsl:value-of select="$newpar"/>
  </xsl:template>


  <xsl:template match="img">
    <xsl:copy-of select="."/>
  </xsl:template>


  <xsl:template match="fig">
    <xsl:text>Abb. </xsl:text>
    <xsl:value-of select="img/@src"/>
    <xsl:if test="h">
      <xsl:text>: </xsl:text>
      <xsl:value-of select="h"/>
    </xsl:if>
    <xsl:value-of select="$newpar"/>
  </xsl:template>


</xsl:stylesheet>
