<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:import href="Link.xsl"/>
  <xsl:import href="Utils.xsl"/>

  <xsl:template match="PIE">
<!-- 
    <xsl:if test="$flag_tree">
      <xsl:call-template name="TREE"/>
    </xsl:if>
-->
    <xsl:apply-templates/>
  </xsl:template>


  <xsl:template name="TREE">
    <xsl:element name="pre">
      <xsl:for-each select="//SECTION">
        <xsl:for-each select="ancestor-or-self::SECTION">
          <xsl:text>    </xsl:text>
        </xsl:for-each>
        <xsl:value-of select="H"/>
        <xsl:value-of select="$newline"/>
      </xsl:for-each>
    </xsl:element>
    <hr/>
  </xsl:template>


  <xsl:template match="H">
    <xsl:choose>
      <xsl:when test="@REF">
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:value-of select="@REF"/>
          </xsl:attribute>
          <xsl:value-of select="."/>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  

  <xsl:template match="SECTION">
    <xsl:if test="not(@VALID = 'no')">
      <xsl:element name="{concat('h',string(count(ancestor-or-self::SECTION)))}">
        <xsl:apply-templates select="H"/>
      </xsl:element>
      <xsl:apply-templates select="*[not(name(.) = 'H')]"/>
    </xsl:if>
  </xsl:template>


  <xsl:template match="TASK">
    <!-- valid TASK element -->
    <xsl:if test="not(@VALID = 'no')">
      <xsl:element name="p">
        <xsl:choose>
          <xsl:when test="@DONE">
            <xsl:attribute name="class">done</xsl:attribute>
          </xsl:when>
          <xsl:when test="@PRIO">
            <xsl:attribute name="class">p<xsl:value-of select="@PRIO"/></xsl:attribute>
          </xsl:when>
          <xsl:otherwise>
          </xsl:otherwise>
        </xsl:choose>
        <!-- calendar marker -->
        <xsl:element name="u">
        <xsl:choose>
          <xsl:when test="@DONE">
            <xsl:value-of select="@DONE"/>
          </xsl:when>
          <xsl:when test="@DATE">
            <xsl:value-of select="@DATE"/>
          </xsl:when>
          <xsl:otherwise>
          </xsl:otherwise>
        </xsl:choose>
        </xsl:element>
        <xsl:text>: </xsl:text>
        <xsl:apply-templates select="H"/>
        <!--  -->
        <xsl:if test="@EFFORT">
          <xsl:text> / </xsl:text>
          <xsl:value-of select="@EFFORT"/>
        </xsl:if>
        <!--  -->
        <xsl:if test="CONTACT">
          <xsl:element name="ul">
            <xsl:for-each select="CONTACT">
              <xsl:element name="li">
                <xsl:element name="a">
                  <xsl:attribute name="href">
                    <xsl:value-of select="$file_ref"/>
                    <xsl:text>#</xsl:text>
                    <xsl:value-of select="@IDREF"/>
                  </xsl:attribute>
                  <xsl:value-of select="@IDREF"/>
                </xsl:element>
                <xsl:apply-templates select="P|LIST"/>
              </xsl:element>
            </xsl:for-each>
          </xsl:element>
        </xsl:if>
        <!--  -->
        <xsl:apply-templates select="P|LIST"/>
      </xsl:element>
    </xsl:if>
  </xsl:template>


  <xsl:template match="SLIDE">
    <xsl:if test="not(@VALID = 'no')">
      <!-- list item -->
      <xsl:element name="center">
        <xsl:element name="table">
          <xsl:attribute name="class">
            <xsl:value-of select="name(.)"/>
          </xsl:attribute>
          <xsl:attribute name="border">
            <xsl:text>0</xsl:text>
          </xsl:attribute>
          <xsl:attribute name="cellspacing">
            <xsl:text>1</xsl:text>
          </xsl:attribute>
          <xsl:attribute name="width">
            <xsl:text>80%</xsl:text>
          </xsl:attribute>
          <xsl:element name="tbody">
            <xsl:element name="tr">
              <xsl:element name="td">
                <xsl:element name="center">
                  <xsl:element name="b">
                    <xsl:value-of select="H"/>
                  </xsl:element>
                </xsl:element>
                <xsl:apply-templates select="*[not(name(.) = 'H')]"/>
              </xsl:element>
            </xsl:element>
          </xsl:element>
        </xsl:element>
        <xsl:element name="p">
          <xsl:element name="u">
            <xsl:text>Folie:</xsl:text>
          </xsl:element>
          <xsl:text> </xsl:text>
          <xsl:value-of select="H"/>
        </xsl:element>
      </xsl:element>
    </xsl:if>
  </xsl:template>


  <xsl:template match="CONTACT">
    <!-- list item -->
    <xsl:element name="table">
      <xsl:attribute name="class">
        <xsl:value-of select="name(.)"/>
      </xsl:attribute>
      <xsl:attribute name="border">
        <xsl:text>0</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="cellspacing">
        <xsl:text>1</xsl:text>
      </xsl:attribute>
      <xsl:element name="tbody">
        <xsl:element name="tr">
          <xsl:element name="th">
            <xsl:value-of select="NAME"/>
          </xsl:element>
        </xsl:element>
        <xsl:element name="tr">
          <xsl:element name="td">
            <xsl:apply-templates/>
          </xsl:element>
        </xsl:element>
      </xsl:element>
    </xsl:element>
  </xsl:template>


  <xsl:template match="LIST">
    <xsl:if test="child::node()">
      <xsl:choose>
        <xsl:when test="@ENUM = 'yes'">
          <!-- numerated list -->
          <xsl:element name="ol">
            <xsl:apply-templates/>
          </xsl:element>
        </xsl:when>
        <xsl:otherwise>
          <!-- para -->
          <xsl:element name="ul">
            <xsl:apply-templates/>
          </xsl:element>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
  </xsl:template>


  <xsl:template match="P">
    <xsl:choose>
      <xsl:when test="name(parent::node()) = 'LIST'">
        <!-- list item -->
        <xsl:element name="li">
          <xsl:apply-templates/>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <!-- para -->
        <xsl:element name="p">
          <xsl:apply-templates/>
        </xsl:element>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>


  <xsl:template match="IMG">
    <xsl:copy-of select="."/>
  </xsl:template>


  <xsl:template match="FIG">
    <xsl:element name="center">
      <xsl:apply-templates select="IMG"/>
      <xsl:if test="H">
        <xsl:element name="p">
          <xsl:element name="u">
            <xsl:text>Abb.:</xsl:text>
          </xsl:element>
          <xsl:text> </xsl:text>
          <xsl:value-of select="H"/>
        </xsl:element>
      </xsl:if>
    </xsl:element>
  </xsl:template>


</xsl:stylesheet>
