<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  		xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

  <xsl:import href="Header.xsl"/>
  <xsl:import href="Footer.xsl"/>
  <xsl:import href="Copyrights.xsl"/>
  <xsl:import href="Utils.xsl"/>

<!--  encoding="ISO-8859-1" -->
<xsl:output method="text" encoding="UTF-8"/>  

<!--
<xsl:variable name="id_element" select="'plz_cad'"/>
<xsl:variable name="id_element" select="'cad_net'"/>
-->
<xsl:variable name="id_element" select="'bildbearbeitung'"/>

<xsl:variable name="color_default" select="'black'"/>
<xsl:variable name="length_max" select="25"/>
<xsl:variable name="flag_color" select="true()"/>
<xsl:variable name="flag_style" select="true()"/>

<xsl:template match="/">
          <xsl:call-template name="HEADER"/>
  <xsl:apply-templates select="//*[@ID = $id_element]"/>
          <xsl:call-template name="COPYRIGHTNET"/>
          <xsl:call-template name="FOOTER"/>
          <xsl:call-template name="COPYRIGHTPKG"/>
</xsl:template>


<xsl:template match="SUBNET|PETRINET">
<xsl:if test="child::node()">
  <xsl:text>
// Netz </xsl:text><xsl:value-of select="@ID"/>
  <xsl:choose>
    <xsl:when test="self::PETRINET">
<xsl:text>
subgraph cluster0 {
</xsl:text>
    </xsl:when>
    <xsl:otherwise>
<xsl:text>
subgraph cluster</xsl:text><xsl:value-of select="position()"/><xsl:text> {
</xsl:text>
</xsl:otherwise>
</xsl:choose>

<xsl:if test="self::PETRINET">
<xsl:apply-templates select="SUBNET"/>
</xsl:if>

<xsl:text>
  label=&quot;</xsl:text>
    <xsl:value-of select="NAME"/><xsl:text>&quot;

// Modelle
</xsl:text>
<xsl:apply-templates select="STELLE"/>
<xsl:text>
// Prozesse
</xsl:text>
<xsl:apply-templates select="TRANSITION"/>
<xsl:text>
// Relationen
</xsl:text>
<xsl:apply-templates select="RELATION"/>
<xsl:text>
}
</xsl:text>
</xsl:if>
</xsl:template>


<xsl:template match="STELLE|TRANSITION">

<xsl:call-template name="KNOT">
  <xsl:with-param name="id_knot"><xsl:value-of select="@ID"/></xsl:with-param>
</xsl:call-template>

<xsl:for-each select="//RELATION[@TO = $id_element]">
  <xsl:call-template name="KNOT">
    <xsl:with-param name="id_knot"><xsl:value-of select="@FROM"/></xsl:with-param>
  </xsl:call-template>
  <xsl:apply-templates select="."/>
</xsl:for-each>

<xsl:for-each select="//RELATION[@FROM = $id_element]">
  <xsl:call-template name="KNOT">
    <xsl:with-param name="id_knot"><xsl:value-of select="@TO"/></xsl:with-param>
  </xsl:call-template>
  <xsl:apply-templates select="."/>
</xsl:for-each>

</xsl:template>


<xsl:template name="KNOT">
  <xsl:param name="id_knot"/>

  <xsl:for-each select="//*[@ID = $id_knot]">
<xsl:value-of select="@ID"/>
<xsl:text> [label = "</xsl:text>
  <xsl:call-template name="lf2br">
    <xsl:with-param name="StringToTransform" select="NAME"/>
  </xsl:call-template>

<!-- <xsl:value-of select="NAME"/>
<xsl:choose>
  <xsl:when test="contains(NAME,' ')">
    <xsl:value-of select="substring-before(NAME,' ')"/>
    <xsl:text>\n</xsl:text>
    <xsl:variable name="next" select="substring-after(NAME,' ')"/>
    <xsl:choose>
      <xsl:when test="contains($next,' ')">
        <xsl:value-of select="substring-before($next,' ')"/>
        <xsl:text>\n</xsl:text>
        <xsl:variable name="nnext" select="substring-after($next,' ')"/>
        <xsl:value-of select="substring($nnext,0,$length_max)"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="substring($next,0,$length_max)"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:when>

  <xsl:when test="contains(NAME,'-')">
    <xsl:value-of select="substring-before(NAME,'-')"/>
    <xsl:text>-\n</xsl:text>
    <xsl:variable name="next" select="substring-after(NAME,'-')"/>
    <xsl:choose>
      <xsl:when test="contains($next,'-')">
        <xsl:value-of select="substring-before($next,'-')"/>
        <xsl:text>-\n</xsl:text>
        <xsl:variable name="nnext" select="substring-after($next,'-')"/>
        <xsl:value-of select="substring($nnext,0,$length_max)"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="substring($next,0,$length_max)"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:when>

  <xsl:otherwise>
    <xsl:value-of select="substring(NAME,0,$length_max)"/>
  </xsl:otherwise>
</xsl:choose>
 -->
<xsl:text>", </xsl:text>

<!-- detect TRANSITION -->
<xsl:if test="self::TRANSITION">
<xsl:text>shape="box", </xsl:text>
</xsl:if>

<xsl:if test="$flag_color">
<xsl:text>color = "</xsl:text>
<xsl:choose>
  <xsl:when test="@COLOR">
    <xsl:value-of select="@COLOR"/>
  </xsl:when>
  <xsl:otherwise>
    <xsl:value-of select="$color_default"/>
  </xsl:otherwise>
</xsl:choose>
<xsl:text>", </xsl:text>
</xsl:if>

<xsl:text>href = "</xsl:text>
<xsl:value-of select="@ID"/>
<xsl:text>.html", </xsl:text>

<xsl:if test="$flag_style">
<xsl:text>peripheries="</xsl:text>
<xsl:value-of select="@RATING"/>
<xsl:text>" </xsl:text>
</xsl:if>

<xsl:text>];
</xsl:text>

  </xsl:for-each>
</xsl:template>


<xsl:template match="RELATION">
  <xsl:variable name="id_from" select="@FROM"/>
  <xsl:variable name="id_to" select="@TO"/>
  <!--  -->
<xsl:value-of select="@FROM"/>
<xsl:text> -> </xsl:text>
<xsl:value-of select="@TO"/>
<xsl:text> [</xsl:text>

<xsl:if test="$flag_color">
<xsl:text>color="</xsl:text>
<xsl:choose>
  <xsl:when test="@COLOR">
    <xsl:value-of select="@COLOR"/>
  </xsl:when>
  <xsl:otherwise>
    <xsl:value-of select="$color_default"/>
  </xsl:otherwise>
</xsl:choose>
<xsl:text>", </xsl:text>
</xsl:if>

<xsl:if test="$flag_style">
<xsl:text>style="</xsl:text>
<xsl:value-of select="@STYLE"/>
<xsl:text>" </xsl:text>
</xsl:if>

<xsl:text>];
</xsl:text>

</xsl:template>


</xsl:stylesheet>
