<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

  <xsl:output 
    method="html"
    omit-xml-declaration="no"
    doctype-public="-//W3C//DTD HTML 4.01//EN"
    doctype-system="file:///tmp/dummy.dtd"
    encoding="ISO-8859-1" />

<xsl:variable name="prefix_tmp" select="'tmp'"/>
<xsl:variable name="prefix_tmpi" select="translate($prefix_tmp,'\','/')"/>

<xsl:template match="/">
  <html>
    <xsl:copy-of select="document(concat($prefix_tmpi,'/header.xml'))/head"/>
    <body>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/menue.html'))/table"/>
      <xsl:apply-templates/>
      <hr/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-net.xml'))/table"/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-pkg.xml'))/p"/>
    </body>
  </html>
</xsl:template>

<xsl:template match="PETRINET">
  <xsl:comment>Pfad-Suche</xsl:comment>
  <form method="post" action="/cgi-bin/cxproc">
    <input type="hidden" name="cxp" value="Pkg2Search"/>
    <input type="hidden" name="file" value="/home/developer/develop/Album/pkg2/main.xml"/>

  <table class="hidden" cellspacing="1" cellpadding="5" width="100%">
    <tbody>
      <tr>
        <th colspan="3">
          <xsl:text>Start-Modell </xsl:text>
          <select name="start" size="1">
            <option value=""/>
            <xsl:for-each select="//STELLE">
              <xsl:element name="option">
                <xsl:attribute name="value">
                  <xsl:value-of select="@ID"/>
                </xsl:attribute>
                  <xsl:value-of select="NAME"/>
                </xsl:element>
              </xsl:for-each>
            </select>
            <xsl:text> Ziel-Modell </xsl:text>
            <select name="target" size="1">
              <option value=""/>
              <xsl:for-each select="//STELLE">
                <xsl:element name="option">
                  <xsl:attribute name="value">
                    <xsl:value-of select="@ID"/>
                  </xsl:attribute>
                  <xsl:value-of select="NAME"/>
                </xsl:element>
              </xsl:for-each>
            </select>
            <input type="submit" name="mode" value="Tabelle"/>
            <input type="submit" name="mode" value="Graph"/>
            <input type="submit" name="mode" value="XML"/>
            <input type="submit" name="mode" value="XSL"/>
          </th>
        </tr>

        <tr>
          <th colspan="3">
            <input name="l_min" type="text" size="2" maxlength="2"/>
            &lt; Laenge &lt;=
            <input name="l_max" type="text" size="2" maxlength="2" value="7"/>
          </th>
        </tr>

        <tr>
          <td colspan="3">Bitte waehlen Sie die auszuschliessenden
          <!--
          <select name="policy" size="1">
            <option value="include">auszuschliessenden</option>
            <option value="exclude">einzuschliessenden</option>
          </select>
          -->
          Elemente an!</td>
        </tr>

        <tr>
          <td valign="top">
            <table class="hidden">
              <tbody>
                <tr>
                  <th colspan="1">Subnetze</th>
                </tr>
                <xsl:apply-templates select="SUBNET"/>
              </tbody>
            </table>
          </td>

          <td valign="top">
            <table class="hidden">
              <tbody>
                <tr>
                  <th colspan="1">Modelle</th>
                </tr>
                <xsl:apply-templates select="//STELLE"/>
              </tbody>
            </table>
          </td>

          <td valign="top">
            <table class="hidden">
              <tbody>
                <tr>
                  <th colspan="1">Prozesse</th>
                </tr>
                <xsl:apply-templates select="//TRANSITION"/>
              </tbody>
            </table>
          </td>
        </tr>
      </tbody>
    </table>
  </form>
</xsl:template>


<xsl:template match="SUBNET|STELLE|TRANSITION">
  <tr>
    <td>
      <xsl:element name="input">
        <xsl:attribute name="type">checkbox</xsl:attribute>
        <xsl:attribute name="name">
          <xsl:choose>
            <xsl:when test="self::STELLE">state</xsl:when>
            <xsl:when test="self::TRANSITION">transition</xsl:when>
            <xsl:otherwise>subnet</xsl:otherwise>
          </xsl:choose>
        </xsl:attribute>
        <xsl:attribute name="value"><xsl:value-of select="@ID"/></xsl:attribute>
      </xsl:element>

      <xsl:element name="a">
        <xsl:attribute name="href">
          <xsl:value-of select="@ID"/><xsl:text>.html</xsl:text>
        </xsl:attribute>
        <xsl:value-of select="NAME"/>
      </xsl:element>
    </td>
  </tr>
</xsl:template>

</xsl:stylesheet>
