<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

<xsl:output method="html" omit-xml-declaration='yes' encoding="ISO-8859-1" media-type="text/html" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"/>  

<xsl:variable name="prefix_tmp" select="'tmp'"/>
<xsl:variable name="prefix_tmpi" select="translate($prefix_tmp,'\','/')"/>

<xsl:template match="/">
  <html>
    <xsl:copy-of select="document(concat($prefix_tmpi,'/header.xml'))/head"/>
    <body>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/menue.html'))/table"/>
      <table border="0" width="100%" cellspacing="1">
        <tbody>
          <xsl:apply-templates/>
        </tbody>
      </table>
      <hr/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-net.xml'))/table"/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-pkg.xml'))/p"/>
    </body>
  </html>
</xsl:template>


<xsl:template match="PETRINET">
  <h3><xsl:value-of select="NAME"/></h3>
  <table border="0" cellspacing="1" cellpadding="2">
    <tr>
      <th>Element-Typ</th>
      <th>Element-Anzahl</th>
    </tr>  
    <tr>
      <th>Subnetze</th>
      <td align="right"><xsl:value-of select="count(//SUBNET[not(@VALID = 'no')])"/></td>
    </tr>  
    <tr>
      <th>Modelle</th>
      <td align="right"><xsl:value-of select="count(//STELLE[not(@VALID = 'no')])"/></td>
    </tr>  
    <tr>
      <th>Prozesse</th>
      <td align="right"><xsl:value-of select="count(//TRANSITION[not(@VALID = 'no')])"/></td>
    </tr>  
    <tr>
      <th>Relationen</th>
      <td align="right"><xsl:value-of select="count(//RELATION[not(@VALID = 'no')])"/></td>
    </tr>  
    <tr>
      <th>Anforderungen</th>
      <td align="right"><xsl:value-of select="count(//REQUIREMENT[not(@VALID = 'no')])"/></td>
    </tr>  
  </table>
</xsl:template>

</xsl:stylesheet>
