<?xml version="1.0" encoding="ISO-8859-1"?>
<!DOCTYPE xsl:stylesheet SYSTEM "../../../xslt10.dtd">

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

<xsl:import href="../../../pie/xsl/html/PieHtml.xsl"/>

<!-- <xsl:import href="ManualCheckProfile.xsl"/> -->

  <xsl:output 
    method="html"
    omit-xml-declaration="no"
    doctype-public="-//W3C//DTD HTML 4.01//EN"
    doctype-system="file:///tmp/dummy.dtd"
    encoding="ISO-8859-1" />

<xsl:variable name="prefix_tmp" select="'tmp'"/>
<xsl:variable name="prefix_tmpi" select="translate($prefix_tmp,'\','/')"/>

<!-- 
<xsl:variable name="id_element" select="'cad_vereinfachung'"/>
<xsl:variable name="id_element" select="'cad_ins'"/>
<xsl:variable name="id_element" select="'accuracy_model'"/>
-->

  <!--  -->
  <xsl:variable name="level_hidden" select="0"/>
<!-- flag for displaying graph -->
<xsl:variable name="flag_graph" select="true()"/>
<!-- flag for matrix of requirements -->
<xsl:variable name="flag_req"   select="true()"/>
<!-- flag for including external docs -->
<xsl:variable name="flag_doc"   select="true()"/>
<!-- additional language 'en' -->
<xsl:variable name="lang" select="''"/>


<xsl:template match="/">
  <html>
    <xsl:copy-of select="document(concat($prefix_tmpi,'/header.xml'))/head"/>
    <body>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/menue.html'))/table"/>
      <table border="0" width="100%" cellspacing="1">
        <tbody>
          <xsl:apply-templates select="//*[@ID = $id_element]"/>
        </tbody>
      </table>
      <hr/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-net.xml'))/table"/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-pkg.xml'))/p"/>
    </body>
  </html>
</xsl:template>


<xsl:template match="STELLE|TRANSITION|REQUIREMENT|SUBNET|PETRINET">
  <xsl:apply-templates select="NAME"/>
  <xsl:if test="$flag_graph and not(self::REQUIREMENT)">
    <tr>
      <td align="center">
        <xsl:copy-of select="document(concat($prefix_tmpi,'/graph_',$id_element,'.xml'))"/>
        <!-- -->
        <xsl:element name="img">
          <xsl:attribute name="usemap">
            <xsl:text>#pkg2</xsl:text> <!-- <xsl:value-of select="@ID"/> -->
          </xsl:attribute>
          <xsl:attribute name="src">
            <xsl:text>graph_</xsl:text>
            <xsl:value-of select="@ID"/>
            <xsl:text>.png</xsl:text>
          </xsl:attribute>
          <xsl:attribute name="alt">
            <xsl:text>Graph </xsl:text>
            <xsl:value-of select="@ID"/>
          </xsl:attribute>
        </xsl:element>
      </td>
    </tr>
  </xsl:if>
  <xsl:apply-templates select="DESCRIPTION"/>
  <xsl:if test="$flag_doc">
    <tr>
      <td>
        <!--
        <xsl:copy-of select="document(concat($prefix_tmpi,'/',$id_element,'-include.html'))"/>
        -->
        <xsl:apply-templates select="document(concat($prefix_tmpi,'/text_',$id_element,'.pie'))/pie/*"/>
        <!--
        <xsl:copy-of select="document(concat('../../../tmp/text_',$id_element,'.html'))/html/body/*"/>
        <xsl:copy-of select="document(concat('../../../tmp/text_',$id_element,'.xhtml'))/html/body/*"/>
        -->
      </td>
    </tr>
  </xsl:if>
  <xsl:choose>
    <xsl:when test="self::STELLE and child::FORM">
      <tr>
        <td>Formate
          <ul>
            <xsl:apply-templates select="FORM"/>
          </ul>
        </td>
      </tr>
    </xsl:when>
    <xsl:when test="self::TRANSITION and child::TOOL">
      <tr>
        <td>Werkzeuge
          <ul>
            <xsl:apply-templates select="TOOL"/>
          </ul>
        </td>
      </tr>
    </xsl:when>
    <xsl:when test="self::REQUIREMENT and child::CHECK">
      <tr>
        <td>Pruefungen
          <ul>
            <xsl:apply-templates select="CHECK"/>
          </ul>
        </td>
      </tr>
    </xsl:when>
    <xsl:otherwise>
    </xsl:otherwise>
  </xsl:choose>
  <xsl:if test="child::LINK">
    <tr>
      <td>Links
        <ul>
          <xsl:apply-templates select="LINK"/>
        </ul>
      </td>
    </tr>
  </xsl:if>
  <!-- 
 -->
  <!-- call of requirement matrix -->
<!-- 
  <xsl:if test="$flag_req and self::STELLE and child::REQ">
    <xsl:call-template name="MATRIX">
      <xsl:with-param name="id_knot"><xsl:value-of select="@ID"/></xsl:with-param>
    </xsl:call-template>
  </xsl:if>
 -->
</xsl:template>


<xsl:template match="NAME">
  <tr>
    <th>
      <xsl:value-of select="."/>
      <!-- only if parent is a subnet -->
      <xsl:text> (</xsl:text>
      <xsl:element name="a">
        <xsl:attribute name="href">
          <xsl:value-of select="../parent::*/@ID"/><xsl:text>.html</xsl:text>
        </xsl:attribute>
        <xsl:value-of select="../parent::*/NAME"/>
      </xsl:element>
      <xsl:text>)</xsl:text>
      <xsl:if test="@DIMENSION">
        <xsl:text> </xsl:text>
        <xsl:value-of select="@DIMENSION"/>
      </xsl:if>
      <!-- mark check properties -->
      <xsl:if test="parent::REQUIREMENT">
        <xsl:if test="../@COLOR">
          <xsl:text> </xsl:text>
          <xsl:element name="img">
            <xsl:attribute name="src">
              <xsl:value-of select="../@COLOR"/><xsl:text>.png</xsl:text>
            </xsl:attribute>
          </xsl:element>
          <xsl:text> </xsl:text>
        </xsl:if>
        <xsl:text> </xsl:text>
        <xsl:value-of select="../@CHECK"/>
      </xsl:if>
    </th>
  </tr>
</xsl:template>


<xsl:template match="DESCRIPTION">
  <tr>
    <td>
      <xsl:value-of select="."/>
    </td>
  </tr>
  <!-- dictionary lookup -->
  <xsl:if test="$lang">
    <tr>
      <td>
        <xsl:value-of select="//DICTIONARY/TEXT[@IDREF = $id_element]/DESCRIPTION[@LANG = $lang]"/>
      </td>
    </tr>
  </xsl:if>
</xsl:template>


<xsl:template match="FORM|TOOL|CHECK|LINK">
  <li>
    <xsl:choose>
      <xsl:when test="@HREF">
        <xsl:element name="a">
          <xsl:attribute name="href">
            <xsl:value-of select="@HREF"/>
          </xsl:attribute>
          <xsl:attribute name="target">
            <xsl:text>_blank</xsl:text>
          </xsl:attribute>
          <xsl:value-of select="."/>
        </xsl:element>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="."/>
      </xsl:otherwise>
    </xsl:choose>
  </li>
</xsl:template>


<xsl:template match="RELATION">
  <tr>
    <th>
      <xsl:value-of select="@TO"/>
    </th>
  </tr>
  <xsl:apply-templates select="REQ"/>
</xsl:template>


</xsl:stylesheet>


