<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

<xsl:output method="html" omit-xml-declaration='yes' encoding="ISO-8859-1" media-type="text/html" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"/>  

<xsl:variable name="prefix_tmp" select="'tmp'"/>
<xsl:variable name="prefix_tmpi" select="translate($prefix_tmp,'\','/')"/>
<xsl:variable name="id_main" select="'main'"/>

<xsl:template match="/">
  <html>
    <xsl:copy-of select="document(concat($prefix_tmpi,'/header.xml'))/head"/>
    <body>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/menue.html'))/table"/>
      <table border="0" width="100%" cellspacing="1">
        <tbody>
          <xsl:apply-templates/>
        </tbody>
      </table>
      <hr/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-net.xml'))/table"/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-pkg.xml'))/p"/>
    </body>
  </html>
</xsl:template>


<xsl:template match="PETRINET">
  <xsl:element name="h3">
    <xsl:value-of select="NAME"/>
  </xsl:element>

  <xsl:copy-of select="document(concat($prefix_tmpi,'/graph_',$id_main,'.cmapx'))"/>
  <!-- -->
  <xsl:element name="center">
    <xsl:element name="img">
      <xsl:attribute name="usemap">
        <xsl:text>#pkg2</xsl:text> <!-- <xsl:value-of select="@ID"/> -->
      </xsl:attribute>
      <xsl:attribute name="src">
        <xsl:value-of select="concat('graph_',$id_main,'.png')"/>
      </xsl:attribute>
      <xsl:attribute name="alt">
        <xsl:text>Graph </xsl:text>
        <xsl:value-of select="$id_main"/>
      </xsl:attribute>
    </xsl:element>
  </xsl:element>

</xsl:template>

</xsl:stylesheet>
