<!DOCTYPE xsl:stylesheet SYSTEM "../../../xslt10.dtd">

<xsl:stylesheet version="1.0"
  		xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

  <xsl:output 
    method="html"
    omit-xml-declaration="no"
    doctype-public="-//W3C//DTD HTML 4.01//EN"
    doctype-system="file:///tmp/dummy.dtd"
    encoding="ISO-8859-1" />

<xsl:variable name="prefix_tmp" select="'tmp'"/>
<xsl:variable name="prefix_tmpi" select="translate($prefix_tmp,'\','/')"/>

<xsl:template match="/">
  <html>
    <xsl:copy-of select="document(concat($prefix_tmpi,'/header.xml'))/head"/>
    <body>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/menue.html'))/table"/>
      <xsl:apply-templates select="PETRINET"/>
      <hr/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-net.xml'))/table"/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-pkg.xml'))/p"/>
    </body>
  </html>
</xsl:template>


<xsl:template match="PETRINET">
  <table border="0" width="100%" cellspacing="1">
    <tbody>
      <tr>
        <th colspan="3">
          <xsl:text>Anforderungskatalog</xsl:text>
        </th>
        <th>
          <xsl:text>Check</xsl:text>
        </th>
        <th>
          <xsl:text>Repair</xsl:text>
        </th>
      </tr>
      <tr>
        <td colspan="5" align="right">
          Status "verbindlich festgeschrieben" <img src="green.png"/><br/>
          Status "in Diskussion" <img src="yellow.png"/><br/>
          Status "Handlungsbedarf" <img src="red.png"/></td>
      </tr>
      <tr>
        <td colspan="5" align="right">
          Prüffunktion aus PTC ModelCHECK "mc"<br/>
          Prüffunktion in cadlink "tcl"<br/>
          Prüffunktion in PE-Check "pec"</td>
      </tr>
      <xsl:apply-templates select="KATALOG"/>
    </tbody>
  </table>
</xsl:template>

<xsl:template match="KATALOG|GRUPPE">
  <xsl:if test="REQUIREMENT">
    <tr>
      <th colspan="5">
        <xsl:for-each select="ancestor-or-self::node()">
          <xsl:if test="child::NAME">
            <xsl:value-of select="child::NAME"/>
            <xsl:text> :: </xsl:text>
          </xsl:if>
        </xsl:for-each>
      </th>
    </tr>
  </xsl:if>
  <xsl:apply-templates select="REQUIREMENT">
    <xsl:sort select="@CHECK" order="descending"/>
    <xsl:sort select="@COLOR" order="descending"/>
  </xsl:apply-templates>
  <xsl:apply-templates select="GRUPPE"/>
</xsl:template>

<xsl:template match="REQUIREMENT">
  <tr>
    <td><xsl:value-of select="position()"/></td>
    <td>
      <xsl:element name="a">
        <xsl:attribute name="href">
          <xsl:value-of select="@ID"/><xsl:text>.html</xsl:text>
        </xsl:attribute>
        <xsl:value-of select="NAME"/>
      </xsl:element>
            <xsl:if test="@BASICS = 'yes'">
              <xsl:text>*</xsl:text>
            </xsl:if>
    </td>
    <td>
      <xsl:value-of select="DESCRIPTION"/>
    </td>
    <th>
      <xsl:value-of select="@CHECK"/>
      <xsl:if test="@COLOR">
        <xsl:text> </xsl:text>
        <xsl:element name="img">
          <xsl:attribute name="src">
            <xsl:value-of select="@COLOR"/><xsl:text>.png</xsl:text>
          </xsl:attribute>
        </xsl:element>
      </xsl:if>
    </th>
    <th>
      <xsl:value-of select="@REPAIR"/>
    </th>
  </tr>
</xsl:template>


</xsl:stylesheet>
