<xsl:stylesheet version="1.0"
  		xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

<xsl:output method="html" omit-xml-declaration='yes' encoding="ISO-8859-1" media-type="text/html" doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"/>  

<xsl:variable name="n_max" select="15"/>
<!-- flag for displaying graph -->
<xsl:variable name="flag_vmi" select="true()"/>
<!-- <xsl:variable name="id_task" select="'re'"/> -->


<xsl:variable name="prefix_tmp" select="'/Album/pkg2'"/>
<xsl:variable name="prefix_tmpi" select="translate($prefix_tmp,'\','/')"/>
<xsl:variable name="id_main" select="'main'"/>

<xsl:template match="/">
  <html>
    <xsl:copy-of select="document(concat($prefix_tmpi,'/header.xml'))/head"/>
    <body>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/menue.html'))/table"/>
      <table border="0" width="100%" cellspacing="1">
        <tbody>
          <xsl:apply-templates/>
        </tbody>
      </table>
      <hr/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-net.xml'))/table"/>
      <xsl:copy-of select="document(concat($prefix_tmpi,'/copyright-pkg.xml'))/p"/>
    </body>
  </html>
</xsl:template>


<xsl:template match="PATHTABLE">
  <p>
    <xsl:choose>
      <xsl:when test="@COUNT &gt; $n_max">
        <xsl:text>Es werden </xsl:text>
        <xsl:value-of select="$n_max"/>
        <xsl:text> von </xsl:text>
        <xsl:value-of select="@COUNT"/><xsl:text> ermittelten Pfaden dargestellt</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>Es wurden </xsl:text>
        <xsl:value-of select="@COUNT"/>
        <xsl:text> Pfade ermittelt.</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </p>
    <table border="0" cellspacing="1">
    <tbody>
      <xsl:apply-templates select="PATH">
        <xsl:sort select="count(child::STELLE)"/>
      </xsl:apply-templates>
    </tbody>
  </table>
</xsl:template>


<xsl:template match="PATH">
  <xsl:if test="position() &lt; $n_max + 1">
    <tr>
      <th colspan="6">
        <xsl:text>Pfad </xsl:text><xsl:value-of select="position()"/>
      </th>
    </tr>
    <tr>
      <th><xsl:text>Nr.</xsl:text></th>
      <th><xsl:text></xsl:text></th>
      <th><xsl:text>Beschreibung</xsl:text></th>
      <xsl:if test="$flag_vmi">
        <th><xsl:text>V</xsl:text></th>
        <th><xsl:text>M</xsl:text></th>
        <th><xsl:text>I</xsl:text></th>
      </xsl:if>
    </tr>
    <xsl:apply-templates/>
  </xsl:if>
</xsl:template>


<xsl:template match="STELLE|TRANSITION">
  <tr>
    <td>
      <xsl:value-of select="position()"/>
    </td>
    <xsl:element name="td">
      <xsl:attribute name="class">
        <xsl:choose>
          <xsl:when test="self::TRANSITION">transition</xsl:when>
          <xsl:when test="self::STELLE">state</xsl:when>
        </xsl:choose>
      </xsl:attribute>
      <xsl:element name="a">
        <xsl:attribute name="href">
          <xsl:value-of select="@ID"/><xsl:text>.html</xsl:text>
        </xsl:attribute>
        <xsl:value-of select="NAME"/>
      </xsl:element>
      </xsl:element>
    <td>
      <xsl:value-of select="DESCRIPTION"/>
    </td>
    <xsl:if test="$flag_vmi">
      <td>
      </td>
      <td>
        <xsl:value-of select="PARENT"/>
      </td>
      <td>
      </td>
    </xsl:if>
  </tr>
</xsl:template>


<xsl:template match="RELATION">
  <xsl:if test="DESCRIPTION">
    <tr>
      <td>
      </td>
      <td>
      </td>
      <td align="right">
        <xsl:value-of select="DESCRIPTION"/>
      </td>
      <xsl:if test="$flag_vmi">
        <td>
        </td>
        <td>
        </td>
        <td>
        </td>
    </xsl:if>
    </tr>
  </xsl:if>
</xsl:template>


<xsl:template match="*">
  <tr>
    <td>
    </td>
    <td align="right">
      <xsl:value-of select="."/>
    </td>
  </tr>
</xsl:template>


</xsl:stylesheet>
