<!DOCTYPE xsl:stylesheet SYSTEM "../../../xslt10.dtd">

<xsl:stylesheet version="1.0"
  		xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

<xsl:output method="xml" encoding="ISO-8859-1"/>  

<xsl:template match="/">
  <xsl:element name="DICTIONARY"><xsl:text> 
</xsl:text>
<xsl:apply-templates select="//REQUIREMENT[@ID and not(@ID = '')]"/> 
<!-- <xsl:apply-templates select="//*[@ID and not(@ID = '')]"/>  -->
<!-- RELATION fehlen noch -->
  </xsl:element>
</xsl:template>

<xsl:template match="*">
  <xsl:variable name="id_element" select="@ID"/>
  <xsl:choose>
    <xsl:when test="//DICTIONARY/TEXT[@IDREF = $id_element]">
      <!-- there is a dictionary text already -->
    </xsl:when>
    <xsl:otherwise>
      <!--  -->
      <xsl:element name="TEXT">
        <xsl:attribute name="IDREF">
          <xsl:value-of select="@ID"/>
        </xsl:attribute>
        <!-- Path --><!-- 
        <xsl:comment>
          <xsl:for-each select="ancestor::node()">
            <xsl:if test="child::NAME">
              <xsl:value-of select="child::NAME"/>
              <xsl:text> :: </xsl:text>
            </xsl:if>
          </xsl:for-each>
        </xsl:comment>
        -->
        <xsl:copy-of select="NAME"/>
        <xsl:copy-of select="DESCRIPTION"/>
      </xsl:element>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

</xsl:stylesheet>
