<!DOCTYPE xsl:stylesheet SYSTEM "../../../xslt10.dtd">

<xsl:stylesheet version="1.0"
  		xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

<xsl:output method="xml" encoding="ISO-8859-1"/>  

<xsl:template match="/">
  <xsl:element name="STELLE">
    <xsl:apply-templates select="PETRINET|SUBNET|KATALOG"/>
  </xsl:element>
</xsl:template>

<xsl:template match="PETRINET">
  <xsl:apply-templates select="KATALOG"/>
</xsl:template>

<xsl:template match="KATALOG|GRUPPE">
  <xsl:if test="count(descendant::REQUIREMENT) &gt; 0">
    <xsl:comment>
      <xsl:for-each select="ancestor-or-self::node()">
        <xsl:if test="child::NAME">
          <xsl:value-of select="child::NAME"/>
          <xsl:text> :: </xsl:text>
        </xsl:if>
      </xsl:for-each>
    </xsl:comment>
    <xsl:text>
 </xsl:text>
    </xsl:if>
    <xsl:apply-templates select="REQUIREMENT">
      <xsl:sort select="@CHECK" order="descending"/>
      <xsl:sort select="@COLOR" order="descending"/>
    </xsl:apply-templates>
    <xsl:apply-templates select="GRUPPE"/>
  </xsl:template>


  <xsl:template match="REQUIREMENT">
    <xsl:element name="REQ">
      <xsl:attribute name="REF">
        <xsl:value-of select="@ID"/>
      </xsl:attribute>
      <xsl:attribute name="CAT">
      </xsl:attribute>
    </xsl:element>
    <xsl:if test="@BASICS = 'yes'">
      <xsl:comment>*</xsl:comment>
    </xsl:if>
    <xsl:text>
    </xsl:text>
  </xsl:template>

</xsl:stylesheet>
