<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

<xsl:output
  method='xml'
  version='1.0'
  encoding='ISO-8859-1'
  indent='no'/>

<xsl:template match="/">
  <xsl:for-each select="map/node">
    <xsl:variable name="id_element" select="translate(@TEXT,'ABCDEFGHIJKLMNOPQRSTUVWXYZ -/()+','abcdefghijklmnopqrstuvwxyz___')"/>
    <xsl:comment>
      <xsl:text> Draft </xsl:text>
    </xsl:comment>
    <xsl:element name="PETRINET">
      <xsl:attribute name="ID">
        <xsl:value-of select="$id_element"/>
      </xsl:attribute>
      <xsl:element name="NAME">
        <xsl:value-of select="@TEXT"/>
      </xsl:element>
      <xsl:element name="DESCRIPTION">
        <xsl:text> </xsl:text>
      </xsl:element>
      <xsl:element name="COPYRIGHT">
        <xsl:text> </xsl:text>
      </xsl:element>
      <xsl:element name="CONTACT">
        <xsl:text> </xsl:text>
      </xsl:element>
      <xsl:apply-templates/>
    </xsl:element>
  </xsl:for-each>
</xsl:template>

<xsl:template match="node[child::node[@TEXT='Modelle' or @TEXT='Prozesse']]">
  <xsl:variable name="id_element" select="translate(@TEXT,'ABCDEFGHIJKLMNOPQRSTUVWXYZ -/()+','abcdefghijklmnopqrstuvwxyz___')"/>
  <xsl:comment>
    <xsl:value-of select="@TEXT"/>
  </xsl:comment>
  <xsl:element name="SUBNET">
    <xsl:attribute name="ID">
      <xsl:value-of select="$id_element"/>
    </xsl:attribute>
    <xsl:element name="NAME">
      <xsl:value-of select="@TEXT"/>
    </xsl:element>
    <xsl:apply-templates/>
  </xsl:element>
</xsl:template>


<xsl:template match="node[@TEXT='Modelle']">
  <xsl:for-each select="child::node">
    <xsl:variable name="id_element" select="translate(@TEXT,'ABCDEFGHIJKLMNOPQRSTUVWXYZ -/()+','abcdefghijklmnopqrstuvwxyz___')"/>
    <xsl:comment>
      <xsl:value-of select="@TEXT"/>
    </xsl:comment>
    <xsl:element name="STELLE">
      <xsl:attribute name="ID">
        <xsl:value-of select="$id_element"/>
      </xsl:attribute>
      <xsl:element name="NAME">
        <xsl:value-of select="@TEXT"/>
      </xsl:element>
      <xsl:element name="DESCRIPTION">
        <xsl:for-each select="child::node">
          <xsl:value-of select="@TEXT"/>
          <xsl:text>; </xsl:text>
        </xsl:for-each>
      </xsl:element>
    </xsl:element>
      <xsl:element name="RELATION">
        <xsl:attribute name="FROM">
          <xsl:value-of select="$id_element"/>
        </xsl:attribute>
        <xsl:attribute name="TO">
        <xsl:text> </xsl:text>
      </xsl:attribute>
    </xsl:element>
    <xsl:element name="RELATION">
      <xsl:attribute name="FROM">
        <xsl:text> </xsl:text>
      </xsl:attribute>
      <xsl:attribute name="TO">
        <xsl:value-of select="$id_element"/>
      </xsl:attribute>
    </xsl:element>
  </xsl:for-each>
</xsl:template>

<xsl:template match="node[@TEXT='Prozesse']">
  <xsl:for-each select="child::node">
    <xsl:variable name="id_element" select="translate(@TEXT,'ABCDEFGHIJKLMNOPQRSTUVWXYZ -/()+','abcdefghijklmnopqrstuvwxyz___')"/>
    <xsl:comment>
      <xsl:value-of select="@TEXT"/>
    </xsl:comment>
    <xsl:element name="TRANSITION">
      <xsl:attribute name="ID">
        <xsl:value-of select="$id_element"/>
      </xsl:attribute>
      <xsl:element name="NAME">
        <xsl:value-of select="@TEXT"/>
      </xsl:element>
      <xsl:element name="DESCRIPTION">
        <xsl:for-each select="child::node">
          <xsl:value-of select="@TEXT"/>
          <xsl:text>; </xsl:text>
        </xsl:for-each>
      </xsl:element>
    </xsl:element>
      <xsl:element name="RELATION">
        <xsl:attribute name="FROM">
          <xsl:value-of select="$id_element"/>
        </xsl:attribute>
        <xsl:attribute name="TO">
          <xsl:text> </xsl:text>
        </xsl:attribute>
      </xsl:element>
      <xsl:element name="RELATION">
        <xsl:attribute name="FROM">
          <xsl:text> </xsl:text>
        </xsl:attribute>
        <xsl:attribute name="TO">
          <xsl:value-of select="$id_element"/>
        </xsl:attribute>
      </xsl:element>
  </xsl:for-each>
</xsl:template>

<xsl:template match="*">
    <xsl:apply-templates/>
</xsl:template>

</xsl:stylesheet>
