<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

<xsl:output method='xml' version='1.0' encoding='ISO-8859-1' indent='yes'/>

<!-- flag for displaying description -->
<xsl:variable name="flag_description" select="true()"/>
<!-- flag for displaying description as note -->
<xsl:variable name="flag_note" select="false()"/>

<xsl:template match="/">
  <xsl:comment>
    <xsl:text> PKG2-Stylesheet .xsl </xsl:text>
  </xsl:comment>
  <xsl:element name="map">
    <xsl:apply-templates/>
  </xsl:element>
  <!--     <xsl:element name="hook"> <xsl:attribute name="name">
     <xsl:text>accessories/plugins/RevisionPlugin.properties</xsl:text>
     </xsl:attribute>
    </xsl:element> -->
</xsl:template>

<xsl:template match="PETRINET|SUBNET|KATALOG|GRUPPE">
  <xsl:element name="node">
    <xsl:attribute name="text">
      <xsl:value-of select="NAME"/>
    </xsl:attribute>
    <xsl:attribute name="link">
      <xsl:text>http://test/pkg/html/</xsl:text>
      <xsl:value-of select="@ID"/>
      <xsl:text>.html</xsl:text>
    </xsl:attribute>
    <xsl:attribute name="folded">
      <xsl:text>true</xsl:text>
    </xsl:attribute>

    <xsl:apply-templates select="KATALOG"/>

    <xsl:apply-templates select="GRUPPE"/>

    <xsl:apply-templates select="SUBNET"/>

    <xsl:apply-templates select="REQUIREMENT"/>

    <xsl:if test="STELLE">
      <!--  -->
      <xsl:element name="node">
        <xsl:attribute name="text">
          <xsl:text>Modelle</xsl:text>
        </xsl:attribute>
        <xsl:apply-templates select="STELLE"/>
      </xsl:element>
    </xsl:if>

    <xsl:if test="TRANSITION">
      <!--  -->
      <xsl:element name="node">
        <xsl:attribute name="text">
          <xsl:text>Prozesse</xsl:text>
        </xsl:attribute>
        <xsl:apply-templates select="TRANSITION"/>
      </xsl:element>
    </xsl:if>

  </xsl:element>
</xsl:template>


<xsl:template match="STELLE | TRANSITION | REQUIREMENT">
    <xsl:element name="node">
      <xsl:attribute name="text">
      <xsl:choose>
        <xsl:when test="NAME">
          <xsl:value-of select="NAME"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="@ID"/>
        </xsl:otherwise>
      </xsl:choose>
     </xsl:attribute>
     <!--  -->
     <xsl:if test="$flag_description">
       <xsl:choose>
         <xsl:when test="$flag_note">
           <xsl:element name="hook">
             <xsl:attribute name="name">
               <xsl:text>accessories/plugins/NodeNote.properties</xsl:text>
             </xsl:attribute>
             <xsl:element name="text">
               <xsl:value-of select="DESCRIPTION"/>
             </xsl:element>
           </xsl:element>
         </xsl:when>
         <xsl:otherwise>
           <!--  -->
           <xsl:element name="node">
             <xsl:attribute name="text">
               <xsl:value-of select="DESCRIPTION"/>
             </xsl:attribute>
           </xsl:element>
         </xsl:otherwise>
       </xsl:choose>
     </xsl:if>
   </xsl:element>
</xsl:template>


</xsl:stylesheet>
