<!DOCTYPE xsl:stylesheet SYSTEM "../../../xslt10.dtd">

<xsl:stylesheet version="1.0"
  		xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--

PKG2 - ProzessKettenGenerator second implementation 
Copyright (C) 1999-2006 by Alexander Tenbusch

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

-->

<xsl:output method="xml" encoding="ISO-8859-1"/>  

<xsl:variable name="prefix_tmp" select="'tmp'"/>
<xsl:variable name="prefix_tmpi" select="translate($prefix_tmp,'\','/')"/>

<xsl:template match="/">
  <xsl:element name="site"><xsl:text> 
</xsl:text>
<xsl:apply-templates select="//*[@ID and not(@ID = '') and NAME]"/>
<!-- RELATION fehlen noch -->
  </xsl:element>
</xsl:template>

<xsl:template match="*[@ID]">
  <xsl:element name="page">
    <xsl:element name="title">
      <xsl:value-of select="NAME"/>
    </xsl:element>
    <xsl:element name="url">
      <xsl:value-of select="@ID"/><xsl:text>.html</xsl:text>
    </xsl:element>
    <xsl:element name="text">
      <xsl:choose>
        <xsl:when test="DESCRIPTION != ''">
          <xsl:value-of select="DESCRIPTION"/>
        </xsl:when>
        <xsl:when test="NAME != ''">
          <xsl:value-of select="NAME"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="@ID"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:element>
    <xsl:element name="content">
      <xsl:value-of select="@ID"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="@FROM"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="@TO"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="NAME"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="DESCRIPTION"/>
      <xsl:apply-templates select="document(concat($prefix_tmpi,'/text_',@ID,'.pie'))/PIE/*"/>
      <xsl:for-each select="FORM">
        <xsl:text> </xsl:text>
        <xsl:value-of select="."/>
      </xsl:for-each>
      <xsl:text> </xsl:text>
      <xsl:value-of select="TOOL"/>
      <xsl:for-each select="LINK">
        <xsl:text> </xsl:text>
        <xsl:value-of select="."/>
      </xsl:for-each>
      <xsl:text> </xsl:text>
      <xsl:value-of select="LINK/@HREF"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="CHECK"/>
    </xsl:element>
    <xsl:element name="rank">
      <xsl:text>1</xsl:text>
    </xsl:element>
  </xsl:element>
  <xsl:text> 
</xsl:text>
</xsl:template>

</xsl:stylesheet>
